;;; SForms aliases
;;; nov 28 1998

;#+forms
;(require 'logical)

;;; just a macro for define
(defmacro fl:alias (aliasname defname)
  `(define ,aliasname ,defname))

;;;
; BASIC (alias)
;;;
(fl:alias FL_PLACE_FREE_CENTER  (logior FL_PLACE_CENTER FL_FREE_SIZE))
(fl:alias FL_PLACE_CENTERFREE   (logior FL_PLACE_CENTER FL_FREE_SIZE))

(fl:alias (FL_IS_UPBOX bt)   
	  (if (or (= bt FL_UP_BOX)
		  (= bt FL_OVAL3D_UPBOX)
		  (= bt FL_ROUNDED3D_UPBOX)) FL_TRUE FL_FALSE))

(fl:alias (FL_IS_DOWNBOX bt)
	  (if (or (= bt FL_DOWN_BOX)
		  (= bt FL_OVAL3D_DOWNBOX)
		  (= bt FL_ROUNDED3D_DOWNBOX)) FL_TRUE FL_FALSE))

(fl:alias (FL_TO_DOWNBOX bt)  
	  (cond ((= bt FL_UP_BOX) FL_DOWN_BOX)
		((= bt FL_ROUNDED3D_UPBOX) FL_ROUNDED3D_DOWNBOX)
		((= bt FL_OVAL3D_UPBOX) FL_OVAL3D_DOWNBOX)
		(else bt)))

(fl:alias FL_LEFT_MOUSE                 FL_MBUTTON1)
(fl:alias FL_MIDDLE_MOUSE               FL_MBUTTON2)
(fl:alias FL_RIGHT_MOUSE                FL_MBUTTON3)

(fl:alias FL_LEFTMOUSE                  FL_LEFT_MOUSE)
(fl:alias FL_MIDDLEMOUSE                FL_MIDDLE_MOUSE)
(fl:alias FL_RIGHTMOUSE                 FL_RIGHT_MOUSE)

(fl:alias FL_BUILT_IN_COLS              (+ FL_DODGERBLUE 1))
(fl:alias FL_INACTIVE_COL               FL_INACTIVE)
(fl:alias FL_DOGERBLUE                  FL_DODGERBLUE)

(fl:alias FL_GRAY16                     FL_RIGHT_BCOL)
(fl:alias FL_GRAY35                     FL_BOTTOM_BCOL)
(fl:alias FL_GRAY80                     FL_TOP_BCOL)
(fl:alias FL_GRAY90                     FL_LEFT_BCOL)
(fl:alias FL_GRAY63                     FL_COL1)
(fl:alias FL_GRAY75                     FL_MCOL)

(fl:alias FL_LCOL                       FL_BLACK)

(fl:alias FL_MOVE                       FL_MOTION) ; for compatibility 

(fl:alias FL_RESIZE_ALL                 (logior FL_RESIZE_X FL_RESIZE_Y))

(fl:alias FL_ALT_VAL                    FL_ALT_MASK)

(fl:alias FL_PUP_GRAY                   FL_PUP_GREY)
(fl:alias FL_PUP_TOGGLE                 FL_PUP_BOX)
(fl:alias FL_PUP_INACTIVE               FL_PUP_GREY)

(fl:alias (special_style a)
	  (if (and (>= a FL_SHADOW_STYLE) 
		   (<= a (+ FL_EMBOSSED_STYLE FL_MAXFONTS)) FL_TRUE FL_FALSE)))

(fl:alias FL_DEFAULT_SIZE               FL_SMALL_SIZE)

(fl:alias FL_TINY_FONT                  FL_TINY_SIZE)
(fl:alias FL_SMALL_FONT                 FL_SMALL_SIZE)
(fl:alias FL_NORMAL_FONT                FL_NORMAL_SIZE)
(fl:alias FL_MEDIUM_FONT                FL_MEDIUM_SIZE)
(fl:alias FL_LARGE_FONT                 FL_LARGE_SIZE)
(fl:alias FL_HUGE_FONT                  FL_HUGE_SIZE)

(fl:alias FL_NORMAL_FONT1               FL_SMALL_FONT)
(fl:alias FL_NORMAL_FONT2               FL_NORMAL_FONT)
(fl:alias FL_DEFAULT_FONT               FL_SMALL_FONT)

(fl:alias fl_set_object_focus           fl_set_focus_object)
(fl:alias fl_set_form_call_back         fl_set_form_callback)
(fl:alias fl_set_initial_placement      fl_set_form_geometry)
(fl:alias fl_register_call_back         fl_register_raw_callback)
(fl:alias fl_draw_object_outside_label  fl_draw_object_label_outside)
(fl:alias fl_set_object_lcolor          fl_set_object_lcol)
(fl:alias fl_compute_object_geometry    fl_get_object_bbox)
(fl:alias fl_set_object_align           fl_set_object_lalign)
(fl:alias fl_set_call_back              fl_set_object_callback)
(fl:alias fl_get_string_size            fl_get_string_dimension)

(fl:alias (fl_draw_text a x y w h c st sz s)
	  (if (= (logand a FL_ALIGN_INSIDE) FL_TRUE)
	      (fl_drw_text        a x y w h c st sz s)
	      (fl_drw_text_beside a x y w h c st sz s)))

(fl:alias fl_mapcolor_name              fl_mapcolorname)
(fl:alias fl_get_flcolor                fl_get_pixel)

; Some macros 
(fl:alias (FL_max a b) (if (> a b) a b))
(fl:alias (FL_min a b) (if (< a b) a b))
(fl:alias (FL_abs a)   (if (> a 0) a (* a -1)))
(fl:alias (FL_nint a)  (if (> a 0) (+ a 0.5) (- a 0.5)))

(fl:alias (fl_set_thinscrollbar bt)
	  (fl_set_scollbar_type (if (= bt FL_TRUE) 
				    FL_THIN_SCROLLBAR 
				    FL_NORMAL_SCROLLBAR)))

(fl:alias fl_mousebutton                fl_mouse_button)

;;;
; BITMAP (alias)
;;;
(fl:alias FL_BITMAP_BOXTYPE             FL_NO_BOX)
(fl:alias FL_BITMAP_COL1                FL_COL1)
(fl:alias FL_BITMAP_COL2                FL_COL1)
(fl:alias FL_BITMAP_LCOL                FL_LCOL)
(fl:alias FL_BITMAP_ALIGN               FL_ALIGN_BOTTOM)

(fl:alias fl_set_bitmap_datafile        fl_set_bitmap_file)

;;;
; BOX (alias)
;;;

; nil

;;;
; BROWSER (alias)
;;;
(fl:alias FL_BROWSER_BOXTYPE            FL_DOWN_BOX)
(fl:alias FL_BROWSER_COL1               FL_COL1)
(fl:alias FL_BROWSER_COL2               FL_YELLOW)
(fl:alias FL_BROWSER_LCOL               FL_LCOL)
(fl:alias FL_BROWSER_ALIGN              FL_ALIGN_BOTTOM)

(fl:alias FL_BROWSER_SLCOL              FL_COL1)
(fl:alias FL_BROWSER_FONTSIZE           FL_SMALL_FONT)

(fl:alias fl_append_browser             fl_addto_browser_chars)

;;;
; BUTTON (alias)
;;;
(fl:alias FL_BUTTON_BOXTYPE             FL_UP_BOX)
(fl:alias FL_BUTTON_COL1                FL_COL1)
(fl:alias FL_BUTTON_COL2                FL_COL1)
(fl:alias FL_BUTTON_LCOL                FL_LCOL)
(fl:alias FL_BUTTON_ALIGN               FL_ALIGN_CENTER)
(fl:alias FL_BUTTON_MCOL1               FL_MCOL)
(fl:alias FL_BUTTON_MCOL2               FL_MCOL)
(fl:alias FL_BUTTON_BW                  FL_BOUND_WIDTH)

(fl:alias FL_LIGHTBUTTON_BOXTYPE        FL_UP_BOX)
(fl:alias FL_LIGHTBUTTON_COL1           FL_COL1)
(fl:alias FL_LIGHTBUTTON_COL2           FL_YELLOW)
(fl:alias FL_LIGHTBUTTON_LCOL           FL_LCOL)
(fl:alias FL_LIGHTBUTTON_ALIGN          FL_ALIGN_CENTER)
(fl:alias FL_LIGHTBUTTON_TOPCOL         FL_COL1)
(fl:alias FL_LIGHTBUTTON_MCOL           FL_MCOL)

(fl:alias FL_ROUNDBUTTON_BOXTYPE        FL_NO_BOX)
(fl:alias FL_ROUNDBUTTON_COL1           FL_MCOL)
(fl:alias FL_ROUNDBUTTON_COL2           FL_YELLOW)
(fl:alias FL_ROUNDBUTTON_LCOL           FL_LCOL)
(fl:alias FL_ROUNDBUTTON_ALIGN          FL_ALIGN_CENTER)
(fl:alias FL_ROUNDBUTTON_TOPCOL         FL_COL1)
(fl:alias FL_ROUNDBUTTON_MCOL           FL_MCOL)

(fl:alias FL_ROUND3DBUTTON_BOXTYPE      FL_NO_BOX)
(fl:alias FL_ROUND3DBUTTON_COL1         FL_COL1)
(fl:alias FL_ROUND3DBUTTON_COL2         FL_BLACK)
(fl:alias FL_ROUND3DBUTTON_LCOL         FL_LCOL)
(fl:alias FL_ROUND3DBUTTON_ALIGN        FL_ALIGN_CENTER)
(fl:alias FL_ROUND3DBUTTON_TOPCOL       FL_COL1)
(fl:alias FL_ROUND3DBUTTON_MCOL         FL_MCOL)

(fl:alias FL_CHECKBUTTON_BOXTYPE        FL_NO_BOX)
(fl:alias FL_CHECKBUTTON_COL1           FL_COL1)
(fl:alias FL_CHECKBUTTON_COL2           FL_YELLOW)
(fl:alias FL_CHECKBUTTON_LCOL           FL_LCOL)
(fl:alias FL_CHECKBUTTON_ALIGN          FL_ALIGN_CENTER)
(fl:alias FL_CHECKBUTTON_TOPCOL         FL_COL1)
(fl:alias FL_CHECKBUTTON_MCOL           FL_MCOL)

(fl:alias FL_BITMAPBUTTON_BOXTYPE       FL_UP_BOX)
(fl:alias FL_BITMAPBUTTON_COL1          FL_COL1)
(fl:alias FL_BITMAPBUTTON_COL2          FL_BLUE)
(fl:alias FL_BITMAPBUTTON_LCOL          FL_LCOL)
(fl:alias FL_BITMAPBUTTON_ALIGN         FL_ALIGN_BOTTOM)

(fl:alias FL_PIXMAPBUTTON_BOXTYPE       FL_UP_BOX)
(fl:alias FL_PIXMAPBUTTON_COL1          FL_COL1)
(fl:alias FL_PIXMAPBUTTON_COL2          FL_YELLOW)
(fl:alias FL_PIXMAPBUTTON_LCOL          FL_LCOL)
(fl:alias FL_PIXMAPBUTTON_ALIGN         FL_ALIGN_BOTTOM)

(fl:alias fl_set_bitmapbutton_datafile  fl_set_bitmapbutton_file)

(fl:alias fl_set_pixmapbutton_data      fl_set_pixmap_data)
(fl:alias fl_set_pixmapbutton_file      fl_set_pixmap_file)
(fl:alias fl_set_pixmapbutton_pixmap    fl_set_pixmap_pixmap)
(fl:alias fl_get_pixmapbutton_pixmap    fl_get_pixmap_pixmap)
(fl:alias fl_set_pixmapbutton_align     fl_set_pixmap_align)
(fl:alias fl_free_pixmapbutton_pixmap   fl_free_pixmap_pixmap)
(fl:alias fl_set_pixmapbutton_datafile  fl_set_pixmapbutton_file)

(fl:alias fl_set_button_shortcut        fl_set_object_shortcut)

;;;
; CANVAS (alias)
;;;
(fl:alias FL_CANVAS_BOXTYPE             FL_DOWN_BOX)
(fl:alias FL_CANVAS_ALIGN               FL_ALIGN_TOP)

(fl:alias fl_set_canvas_decoration      fl_set_object_boxtype)

;;;
; CHART (alias)
;;;
(fl:alias FL_FILLED_CHART               FL_FILL_CHART)

(fl:alias FL_CHART_BOXTYPE              FL_BORDER_BOX)
(fl:alias FL_CHART_COL1                 FL_COL1)
(fl:alias FL_CHART_LCOL                 FL_LCOL)
(fl:alias FL_CHART_ALIGN                FL_ALIGN_BOTTOM)

(fl:alias fl_set_chart_lcol             fl_set_chart_lcolor)

;;;
; CHOICE (alias)
;;;
(fl:alias  FL_SIMPLE_CHOICE             FL_NORMAL_CHOICE)

(fl:alias FL_CHOICE_BOXTYPE             FL_ROUNDED_BOX)
(fl:alias FL_CHOICE_COL1                FL_COL1)
(fl:alias FL_CHOICE_COL2                FL_LCOL)
(fl:alias FL_CHOICE_LCOL                FL_LCOL)
(fl:alias FL_CHOICE_ALIGN               FL_ALIGN_LEFT)

(fl:alias FL_CHOICE_MCOL                FL_MCOL)

;;;
; CLIPBD (alias)
;;;

; nil

;;;
; CLOCK (alias)
;;;
(fl:alias FL_CLOCK_BOXTYPE              FL_UP_BOX)
(fl:alias FL_CLOCK_COL1                 FL_INACTIVE_COL)
(fl:alias FL_CLOCK_COL2                 FL_BOTTOM_BCOL)
(fl:alias FL_CLOCK_LCOL                 FL_BLACK)
(fl:alias FL_CLOCK_ALIGN                FL_ALIGN_BOTTOM)

(fl:alias FL_CLOCK_TOPCOL               FL_COL1)

;;;
; COUNTER (alias)
;;;
(fl:alias FL_COUNTER_BOXTYPE            FL_UP_BOX)
(fl:alias FL_COUNTER_COL1               FL_COL1)
(fl:alias FL_COUNTER_COL2               FL_BLUE)
(fl:alias FL_COUNTER_LCOL               FL_LCOL)
(fl:alias FL_COUNTER_ALIGN              FL_ALIGN_BOTTOM)

;;;
; CURSOR (alias)
;;;
(fl:alias (fl_reset_cursor win) 
	  (fl_set_cursor win FL_DEFAULT_CURSOR))

;;;
; DIAL (alias)
;;;
(fl:alias FL_DIAL_BOXTYPE               FL_FLAT_BOX)
(fl:alias FL_DIAL_COL1                  FL_COL1)
(fl:alias FL_DIAL_COL2                  FL_RIGHT_BCOL)
(fl:alias FL_DIAL_LCOL                  FL_LCOL)
(fl:alias FL_DIAL_ALIGN                 FL_ALIGN_BOTTOM)

(fl:alias FL_DIAL_TOPCOL                FL_COL1)

;;;
; FILESYS (alias)
;;;

; nil

;;;
; FLPS (alias)
;;;

; nil

;;;
; FOLDER (alias)
;;;
(fl:alias FL_NORMAL_TABFOLDER           FL_TOP_TABFOLDER)

;;;
; FRAME (alias)
;;;
(fl:alias FL_FRAME_COL1                 FL_BLACK)   
(fl:alias FL_FRAME_COL2                 FL_COL1)    
(fl:alias FL_FRAME_LCOL                 FL_BLACK)   

;;;
; FREE (alias)
;;;
(fl:alias FL_SLEEPING_FREE              FL_INACTIVE_FREE)

;;;
; GOODIES (alias)
;;;
(fl:alias FLAlertDismissLabel           "flAlert.dismiss.label")
(fl:alias FLAlertTitle                  "flAlert.title")

(fl:alias FLQuestionYesLabel            "flQuestion.yes.label")
(fl:alias FLQuestionNoLabel             "flQuestion.no.label")
(fl:alias FLQuestionTitle               "flQuestion.title")

(fl:alias FLOKLabel                     "flInput.ok.label")
(fl:alias FLInputClearLabel             "flInput.clear.label")
(fl:alias FLInputCancelLabel            "flInput.cancel.label")
(fl:alias FLInputTitle                  "flInput.title")

(fl:alias FLChoiceTitle                 "flChoice.title")

(fl:alias fl_set_choices_shortcut       fl_set_choice_shortcut)

(fl:alias fl_open_command               fl_exe_command)
(fl:alias fl_close_command              fl_end_command)

(fl:alias (fl_set_fselector_transient b)
	  (fl_set_fselector_border (if (= b FL_TRUE)
				       FL_TRANSIENT FL_FULLBORDER)))

(fl:alias fl_show_file_selector         fl_show_fselector)
(fl:alias fl_set_fselector_cb           fl_set_fselector_callback)
(fl:alias (fl_set_fselector_title s) 
	  (fl_set_form_title (fl_get_fselector_form) s))

;;;
; INPUT (alias)
;;;
(fl:alias FL_INPUT_BOXTYPE              FL_DOWN_BOX)
(fl:alias FL_INPUT_COL1                 FL_COL1)
(fl:alias FL_INPUT_COL2                 FL_MCOL)
(fl:alias FL_INPUT_LCOL                 FL_LCOL)
(fl:alias FL_INPUT_ALIGN                FL_ALIGN_LEFT)

(fl:alias FL_INPUT_TCOL                 FL_LCOL)
(fl:alias FL_INPUT_CCOL                 FL_BLUE)

(fl:alias fl_set_input_shortcut         fl_set_object_shortcut)

;;;
; MENU (alias)
;;;
(fl:alias FL_MENU_BOXTYPE               FL_BORDER_BOX)
(fl:alias FL_MENU_COL1                  FL_COL1)
(fl:alias FL_MENU_COL2                  FL_MCOL)
(fl:alias FL_MENU_LCOL                  FL_LCOL)
(fl:alias FL_MENU_ALIGN                 FL_ALIGN_CENTER)

;;;
; MENUBAR (alias)
;;;
(fl:alias FL_MENUBAR_BOXTYPE            FL_UP_BOX)
(fl:alias FL_MENUBAR_COL1               FL_COL1)
(fl:alias FL_MENUBAR_COL2               FL_MCOL)
(fl:alias FL_MENUBAR_LCOL               FL_LCOL)

;;;
; POPUP (alias)
;;;
(fl:alias fl_setpup_default_fontsize    fl_setpup_fontsize)
(fl:alias fl_setpup_default_fontstyle   fl_setpup_fontstyle)
(fl:alias fl_setpup_default_color       fl_setpup_color)
(fl:alias fl_setpup_default_checkcolor  fl_setpup_checkcolor)

(fl:alias fl_setpup_hotkey              fl_setpup_shortcut)

(fl:alias fl_setpup                     fl_setpup_mode)

;;;
; POSITIONER (alias)
;;;
(fl:alias FL_POSITIONER_BOXTYPE         FL_DOWN_BOX)
(fl:alias FL_POSITIONER_COL1            FL_COL1)
(fl:alias FL_POSITIONER_COL2            FL_RED)
(fl:alias FL_POSITIONER_LCOL            FL_LCOL)
(fl:alias FL_POSITIONER_ALIGN           FL_ALIGN_BOTTOM)

;;;
; SCROLLBAR (alias)
;;;
(fl:alias FL_HOR_BASIC_SCROLLBAR        FL_HOR_PLAIN_SCROLLBAR)
(fl:alias FL_VERT_BASIC_SCROLLBAR       FL_VERT_PLAIN_SCROLLBAR)

;;;
; SLIDER (alias)
;;;
(fl:alias FL_SLIDER_BW1                 FL_BOUND_WIDTH)
(fl:alias FL_SLIDER_BW2                 (- FL_BOUND_WIDTH 1))
(fl:alias FL_SLIDER_BOXTYPE             FL_DOWN_BOX)
(fl:alias FL_SLIDER_COL1                FL_COL1)
(fl:alias FL_SLIDER_COL2                FL_COL1)
(fl:alias FL_SLIDER_LCOL                FL_LCOL)
(fl:alias FL_SLIDER_ALIGN               FL_ALIGN_BOTTOM)

;;;
; TEXT (alias)
;;;
(fl:alias FL_TEXT_BOXTYPE               FL_FLAT_BOX)
(fl:alias FL_TEXT_COL1                  FL_COL1)
(fl:alias FL_TEXT_COL2                  FL_MCOL)
(fl:alias FL_TEXT_LCOL                  FL_LCOL)
(fl:alias FL_TEXT_ALIGN                 FL_ALIGN_LEFT)

;;; 
; TIMER (alias)
;;;
(fl:alias FL_TIMER_BOXTYPE              FL_DOWN_BOX)
(fl:alias FL_TIMER_COL1                 FL_COL1)
(fl:alias FL_TIMER_COL2                 FL_RED)
(fl:alias FL_TIMER_LCOL                 FL_LCOL)
(fl:alias FL_TIMER_ALIGN                FL_ALIGN_CENTER)

;;;
; XBASIC (alias)
;;;
; 
(fl:alias GrayScale                     FL_GRAYSCALE)   ; FL_GrayScale
(fl:alias GreyScale                     FL_GRAYSCALE)   ; FL_GrayScale
(fl:alias StaticGray                    FL_STATICGRAY)  ; FL_StaticGray
(fl:alias StaticGrey                    FL_STATICGRAY)  ; FL_StaticGray

(fl:alias (FL_is_gray v)
	  (if (or (= v GrayScale)
		  (= v StaticGray))
	      FL_TRUE FL_FALSE))

(fl:alias (FL_is_rgb v)   
	  (if (or (= v TrueColor)
		  (= v DirectColor))
	      FL_TRUE FL_FALSE))

(fl:alias fl_get_vclass                 fl_vmode)
(fl:alias (fl_get_form_vclass a)        (fl_vmode))

(fl:alias (fl_rectf x y w h c)   
	  (fl_rectangle 1  x y w h c))
(fl:alias (fl_rect x y w h c)    
	  (fl_rectangle 0  x y w h c))

(fl:alias (fl_roundrectf x y w h c) 
	  (fl_roundrectangle 1 x y w h c))
(fl:alias (fl_roundrect x y w h c)  
	  (fl_roundrectangle 0 x y w h c))

(fl:alias (fl_polyf p n c)  
	  (fl_polygon 1  p  n  c))
(fl:alias (fl_polyl p n c)  
	  (fl_polygon 0  p  n  c))

(fl:alias fl_simple_line                fl_line)
(fl:alias (fl_diagline x y w h c) 
	  (fl_line x y (+ x w -1) (+ y h -1) c))

(fl:alias fl_set_linewidth              fl_linewidth)
(fl:alias fl_set_linestyle              fl_linestyle)
(fl:alias fl_set_drawmode               fl_drawmode)

(fl:alias (fl_ovalf x y w h c)     
	  (fl_oval 1 x y w h c))
(fl:alias (fl_ovall x y w h c)     
	  (fl_oval 0 x y w h c))
(fl:alias fl_oval_bound                 fl_ovalbound)

(fl:alias (fl_circf x y r col)  
	  (fl_oval 1 (- x r) (- y r) (* 2 r) (* 2 r) col))
(fl:alias (fl_circ x y r col)   
	  (fl_oval 0 (- x r) (- y r) (* 2 r) (* 2 r) col))

(fl:alias (fl_arcf x y r a1 a2 c)  
	  (fl_pieslice 1 (- x r) (- y r) (* 2 r) (* 2 r)  a1 a2 c))
(fl:alias (fl_arc x y r a1 a2 c)  
	  (fl_pieslice 0 (- x r) (- y r) (* 2 r) (* 2 r)  a1 a2 c))

(fl:alias fl_bgnline                    fl_reset_vertex)
(fl:alias fl_bgnclosedline              fl_reset_vertex)
(fl:alias fl_bgnpolygon                 fl_reset_vertex)

(fl:alias fl_get_font_struct            fl_get_fontstruct)
(fl:alias fl_get_fntstruct              fl_get_font_struct)

(fl:alias fl_pref_winposition           fl_winposition)
(fl:alias fl_win_background             fl_winbackground)
(fl:alias fl_set_winstepunit            fl_winstepunit)
(fl:alias fl_pref_winsize               fl_winsize)
(fl:alias fl_pref_wingeometry           fl_wingeometry)

(fl:alias fl_get_win_size               fl_get_winsize)
(fl:alias fl_get_win_origin             fl_get_winorigin)
(fl:alias fl_get_win_geometry           fl_get_wingeometry)
(fl:alias fl_initial_winposition        fl_pref_winposition)

(fl:alias fl_get_display                fl_display)
(fl:alias (FL_FormDisplay form)         (fl_display))
(fl:alias (FL_ObjectDisplay object)     (fl_display))

(fl:alias FL_OBJECT_WID                 fl_objwin)  ; FL_ObjWin
(fl:alias fl_add_selected_xevent        fl_addto_selected_xevent)

(fl:alias fl_keypressed                 fl_keysym_pressed)

(fl:alias FL_PDButtonLabelSize          FL_PDBUTTONFONTSIZE) 
;FL_PDButtonFontSize
(fl:alias FL_PDSliderLabelSize          FL_PDSLIDERFONTSIZE)
;FL_PDSliderFontSize
(fl:alias FL_PDInputLabelSize           FL_PDINPUTFONTSIZE)
;FL_PDInputFontSize)
(fl:alias FL_PDButtonLabel              FL_PDButtonLabelSize)

(fl:alias (fl_set_text_clipping a b c d) 
	  (fl_set_gc_clipping (fl_textgc) a b c d))
(fl:alias (fl_unset_text_clipping) 
	  (fl_unset_gc_clipping (fl_textgc)))

;;;
; XYPLOT (alias)
;;;
(fl:alias FL_XYPLOT_BOXTYPE             FL_FLAT_BOX)
(fl:alias FL_XYPLOT_COL1                FL_COL1)
(fl:alias FL_XYPLOT_LCOL                FL_LCOL)
(fl:alias FL_XYPLOT_ALIGN               FL_ALIGN_BOTTOM)

(fl:alias fl_set_xyplot_datafile        fl_set_xyplot_file)
(fl:alias (fl_set_xyplot_fontsize o i)
	  (fl_set_object_fontsize o i))

(fl:alias (fl_set_xyplot_fontstyle o i)
	  (fl_set_object_fontstyle o i))

;;;
; EOF
;;;





