;/* 
; * demo showing the effect of different border widths 
; *
; * This file is part of xforms packge
; * T.C. Zhao and M. Overmars  (1997)
; *
; */

(require `forms)
(require `struct) ; SLIB

;/**** Forms and Objects ****/
(define-record s_bwform 
  (bwform
   vdata
   cdata
   ldata
   done
   bw_choice
   bwgroup
   pmobj))

;/* callbacks for form bwform */
(define (done_callback ob data)
  (fl_finish)
  (exit))

(define fd_bwform (make-s_bwform 0 0 0 0 0 0 0 0))

(define (bw_callback ob data)
  ;/* fill-in code for callback */
  (let* ((bws `(-3 -2 -1 1 2 3 4 5))
	 (bw (list-ref bws (- (fl_get_choice ob) 1))))
    
    (fl_set_object_bw (s_bwform->bwgroup fd_bwform) bw)
    ;/* since bwgroup includes the backface  it wipes out the done button*/  
    (fl_redraw_object (s_bwform->done fd_bwform))
    (fl_redraw_object (s_bwform->bw_choice fd_bwform))))

(define (borderwidth . args)
  ;/* application default. Can be overriden by the command line options */
  (fl_set_border_width -2) 
  ;
  (fl_initialize args)
  (set! fd_bwform (create_form_bwform))
  ;
  ;/* fill-in form initialization code */
  (fl_set_pixmapbutton_file (s_bwform->pmobj fd_bwform) "crab.xpm")
  ;
  (fl_addto_choice (s_bwform->bw_choice fd_bwform) 
		   "-3 Pixel|-2 Pixel|-1 Pixel");
  (fl_addto_choice (s_bwform->bw_choice fd_bwform) 
		   " 1 Pixel| 2 Pixel| 3 Pixel");
  (fl_addto_choice (s_bwform->bw_choice fd_bwform) 
		   " 4 Pixel| 5 Pixel");
  (fl_set_choice_text (s_bwform->bw_choice fd_bwform)  
		      "-2 Pixel");
  ;
  ;/* show the first form */
  (fl_show_form (s_bwform->bwform fd_bwform) 
		FL_PLACE_CENTER FL_TRANSIENT "bwform")
  (letrec ((loop 
	    (lambda() 
	      (if (not (equal? (fl_do_forms) 0))
		  (loop)))))
    (loop))
  0)

;/* Form definition file generated with fdesign. */
(define (create_form_bwform)
  (let ((obj `())
	(fdui (make-s_bwform 0 0 0 0 0 0 0 0)))
    (set-s_bwform-bwform! fdui (fl_bgn_form FL_NO_BOX  380  340))

    (set-s_bwform-bwgroup! fdui (fl_bgn_group))
    (set! obj (fl_add_box FL_UP_BOX 0 0 380 340 ""))
    (set! obj (fl_add_frame FL_EMBOSSED_FRAME 220 60 135 145 ""))
    (set! obj (fl_add_frame FL_ENGRAVED_FRAME 15 60 185 145 ""))
    (set! obj (fl_add_slider FL_HOR_SLIDER 25 70 160 20 ""))
    (set! obj (fl_add_valslider FL_HOR_BROWSER_SLIDER 25 105 160 20 ""))
    (set! obj (fl_add_scrollbar FL_HOR_THIN_SCROLLBAR 25 140 160 20 ""))
    (fl_set_scrollbar_size obj  0.2)
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 25 175 160 20 ""))
    (set! obj (fl_add_pixmapbutton FL_NORMAL_BUTTON 305 145 40 35 ""))
    (set-s_bwform-pmobj! fdui obj)
    (set! obj (fl_add_positioner FL_NORMAL_POSITIONER 30 225 100 80 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 230 65 100 28 "Button"))
    (set! obj (fl_add_lightbutton FL_PUSH_BUTTON 230 98 100 28 "LightButton"))
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 230 128 80 32 "Button"))
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 230 152 80 32 "Button"))
    (fl_set_object_color obj FL_COL1  FL_BLUE)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 230 175 80 32 "Button"))
    (set! obj (fl_add_input FL_NORMAL_INPUT 195 240 160 28 "Input"))
    (set! obj (fl_add_choice FL_NORMAL_CHOICE2 105 20 80 28 
			     "Border Width"))
    (set-s_bwform-bw_choice! fdui obj)
    (fl_set_object_callback obj bw_callback 0)
    (fl_end_group)

    (set! obj (fl_add_button FL_NORMAL_BUTTON 270 290 75 30 "Done"))
    (set-s_bwform-done! fdui obj)
    (fl_set_object_callback obj done_callback 0)
    (fl_end_form)
;    (set-s_bwform-fdui! fdui fdui)
    fdui))


; call
(borderwidth)











