;/* 
; *  This is a demo that shows the different types of browsers. 
; *
; *  This file is part of xforms package
; *  M. Overmars and T.C. Zhao  (1997)
; */

(require `forms)

(define form `())
(define br `())
(define exitobj `())
(define readout `())

(define (browserall . args)
  (fl_initialize args)
  (create_form)
  (fill_browsers)
  (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "All Browsers")
  (fl_do_forms)
  (fl_hide_form form)
  0)

(define bnames 
  (list 
   "NORMAL_BROWSER"
   "SELECT_BROWSER"
   "HOLD_BROWSER"
   "MULTI_BROWSER"))

(define (deselect obj arg)
  (map (lambda (b) 
	 (fl_deselect_browser b))
       br))

(define (set_size obj arg)
  (map (lambda (b) 
	 (fl_set_browser_fontsize b arg))
       br))

(define (set_style obj arg)
  (map (lambda (b) 
	 (fl_set_browser_fontstyle b arg))
       br))

(define (br_callback ob arg)
  (let* ((b (fl_mouse_button))
	 (mb (list "" "left" "middle" "right"))
	 (buf "")
	 (i (fl_get_browser ob)))
    (if (< b FL_SHORTCUT)
	(set! buf
	      (string-append 
	       "In " (list-ref bnames arg) 
	       " [" (list-ref mb b) "]"))
	(set! buf 
	      (string-append 
	       "In " (list-ref bnames arg))))
    (set! buf (string-append buf 
			     (fl_get_browser_line ob 
						  (if (> i 0) i (* i -1)))))
    (set! buf (string-append buf
			     (if (> i 0)
				 " was selected"
				 " was deselected.")))
    (fl_set_object_label readout buf)))

(define (create_form)
  (let ((obj `()))
    (set! form (fl_bgn_form FL_UP_BOX 700 570))
    (set! readout (fl_add_text FL_NORMAL_TEXT 50 30 600 50 ""))
    (fl_set_object_lsize readout FL_LARGE_SIZE)
    (fl_set_object_lalign readout FL_ALIGN_CENTER)
    (fl_set_object_lstyle readout FL_BOLD_STYLE)
    (fl_set_object_boxtype readout FL_UP_BOX)
    (fl_set_object_color readout FL_MAGENTA FL_MAGENTA)
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 20 120 150 290 
			      (list-ref bnames 0)))
    (set! br (append br (list obj)))
    (fl_set_object_callback obj  br_callback  0)
    (set! obj (fl_add_browser FL_SELECT_BROWSER 190 120 150 290 
			      (list-ref bnames 1)))
    (set! br (append br (list obj)))
    (fl_set_object_callback obj  br_callback  1)
    (set! obj (fl_add_browser FL_HOLD_BROWSER 360 120 150 290 
			      (list-ref bnames 2)))
    (set! br (append br (list obj)))
    (fl_set_object_color obj FL_COL1 FL_GREEN);
    (fl_set_object_callback obj  br_callback  2);
    (set! obj (fl_add_browser FL_MULTI_BROWSER 530 120 150 290 
			      (list-ref bnames 3)))
    (set! br (append br (list obj)))
    (fl_set_object_color (list-ref br 3) FL_COL1 FL_CYAN)
    (fl_set_object_callback obj  br_callback  3)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 560 510 120 30 "Exit"))
    (set! exitobj obj)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 560 460 120 30 "Deselect"))
    (fl_set_object_callback obj deselect 0)

    (fl_bgn_group)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 20 500 100 30 "Tiny"))
    (fl_set_object_lsize obj FL_TINY_SIZE)
    (fl_set_object_callback obj set_size FL_TINY_SIZE) ;obj->lsize
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 130 500 100 30 "Small"))
    (fl_set_object_lsize obj FL_SMALL_SIZE)
    (fl_set_object_callback obj set_size FL_SMALL_SIZE) ;obj->lsize
    (fl_set_button obj 1)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 240 500 100 30 "Normal"))
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_callback obj set_size FL_NORMAL_BUTTON) ;obj->lsize
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 350 500 100 30 "Large"))
    (fl_set_object_lsize obj FL_LARGE_SIZE);
    (fl_set_object_callback obj set_size FL_LARGE_SIZE) ;obj->lsize
    (fl_end_group)

    (fl_bgn_group)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 20 450 100 30 "Normal"))
    (fl_set_object_callback obj set_style FL_NORMAL_STYLE)
    (fl_set_button obj 1)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 120 450 100 30 "Bold"))
    (fl_set_object_callback obj set_style FL_BOLD_STYLE)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 220 450 100 30 "Italic"))
    (fl_set_object_callback obj set_style FL_ITALIC_STYLE)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 320 450 100 30 "BoldItalic"))
    (fl_set_object_callback obj set_style FL_BOLDITALIC_STYLE)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 420 450 100 30 "Fixed"))
    (fl_set_object_callback obj set_style FL_FIXED_STYLE)
    (fl_end_group)
    (fl_end_form)))



(define (fill_browsers)
  (let ((j 1)
	(buf ""))
    (letrec ((loop_j
	      (lambda (j b)
		(cond ((= j 5)
		       (set! buf 
			     (string-append "@NLine with qb " 
					    (number->string j))))
		      ((= j 10)
		       (set! buf 
			     "@-trailing text should be ignored"))
		      ((= j 40)
		       (set! buf 
			     (string-append "@mLine with qb " 
					    (number->string j))))
		      (else
		       (set! buf 
			     (string-append "Line with qb " 
					    (number->string j)))))
		(fl_add_browser_line b buf)
		(if (<= j 100)
		    (loop_j (+ j 1) b)))))
      (map (lambda (b)
	     (set! j 1)
	     (loop_j j b))
	   br))))


(browserall)

