;/*
; * All button classes
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars (1997)
; */

(require `forms)
; "fd/buttons_gui.h"   ;/* from fd/ directory */

;/* callbacks for form buttform */
(define (done_cb ob data)
  (fl_finish)
  (exit 0))

(define (bw_cb ob data)
  (let ((bws `(-4 -3 -2 -1 1 2 3 4))
	(n (- (fl_get_choice ob) 1))
	(fdui fdui_buttform))
    (fl_freeze_form fdui)
    (fl_set_object_bw fdui_backface (list-ref bws n))
    (fl_set_object_bw fdui_objsgroup (list-ref bws n))
    ;/* redrawing the backface wipes out the done button. Redraw it*/
    (fl_redraw_object fdui_done)
    (fl_unfreeze_form fdui)))

(define (buttonall . args)
  (fl_initialize args)
  (set! fdui_buttform (create_form_buttform))
  ;/* fill-in form initialization code */
  (fl_set_pixmapbutton_file fdui_pbutt "crab45.xpm")
  (fl_set_bitmapbutton_file fdui_bbutt "bm1.xbm")
  (fl_addto_choice fdui_bw_obj 
		   " -4 | -3 | -2 | -1 |  1|  2|  3|  4")
  (fl_set_choice fdui_bw_obj 7)
  ;
  ;/* show the first form */
  (fl_show_form fdui_buttform
		FL_PLACE_CENTER FL_FULLBORDER "buttform");
  (letrec ((loop 
	    (lambda ()
	      (fl_do_forms)
	      (loop))))
    (loop))
  0)

;/* Form definition file generated with fdesign. */
(define fdui_buttform '())
(define fdui_backface '())
(define fdui_done '())
(define fdui_objsgroup '())
(define fdui_buttform '())
(define fdui_bbutt '())
(define fdui_pbutt '())
(define fdui_bw_obj '())

(define (create_form_buttform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  290  260))
    (set! obj (fl_add_box FL_UP_BOX 0 0 290 260 ""))
    (set! fdui_backface obj)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 185 215 90 30 "Done"))
    (set! fdui_done obj)  
    (fl_set_object_callback obj done_cb 0)
    ;
    (set! fdui_objsgroup (fl_bgn_group))
    (set! obj (fl_add_frame FL_ENGRAVED_FRAME 175 170 100 30 ""))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 210 170 30 30 ""))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_bitmapbutton FL_NORMAL_BUTTON 25 85 40 40 
				   "bitmapbutton"))
    (set! fdui_bbutt obj)
    (fl_set_object_color obj FL_COL1 FL_BLACK)
    (set! obj (fl_add_pixmapbutton FL_NORMAL_BUTTON 25 25 40 40 
				   "pixmapbutton"))
    (set! fdui_pbutt obj)  
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 100 31 70 32 "Red"))
    (fl_set_object_color obj FL_COL1 FL_RED)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 100 60 70 32 "Green"))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 100 90 70 32 "Blue"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_lightbutton FL_PUSH_BUTTON 20 170 92 30 "LightButton"))
    (fl_set_button obj  1)
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 200 35 75 25 "Red"))
    (fl_set_object_color obj FL_COL1 FL_RED)
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 200 64 75 25 "Green"))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 200 93 75 25 "Blue"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 180 170 30 30 ""))
    (fl_set_object_color obj FL_COL1 FL_RED)
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 240 170 30 30 ""))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_button FL_PUSH_BUTTON 130 210 30 30 "go"))
    (fl_set_object_boxtype obj FL_OVAL3D_UPBOX)
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 210 90 30 "Button"))
    (fl_set_object_boxtype obj FL_ROUNDED3D_UPBOX)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE2 105 135 80 30 "BW"))
    (set! fdui_bw_obj obj)
    (fl_set_object_callback obj bw_cb 0)
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 190 25 85 100 
				 "RoundButton"))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 90 25 90 100 
				 "CheckButton"))
    (fl_end_group)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(buttonall)
