;/* 
; * A demo of a moving chart 
; *
; *  This file is part of xforms package
; *  M. Overmars and T.C. Zhao   (1997)
; */

(require 'forms)

(define func 1)
(define x 0.0)
(define step 0.15)

(define form `())

(define chartobj `())
(define sinobj `())
(define exitbut `())
(define stepobj `())

(define (set_function obj arg)
  (set! func arg)
  (fl_clear_chart chartobj)
  (set! x 0.0))

(define (set_step obj arg)
  (set! step (fl_get_slider_value stepobj)))

;/*************************************************/
;
;/************************************/

(define (next_step)
  (let ((res 0.0))
    (cond ((= func 1)
	   (set! res (sin x)))
	  ((= func 2)
	   (set! res (* (sin (* 2 x)) (cos x))))
	  ((= func 3)
	   (set! res (+ (sin (* 2 x)) (cos x))))
	  ((= func 4)
	   (set! res (+ (sin (* 3 x)) (cos x))))
	  ((= func 5)
	   (set! res (+ (* (sin x) (sin x)) (cos x))))
	  ;(= func 6)
	  (else
	   (set! res (* (sin x) (sin x) (sin x)))))
    (set! x (+ x step))
    res))

(define (idle_cb xev d)
  (display (next_step))
  (newline)
  (fl_insert_chart_value chartobj 1 (next_step) "" 1)
  0)

(define (add_value xev a)
  (fl_insert_chart_value chartobj 1 (next_step) "" 1))

;*************************************************

(define (create_form_form)
  (let ((obj `()))
    (set! form (fl_bgn_form fl_no_box 490 320))
    (set! obj (fl_add_box fl_border_box 0 0 490 320 ""))
    (set! obj (fl_add_chart fl_line_chart 20 160 390 140 ""))
    (set! chartobj obj)
    (fl_set_object_dblbuffer obj 1)
    ;
    (fl_bgn_group)
    (set! obj (fl_add_lightbutton fl_radio_button 30 120 170 30 "sin(x)"))
    (set! sinobj obj)
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 1)
    (set! obj (fl_add_lightbutton fl_radio_button 30 90 170 30 
				  "sin(2x)*cos(x)"))
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 2)
    (set! obj (fl_add_lightbutton fl_radio_button 30 60 170 30 
				  "sin(2x)+cos(x)"))
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 3)
    (set! obj (fl_add_lightbutton fl_radio_button 240 120 160 30 
				  "(sin 3x)+(cos x)"))
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 4)
    (set! obj (fl_add_lightbutton fl_radio_button 240 90 160 30 
				  "sin(x)^2+cos(x)"))
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 5)
    (set! obj (fl_add_lightbutton fl_radio_button 240 60 160 30 
				  "sin(x)^3"))
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_function 6)
    (fl_end_group)
    ;
    (set! obj (fl_add_button fl_normal_button 150 20 140 30 "Exit"))
    (set! exitbut obj)
    (fl_set_object_boxtype obj fl_border_box)
    (set! obj (fl_add_valslider fl_vert_slider 430 20 40 280 ""))
    (set! stepobj obj)
    (fl_set_object_boxtype obj fl_border_box)
    (fl_set_object_callback obj set_step 0)
    (fl_end_form)))

;************************************

(define (chartstrip . args)
  (let ((obj `()))
    ;(fl_flip_yorigin)
    (fl_initialize args)
    (create_form_form)
    (fl_set_chart_bounds chartobj -1.5 1.5)
    (fl_set_chart_maxnumb chartobj 80)
    (fl_set_chart_autosize chartobj 0)
    (fl_set_button sinobj 1)
    (fl_set_slider_value stepobj 0.15)
    (fl_set_slider_bounds stepobj 0.0 0.4)
    ;
    (fl_show_form form fl_place_center fl_fullborder "StripChart")
    ;(fl_show_form form fl_place_center fl_noborder "StripChart")
    (letrec ((loop
	      (lambda ()
		(fl_insert_chart_value chartobj 1 (next_step) "" 1)
		(if (not (equal? (fl_check_forms) exitbut))
		    (loop)))))
      (loop)
      (fl_finish)
  0)))

(chartstrip)



