;/*
; *  This demo shows the use of choice objects.  
; *  
; *  This file is part of xforms package
; *  M. Overmars and T.C. Zhao    (1997)
; */

(require 'forms)

(define form 0)
(define sexobj 0)
(define childobj 0)
(define licenceobj 0)
(define marriedobj 0)
(define readyobj 0)

(define (cb ob data)
  (display "CallBack: ")
  (display (fl_get_choice ob))
  (newline))

(define (create_form)
  (set! form (fl_bgn_form FL_NO_BOX 420 360))
  (fl_add_box FL_UP_BOX 0 0 420 360 "")
  (fl_add_input FL_NORMAL_INPUT 70 300 320 30 "Name")
  (fl_add_input FL_NORMAL_INPUT 70 260 320 30 "Address")
  (fl_add_input FL_NORMAL_INPUT 70 220 320 30 "City")
  (fl_add_input FL_NORMAL_INPUT 70 180 320 30 "Country")
  (set! sexobj (fl_add_choice FL_NORMAL_CHOICE 70 130 110 30 "Sex"))
  (set! childobj (fl_add_choice FL_NORMAL_CHOICE2 280 130 110 30 "Children"))
  (set! licenceobj (fl_add_choice FL_NORMAL_CHOICE 280 80 110 30 "Licence"))
  (set! marriedobj (fl_add_choice FL_DROPLIST_CHOICE 70 80 110 30 "Married"))
  (fl_set_object_callback marriedobj cb 0)
  (fl_set_object_boxtype marriedobj FL_UP_BOX)
  (set! readyobj (fl_add_button FL_NORMAL_BUTTON 150 20 140 30 "Ready"))
  (fl_end_form))

(define (choice . args)
  (fl_flip_yorigin) 
  (fl_initialize args)
  (create_form)
  (fl_addto_choice sexobj "Male")
  (fl_addto_choice sexobj "Female")
  (fl_addto_choice childobj "Zero|One|Two|Three|Many")
  (fl_addto_choice licenceobj "Yes")
  (fl_addto_choice licenceobj "No")
  (fl_addto_choice marriedobj "Yes")
  (fl_addto_choice marriedobj "No")
  (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "ChoiceDemo")
  (letrec 
      ((loop
	(lambda ()
	  (if (not (equal? (fl_do_forms) readyobj))
	      (loop)))))
    (loop))
  (fl_hide_form form)
  #t)

(choice)


