;/* 
; * This is an example of the use of counters.
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars 
; */

(require `forms)

(define form `())
(define result `())
(define co `())

(define (color_change ob data)
  (let ((r (inexact->exact ; JL : to return integer
	    (fl_get_counter_value (list-ref co 0))))
	(g (inexact->exact ; JL : to return integer
	    (fl_get_counter_value (list-ref co 1))))
	(b (inexact->exact ; JL : to return integer
	    (fl_get_counter_value (list-ref co 2)))))
    ;
    (fl_mapcolor FL_FREE_COL1 r g b)
    (fl_redraw_object result)))
    

(define (create_form_form)
  (let ((obj `()))
    (set! form (fl_bgn_form FL_NO_BOX 480 200))
    (set! obj (fl_add_box FL_UP_BOX 0 0 480 200 ""))
    (set! obj (fl_add_box FL_DOWN_BOX 310 20 150 160 ""))
    (set! result obj)
    (fl_set_object_dblbuffer result  1)
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 20 20 270 30 ""))
    (set! co (append co (list obj)))
    (fl_set_object_color obj FL_INDIANRED FL_RED)
    (fl_set_object_callback obj color_change 0)
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 20 60 270 30 ""))
    (set! co (append co (list obj)))
    (fl_set_object_color obj FL_PALEGREEN FL_GREEN)
    (fl_set_object_callback obj color_change 0)
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 20 100 270 30 ""))
    (set! co (append co (list obj)))
    (fl_set_object_color obj FL_SLATEBLUE FL_BLUE)
    (fl_set_object_callback obj color_change 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 100 150 110 30 "Exit"))
    (fl_end_form)))

(define (counter . args)
  (fl_initialize args)
  (create_form_form)
  (fl_set_object_color result FL_FREE_COL1 FL_FREE_COL1)
  (map (lambda (co_i)
	 (fl_set_counter_bounds co_i 0.0 255.0)
	 (fl_set_counter_step co_i 1.0 10.0)
	 (fl_set_counter_precision co_i 0)
	 (fl_set_counter_return co_i 1))
       CO)
  (fl_call_object_callback (list-ref co 0))
  (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "Counter")
  (fl_do_forms)
  (fl_finish) ; JL : added
  0)


(counter)
