;/* 
; * Cursor routines demo.
; *
; * This file is part of xforms package
; * T.C. Zhao and M. Overmars   (1997)
; *
; */

;#include "bm1.xbm"
;#include "bm2.xbm"

; JL : added
(define (bits2string bits)
  (if (null? bits)
      ""
      (string-append 
       (make-string 1 (integer->char (car bits)))
       (bits2string (cdr bits)))))

(define bm1_width 16)
(define bm1_height 16)
(define bm1_bits 
  (bits2string 
   `(
    #x00 #x00 #x00 #x57 #x7c #x72 #xc4 #x52 #xc4 #x00 #x44 #x01
	 #x44 #x1f #xfc #x22 #x40 #x42 #x40 #x44 #x40 #x43 #xc0 #x40
	 #x70 #x40 #x8c #x20 #x00 #x1f #x00 #x00
	 )))

(define bm2_width 16)
(define bm2_height 16)
(define bm2_bits 
  (bits2string
   '(
     #x00 #x00 #x00 #x57 #x7c #x72 #xfc #x52 #xfc #x00 #x7c #x01
	   #x7c #x1f #xfc #x22 #x40 #x42 #x40 #x44 #x40 #x43 #xc0 #x40
	   #x70 #x40 #x8c #x20 #x00 #x1f #x00 #x00
	   )))
;;;

(define animated 0)
(define bitmapcur #f)

(define XC_watch 150) ; JL added 
(define XC_hand2 60) ; JL added

;/* callbacks for form cursor */
(define (setcursor_cb ob data)
  (fl_set_cursor (fl_objwin ob) data))

(define (setbitmapcursor_cb ob data)
  (if (not bitmapcur)
      (set! bitmapcur 
	    (fl_create_bitmap_cursor bm1_bits bm2_bits 
				     bm1_width bm1_height
				     (/ bm1_width 2) (/ bm1_height 2))))
  (fl_set_cursor (fl_objwin ob) bitmapcur))

(define (setanimatedcursor_cb ob data)
  (fl_set_cursor (fl_objwin ob) animated))

(define (done_cb ob data)
  (fl_finish)
  (exit 0))

(define curs '(1 2 3 4 5 6 7 8 9 10 11 12 13 -1))

(define (cursor . args)
  (let ((fd_cursor 0))
    (fl_set_border_width -2)
    (fl_initialize args)
    (set! fd_cursor (create_form_cursor))
    ;/* fill-in form initialization code */
    (fl_set_cursor_color XC_watch FL_BLACK FL_RED) 
    (set! animated (fl_create_animated_cursor curs 100))
    ;
    (fl_show_form fd_cursor FL_PLACE_CENTER FL_FULLBORDER "cursor")
    (fl_do_forms)
    0))

(define (create_form_cursor)
  (let ((obj '())
	(fdui '()))
    (set! fdui (fl_bgn_form FL_NO_BOX 325 175))
    (set! obj (fl_add_box FL_UP_BOX 0 0 325 175 ""))
    (set! obj (fl_add_frame FL_EMBOSSED_FRAME 10 10 305 120 ""))
    ;
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 20 50 25 "Hand"))
    (fl_set_object_callback obj setcursor_cb XC_hand2)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 70 20 50 25 "Watch"))
    (fl_set_object_callback obj setcursor_cb XC_watch)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 120 20 60 25 "Invisible"))
    (fl_set_object_callback obj setcursor_cb FL_INVISIBLE_CURSOR);
    (set! obj (fl_add_button FL_NORMAL_BUTTON 180 20 62 25 "Animated"))
    (fl_set_object_callback obj setanimatedcursor_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 242 20 62 25 "BitmapCur"))
    (fl_set_object_callback obj setbitmapcursor_cb 0)
    ;
    (set! obj (fl_add_button FL_NORMAL_BUTTON 90 70 140 50 "DefaultCursor"))
    (fl_set_button_shortcut obj "Dd#d" 1)
    (fl_set_object_callback obj setcursor_cb FL_DEFAULT_CURSOR)
    ;
    (set! obj (fl_add_button FL_NORMAL_BUTTON 250 140 60 25 "Done"))
    (fl_set_object_callback obj done_cb 0)
    (fl_end_form)
    (fl_adjust_form_size fdui)
    fdui))

;/*---------------------------------------*/

(cursor)