;/* This demo shows the use of a slider. Every time the slider changes
;   position it is returned by do_forms() and the text field showing its
;   value is adapted.
;*/

(require `forms)

(define (slider_cb ob data)
(let* ((astr (number->string (fl_get_slider_value ob)))
       (str (if (< (string-length astr) 10)
		 astr
		 (substring astr 0 10))))
    (fl_set_object_label data str)))

(define (demo05 . args)
  (let ((form `())
	(slider `())
	(value 0))
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 240 400))
    (set! value (fl_add_box FL_DOWN_BOX 120 180 100 30 ""))
    (fl_set_object_lalign value FL_ALIGN_CENTER)
    (set! slider (fl_add_slider FL_VERT_SLIDER 40 40 60 320 ""))
    (fl_set_slider_bounds slider -1 1)
    (fl_set_slider_value slider 0)
    (fl_set_object_color slider FL_SLIDER_COL1 FL_GREEN)
    (fl_set_object_callback slider slider_cb 0) ; value)
    (fl_add_button FL_RETURN_BUTTON 120 290 100 30 "Exit")
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Slider")
    (fl_do_forms)
    (fl_finish) ; JL : added
    0))

(demo05)
