;/*
; * test of fl_get_dirlist() and its kin.
; *
; * This file is part of xforms package
; * T.C. Zhao and M. Overmars (1997)
; */

(require 'forms)
(require 'posix-time)

; JL : "fbtest_gui.h"

;/**** Forms and Objects ****/

(define (fill_browser ob)
  (let ((dl (fl_get_dirlist "." "*" 0)))
    (fl_freeze_form fd_fbform)
    (fl_set_object_label fd_fbform_total
			 (string-append "Total " 
					(number->string (length dl))
					" files"))
    (fl_clear_browser fd_fbform_browser)
    (map (lambda (ds)
	   (let* ((dl_name (car ds))
		  (dl_size (cadddr ds))
		  (dl_mtime (caddr ds))
		  (s_name  dl_name)
		  (s_size (number->string (inexact->exact
					   (/ dl_size 1024))))
		  (s_mtime (asctime (gmtime dl_mtime)))
		  (buf ; JL : ugly formatting
		   (string-append 
		    (substring
		     (string-append dl_name
				    (make-string 10 #\space))
		     0 10)
		    "\t\t"
		    (string-append (make-string 
				    (- 5 (string-length s_size))
				    #\space)
				    s_size)
		    "K\t"
		    (substring s_mtime 3 (string-length s_mtime)))))
	     ;(display buf)
	     (fl_addto_browser_chars 
	      fd_fbform_browser
	      buf)
	     ))
	 dl)
    (fl_unfreeze_form fd_fbform)
    (fl_free_dirlist dl)))


;/* callbacks and freeobj handles for form fbform */
(define (sort_method_cb ob data)
  (fl_set_dirlist_sort data)
  (fill_browser ob))

(define (done_cb ob data)
  (fl_finish)
  (exit 0))

(define (dirlist . args)
  ;
  (fl_initialize args)
  (set! fd_fbform (create_form_fbform))
  (fl_set_browser_fontstyle fd_fbform_browser FL_FIXED_STYLE)
  ;/* fill-in form initialization code */
  (fill_browser fd_fbform_browser)
  ;
  ;/* show the first form */
  (fl_show_form fd_fbform
		FL_PLACE_CENTERFREE FL_FULLBORDER "fbform")
  (fl_do_forms)
  0)

;#include "fbtest_gui.c"
;/* Form definition file generated with fdesign. */

(define fd_fbform '())
(define fd_fbform_browser '())
(define fd_fbform_total '())

(define (create_form_fbform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  371  361))
    (set! obj (fl_add_box FL_UP_BOX 0 0 371 361 ""))
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 20 50 240 290 ""))
    (set! fd_fbform_browser obj)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 270 50 70 25 "AlphaSort"))
    (fl_set_object_callback obj sort_method_cb FL_ALPHASORT)
    (fl_set_button obj  1)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 270 85 70 25 "SizeSort"))
    (fl_set_object_callback obj sort_method_cb FL_SIZESORT)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 270 120 70 25 "TimeSort"))
    (fl_set_object_callback obj sort_method_cb FL_MTIMESORT)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 275 310 75 25 "Done"))
    (fl_set_object_callback obj done_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 10 15 220 30 ""))
    (set! fd_fbform_total obj)
    (fl_set_object_boxtype obj FL_NO_BOX)
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (fl_end_form)
    form))

;/*---------------------------------------*/

(dirlist)




