;/*
; * This demo shows the use of a browser and a file selector.
; * Good browser/scrollbar test
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars
; *
; */

(require `forms)


(define form `())
(define vdata `())
(define cdata `())
(define ldata `())
(define br `())
(define br_visible #t)

(define (load_file ob arg)
  (let ((fdui form)
	(fname (fl_show_file_selector "File To Load" "" "*" "")))
    (if (not (string-null? fname))
	(if (not (fl_load_browser br fname)) 
	    (fl_add_browser_line br "NO SUCH FILE!")))))

(define (set_size ob arg)
  (fl_set_browser_fontsize br arg))

(define (exit_program ob data)
  (exit 0))

(define (hide_show ob data)
  (let ((fdui form))
    (if br_visible
	(fl_hide_object br)
	(fl_show_object br))
    (set! br_visible (not br_visible))))

(define (create_form)
  (let ((obj `())
	(x 20)
	(dx 80)
	(dy 28))
    ;
    (set! form (fl_bgn_form FL_NO_BOX 590 610))
    (set! obj (fl_add_box FL_UP_BOX 0 0 590 610 ""))
    ;
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 20 20 550 530 ""))
    (set! br  obj)
    ;/*  (fl_set_object_boxtype obj FL_EMBOSSED_BOX) */
    (set! obj (fl_add_button FL_NORMAL_BUTTON x 565 (- dx 5) dy "Load"))
    (fl_set_object_callback obj load_file 0)
    (set! x (+ x dx))
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON x 565 dx dy "Tiny"))
    (fl_set_object_callback obj set_size FL_TINY_SIZE)
    (set! x (+ x dx))
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON x  565 dx dy "Small"))
    (fl_set_object_callback obj set_size FL_SMALL_SIZE)
    (fl_set_button obj  FL_SMALL_SIZE); == FL_BROWSER_FONTSIZE
    (set! x (+ x dx))
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON x  565 dx dy "Normal"))
    (fl_set_object_callback obj set_size FL_NORMAL_SIZE)
    (fl_set_button obj  FL_NORMAL_SIZE); == FL_BROWSER_FONTSIZE
    (set! x (+ x dx))
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON x  565 dx dy "Large"))
    (fl_set_object_callback obj set_size FL_LARGE_SIZE)
    (set! x (+ x dx 4))
    (set! obj (fl_add_button FL_NORMAL_BUTTON x 565 dx dy "Hide/Show"))
    (fl_set_object_callback obj  hide_show  0)
    (set! x (+ x dx 5))
    (set! obj (fl_add_button FL_NORMAL_BUTTON x 565 60 dy "Exit"))
    (fl_set_object_callback obj  exit_program  0)
    (fl_end_form)
    ;
    (fl_adjust_form_size form)
    form))

(define (fbrowse . args)
  (let ((fdui `()))
    (fl_initialize args)
    ;
    (set! fdui (create_form))
    ;
    (fl_clear_browser br)
    (fl_add_browser_line br "LOAD A FILE.")
    (fl_set_browser_fontstyle br FL_FIXED_STYLE)
    ;
    (fl_show_form fdui 
		  FL_PLACE_FREE FL_FULLBORDER "Browser")
    ;
    (fl_do_forms)
    ;
    (fl_hide_form form)
    (fl_free_form form)
    ;
    (fl_finish)
    0))

(fbrowse)

