;/* This is an example of the use of filled dials, dial range
; * and dial direction.
; *
; *  T.C. Zhao and M. Overmars
; */

(require `forms)

(define form `())
(define button `())
(define red `())
(define green `())
(define blue `())
(define redtext `())
(define greentext `())
(define bluetext `())
(define result `())

(define (makeform)
  (set! form (fl_bgn_form FL_UP_BOX 300 330))
  (set! button (fl_add_button FL_NORMAL_BUTTON 45 15 210 45 "A Color Editor"))
  (fl_set_object_lsize button FL_LARGE_SIZE)
  ;
  (set! red (fl_add_dial FL_FILL_DIAL 30 240 60 60 "Red"))
  (fl_set_dial_bounds red 0.0 255.0)
  (fl_set_dial_value red 128.0)
  (fl_set_object_color red FL_DIAL_COL1  FL_RED)
  (set! redtext (fl_add_box FL_DOWN_BOX 105 255 50 25 ""))
  ;
  (set! green (fl_add_dial FL_FILL_DIAL 30 155 60 60 "Green"))
  (fl_set_dial_bounds green 0.0 255.0)
  (fl_set_dial_value green 128.0)
  (fl_set_dial_angles green  45.  (- 360 45.))
  (fl_set_object_color green FL_DIAL_COL1  FL_GREEN)
  (set! greentext (fl_add_box FL_DOWN_BOX 105 170 50 25 ""))
  ;
  (set! blue (fl_add_dial FL_FILL_DIAL 30 70 60 60 "Blue"))
  (fl_set_dial_bounds blue 0.0 255.0)
  (fl_set_dial_value blue 128.0)
  (fl_set_object_color blue FL_DIAL_COL1 FL_BLUE)
  (fl_set_dial_direction blue  FL_DIAL_CCW)
  (set! bluetext (fl_add_box FL_DOWN_BOX 105 90 50 25 ""))
  ;
  (set! result (fl_add_box FL_DOWN_BOX 180 70 90 245 ""))
  (fl_set_object_color result FL_FREE_COL1 FL_FREE_COL1)
  (fl_set_object_dblbuffer result 1);
  (fl_end_form))

(define (fdial . args)
  (let ((r 0)
	(g 0)
	(b 0)
	(str ""))
    (fl_initialize args)
    (makeform)
    ;
    (fl_show_form form FL_PLACE_MOUSE FL_TRANSIENT "A Form")
    (letrec ((loop
	      (lambda ()
		(set! r (inexact->exact  ; JL : to return integer !
			 (fl_get_dial_value red)))
		(set! g (inexact->exact  ; JL : to return integer !
			 (fl_get_dial_value green)))
		(set! b (inexact->exact  ; JL : to return integer !
			 (fl_get_dial_value blue)))
		(fl_mapcolor FL_FREE_COL1 r g b)
		(fl_redraw_object result)
		(set! str (number->string r))
		(fl_set_object_label redtext str)
		(set! str (number->string g))
		(fl_set_object_label greentext str)
		(set! str (number->string b))
		(fl_set_object_label bluetext str)
		(if (not (equal? (fl_do_forms) button))
		    (loop)))))
      (loop)
      ;
      (fl_hide_form form)
      (fl_finish)
      0)))

(fdial)
