;/*
; * Tabbed folder demo and tester
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars
; *
; */

(require 'forms)

;/* callback routines */
(define (hide_show_cb ob data)
  (if (= data fl_true)
      (fl_show_object fdui_folder)
      (fl_hide_object fdui_folder)))

(define (reshow_cb ob data)
  (fl_hide_form (fl_get_object_form ob))
  (fl_show_form (fl_get_object_form ob) 
		FL_PLACE_CENTER FL_FULLBORDER "TabFolder"))

(define (set_cb ob data)
  (let ((n (fl_get_active_folder_number fdui_folder)))
    (fl_set_folder_bynumber fdui_folder
			    (+ (modulo n 5) 1))))

(define (deactivate_cb ob data)
  (if (> (fl_get_object_active fdui_folder) 0)
      (begin
        (fl_set_object_label ob "Activate")
        (fl_deactivate_object fdui_folder))
      (begin
        (fl_set_object_label ob "Deactivate")
        (fl_activate_object fdui_folder))))

(define (done_cb ob data)
  (if #f
      (begin
	(fl_hide_form (fl_get_object_form ob))
	(fl_free_form (fl_get_object_form ob))
	(if (= (fl_show_question "Do you want to quit ?" 0) FL_TRUE)
	    (exit 0)
	    (begin
	      (display "will quit after 5 seconds\n")
	      (fl_msleep 5000))))
      (begin
	(fl_finish)
	(exit 0))))

(define (folder . args)
  (fl_set_border_width -2)
  (fl_initialize args)
  (set! fdui_mainform (create_form_mainform))

  (make_folder fdui_folder)

  ;/* show the first form */
  (fl_show_form fdui_mainform FL_PLACE_CENTER FL_FULLBORDER "TabFolder")

  (letrec ((loop (lambda ()
		   (fl_do_forms)
		   (loop))))
    (loop))
  0)


(define (make_folder folder)
  (let ((fdui_buttonform '())
	(fdui_staticform '())
	(fdui_valuatorform '())
	(fdui_choiceform '())
	(fdui_inputform '())
	(x '(0  1  2  3  4  5))
	(y '(5.5  4  4.5  3.8  4  5))
	(label '("Mon" "Tue" "Wed"  "Thur" "Fri" "Sat"))
	(i 0) ; JL : unused
	)
    (set! fdui_buttonform (create_form_buttonform))
    (set! fdui_staticform (create_form_staticform))
    (set! fdui_valuatorform (create_form_valuatorform))
    (set! fdui_choiceform (create_form_choiceform))
    (set! fdui_inputform (create_form_inputform))
    
    ;/* fill-in form initialization code */
    (map (lambda (i)
	   (fl_add_chart_value fdui_chart 
			       (list-ref y i)
			       (list-ref label i)
			       (+ i 1)))
	 x)
    ; JL : fl_addto_menu with more than two args ?
    (fl_addto_menu fdui_pulldown (string-append "MenuEntry1|MenuEntry2"
		   "MenuEntry3|MenuEntry4"))
    (fl_addto_menu fdui_pushmenu (string-append "MuEntry1|MenuEntry2|"
		   "MenuEntry3"))
    (fl_addto_choice fdui_choice (string-append 
				  "Choice1|Choice2|Choice3|Choice4|"
				  "Choice5|Choice6"))
    
    (fl_load_browser fdui_browser "01Readme")
    
    (if #t
	(begin
	  (fl_addto_tabfolder folder "ButtonObj"  fdui_buttonform)
	  (fl_addto_tabfolder folder "StaticObj"  fdui_staticform)
	  (fl_addto_tabfolder folder "ValuatorObj"  fdui_valuatorform)
	  (fl_addto_tabfolder folder "ChoiceObj"  fdui_choiceform)
	  (fl_addto_tabfolder folder "InputObj"  fdui_inputform)
	  ))
    ))
  

; "folder_gui.c"
;/* Form definition file generated with fdesign. */

(define (create_form_buttonform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  430  210))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 430 210 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 30 151 80 30 "Button"))
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 40 91 100 30 "RoundButton"))
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 135 151 110 30 
	  "Round3DButton"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 170 111 110 30 "CheckButton"))
    (set! obj (fl_add_lightbutton FL_PUSH_BUTTON 30 31 100 30 "LightButton"))
    (set! obj (fl_add_pixmapbutton FL_NORMAL_BUTTON 320 36 80 80 
				   "PixmapButton"))
    (fl_set_pixmapbutton_file obj  "porsche.xpm")
    (set! obj (fl_add_button FL_NORMAL_BUTTON 185 26 100 30 "Button"))
    (fl_set_object_boxtype obj FL_ROUNDED3D_UPBOX)
    (set! obj (fl_add_lightbutton FL_PUSH_BUTTON 290 146 100 30 "Button"))
    (fl_set_object_boxtype obj FL_EMBOSSED_BOX);
    (set! obj (fl_add_button FL_NORMAL_BUTTON 175 71 60 25 "Button"))
    (fl_set_object_boxtype obj FL_SHADOW_BOX)
    (fl_set_object_color obj FL_COL1 FL_SLATEBLUE)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(define fdui_chart '())
(define (create_form_staticform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  431  211))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 431 211 ""))
    (fl_set_object_color obj FL_INDIANRED FL_INDIANRED)
    (fl_set_object_lcolor obj FL_INDIANRED)
    (set! obj (fl_add_box FL_UP_BOX 40 40 60 45 "A Box"))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 130 30 120 55 "LabelFrame"))
    (fl_set_object_color obj FL_BLACK FL_INDIANRED)
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (set! obj (fl_add_chart FL_PIE_CHART 270 20 130 105 ""))
    (set! fdui_chart obj)
    (fl_set_object_color obj FL_INDIANRED FL_COL1)
    (set! obj (fl_add_clock FL_ANALOG_CLOCK 30 100 85 85 ""))
    (fl_set_object_color obj FL_COL1 FL_RIGHT_BCOL)
    (set! obj (fl_add_bitmap FL_NORMAL_BITMAP 150 140 30 25 ""))
    (set! obj (fl_add_pixmap FL_NORMAL_PIXMAP 210 120 60 60 ""))
    (set! obj (fl_add_text FL_NORMAL_TEXT 310 150 70 25 "Text"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (fl_end_form)
    form))

;/*---------------------------------------*/

(define fdui_mainform '())
(define fdui_done '())
(define fdui_hide '())
(define fdui_show '())
(define fdui_reshow '())
(define fdui_folder '())
(define fdui_set '())
(define fdui_deactivate '())

(define (create_form_mainform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  461  291))
    (set! obj (fl_add_box FL_UP_BOX 0 0 461 291 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 381 250 64 25 "Done"))
    (set! fdui_done obj)
    (fl_set_object_callback obj done_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 15 249 64 27 "Hide"))
    (set! fdui_hide obj)
    (fl_set_button_shortcut obj "#H" 1)
    (fl_set_object_callback obj hide_show_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 79 249 64 27 "Show"))
    (set! fdui_show obj)
    (fl_set_button_shortcut obj "#S" 1)
    (fl_set_object_callback obj hide_show_cb 1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 155 249 64 27 "ReShow"))
    (set! fdui_reshow obj)
    (fl_set_button_shortcut obj "#R" 1)
    (fl_set_object_callback obj reshow_cb 0)
    (set! obj (fl_add_tabfolder FL_TOP_TABFOLDER 15 11 435 230 ""))
    (set! fdui_folder obj)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 232 249 64 27 "Set"))
    (set! fdui_set obj)
    (fl_set_object_callback obj set_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 296 249 69 27 "Deactivate"))
    (set! fdui_deactivate obj)
    (fl_set_object_callback obj deactivate_cb 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(define (create_form_valuatorform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  431  211))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 431 211 ""))
    (set! obj (fl_add_positioner FL_NORMAL_POSITIONER 280 50 82 72 ""))
    (fl_set_positioner_xvalue obj  0.679012)
    (fl_set_positioner_yvalue obj  0.71831)
    (set! obj (fl_add_valslider FL_HOR_NICE_SLIDER 55 10 240 20 ""))
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_color obj FL_COL1 FL_RIGHT_BCOL)
    (fl_set_slider_value obj  0.87)
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 130 110 110 20 ""))
    (fl_set_counter_value obj  -1.0)
    (set! obj (fl_add_slider FL_VERT_NICE_SLIDER 10 30 20 160 ""))
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_color obj FL_COL1 FL_RED)
    (fl_set_slider_value obj  0.49)
    (set! obj (fl_add_valslider FL_HOR_BROWSER_SLIDER 70 170 150 21 ""))
    (fl_set_slider_size obj  0.10)
    (set! obj (fl_add_slider FL_HOR_FILL_SLIDER 69 57 159 22 ""))
    (fl_set_object_color obj FL_COL1 FL_SLATEBLUE)
    (fl_set_slider_value obj  0.25)
    (set! obj (fl_add_dial FL_NORMAL_DIAL 60 90 60 58 ""))
    (fl_set_object_boxtype obj FL_UP_BOX)
    (set! obj (fl_add_scrollbar FL_VERT_THIN_SCROLLBAR 394 14 18 180 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_scrollbar_size obj  0.20)
    (set! obj (fl_add_scrollbar FL_HOR_SCROLLBAR 238 158 140 16 ""))
    (fl_set_scrollbar_size obj  0.25)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(define fdui_pulldown '())
(define fdui_choice '())
(define fdui_browser '())
(define fdui_pushmenu '())

(define (create_form_choiceform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  431  211))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 431 211 ""))
    (set! obj (fl_add_menu FL_PULLDOWN_MENU 45 36 45 21 "Menu"))
    (set! fdui_pulldown obj)				 
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_color obj FL_COL1 FL_LEFT_BCOL)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE2 24 93 111 27 ""))
    (set! fdui_choice obj)
    (set! obj (fl_add_browser FL_HOLD_BROWSER 257 14 154 179 ""))
    (set! fdui_browser obj)
    (set! obj (fl_add_menu FL_PUSH_MENU 152 51 75 26 "Menu"))
    (set! fdui_pushmenu obj)
    (fl_set_object_boxtype obj FL_UP_BOX)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(define (create_form_inputform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  430  210))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 430 210 ""))
    (set! obj (fl_add_input FL_MULTILINE_INPUT 70 20 280 90 
			    "MultiLine\nInput"))
    (set! obj (fl_add_input FL_NORMAL_INPUT 80 132 250 34 "Input"))
    (fl_end_form)
    form))

;/*---------------------------------------*/

(folder)
