;/*
; * Demo, showing the different fonts in different sizes. 
; * M. Overmars and T.C. Zhao 
; */

(require 'forms)

(define fdui_fontsform '())
(define fdui_fontobj '())
(define fdui_sizeobj '())
(define fdui_textobj '())


(define (done_cb obj arg)
  (fl_finish)
  (exit 0))

(define (style_cb obj arg)
  (fl_set_object_lstyle fdui_textobj (- (fl_get_browser obj) 1)))

(define (size_cb obj arg)
  (case (fl_get_browser obj)
    ((1) (fl_set_object_lsize fdui_textobj 8))
    ((2) (fl_set_object_lsize fdui_textobj 10))
    ((3) (fl_set_object_lsize fdui_textobj 11))
    ((4) (fl_set_object_lsize fdui_textobj 12))
    ((5) (fl_set_object_lsize fdui_textobj 13))
    ((6) (fl_set_object_lsize fdui_textobj 14))
    ((7) (fl_set_object_lsize fdui_textobj 18))
    ((8) (fl_set_object_lsize fdui_textobj 24))
    ((9) (fl_set_object_lsize fdui_textobj 30))
    (else #t)))

(define (addit str)
  (fl_add_browser_line fdui_fontobj str)) 

(define (fonts . args)
  (fl_set_border_width -3)
  ;
  (fl_initialize args)
  (set! fdui_fontsform (create_form_fontsform))
  (fl_scale_form fdui_fontsform  1.1 1.2)
  (fl_set_object_dblbuffer fdui_textobj 1)
  (fl_set_object_bw fdui_textobj 5)
  ;
  (fl_enumerate_fonts addit  1)
  (fl_select_browser_line fdui_fontobj 1)
  (fl_addto_browser fdui_sizeobj "8  (tiny)")
  (fl_addto_browser fdui_sizeobj "10 (small)")
  (fl_addto_browser fdui_sizeobj "11 (scaled)")
  (fl_addto_browser fdui_sizeobj "12 (normal)")
  (fl_addto_browser fdui_sizeobj "13 (scaled)")
  (fl_addto_browser fdui_sizeobj "14 (medium)")
  (fl_addto_browser fdui_sizeobj "18 (large)")
  (fl_addto_browser fdui_sizeobj "24 (Huge)")
  (fl_addto_browser fdui_sizeobj "30 (scaled)")
  (fl_select_browser_line fdui_sizeobj 2)
  (fl_set_object_lstyle fdui_textobj FL_NORMAL_STYLE)
  (fl_call_object_callback fdui_fontobj)
  (fl_call_object_callback fdui_sizeobj)
  (fl_show_form fdui_fontsform FL_PLACE_CENTER FL_TRANSIENT "Fonts")
  (fl_do_forms)
  0)

(define (create_form_fontsform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  371  296))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 371 296 ""))
    (fl_set_object_color obj FL_SLATEBLUE FL_COL1);
    (set! obj (fl_add_browser FL_HOLD_BROWSER 10 145 195 135 ""))
    (set! fdui_fontobj obj)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj style_cb 0)
    (set! obj (fl_add_browser FL_HOLD_BROWSER 215 145 145 135 ""))
    (set! fdui_sizeobj obj)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj size_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 10 5 351 125 
			   "The quick brown\nfox jumps over\nthe lazy dog."))
    (set! fdui_textobj obj)
    (fl_set_object_boxtype obj  FL_FRAME_BOX)
    (fl_set_object_lalign obj  FL_ALIGN_CENTER)
    (set! obj (fl_add_button FL_HIDDEN_BUTTON 0 0 370 140 "Button"))
    (fl_set_button_shortcut obj "^[qQ" 1)
    (fl_set_object_callback obj done_cb 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(fonts)