;/* This demo is meant to demonstrate the use of a free
;   object in a form.
;*/

(require `forms)

(define on #t)
(define dcol 1)
(define cole -1)

; JL : in lack of direct object manipulation ...
(define obj_x 0)
(define obj_y 0)
(define obj_w 0)
(define obj_h 0)
(define obj_u_ldata 0)


;/* The call back routine */
(define (handle_it obj event mx my key ev)
  (display "handle_it")
  ;  static int dcol = 1;
  (cond ((= event FL_DRAW)
	 (fl_rectf obj_x obj_y obj_w obj_h  obj_u_ldata))
	((= event FL_RELEASE)
	 (set! on (not on)))
	((= event FL_STEP)
	 (if on
	     (begin 
	       (if (equal? obj_u_ldata cole) 
		   (set! dcol -1))
	       (if (equal? obj_u_ldata FL_FREE_COL1) 
		   (set! dcol 1))
	       (set! obj_u_ldata (+ obj_u_ldata dcol))
	       (fl_redraw_object obj))))
	(else `()))
  0)

(define (done ob data)
  (exit 0))

(define (free1 . args)
  (let ((form `())
	(obj `())
	(i 0)
	(j 0)
	(depth 0)
	(col 0))
    (fl_initialize args)
    ;
    (set! form (fl_bgn_form FL_UP_BOX 400 400))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 320 20 40 30 "Exit"))
    (fl_set_object_callback obj  done  0)
    (set! obj 
	  (fl_add_free FL_CONTINUOUS_FREE 40 80 320 280 "" handle_it))
    (fl_end_form)
    ;
    (set! depth  (fl_get_visual_depth))
    ;/* can't do it if less than 4 bit deep */
    (if (< depth 4)
	(begin
	  (display "This Demo requires a depth of at least 4 bits\n")
	  (fl_finish)
	  (exit 1)))
    ;
    (set! cole (- (expt 2 depth) 1))
    (if (> cole 64)
	(set! cole 64))
    ;
    (set! col FL_FREE_COL1)
    (set! obj_u_ldata col)
    ; JL : save obj dimensions
    (set! obj_x 40)
    (set! obj_y 80)
    (set! obj_w 320)
    (set! obj_h 280)
    ;
    (set! cole (+ cole col))
    ;
    (letrec ((loop
	      (lambda (i)
		(set! j (inexact->exact ; JL : to return integer
			 (* 255 (/ (- i col) (- cole col)))))
		(fl_mapcolor i j j j)
		(if (<= i cole)
		    (loop (+ i 1))))))
      (loop col))
    ;
    (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Free Object")
    (fl_do_forms)
    0))

(free1)
