;/* 
; * Demo showing the use of a free object 
; *
; * This file is part of xforms package
; * T.C. Zhao and M. Overmars
; *
; */
; JL : BUG - refresh only works once 
; JL : possible BUG - filled objects (at start)

(require 'forms)
(require 'logical)
(require 'struct)

;/**** Forms and Objects ****/
(define-record fd
  (drawfree
   freeobj
   figgrp
   colgrp
   colorobj
   rsli
   gsli
   bsli
   miscgrp
   sizegrp
   hsli
   wsli
   fillobj
   drobj))

(define drawui
  (make-fd 0 0 0 0 0 0 0 0 0 0 0 0 0 (make-vector 3 0)))

(define max_w 150)
(define max_h 150)

(define dpy '())

(define (freedraw . args)
  (set! dpy (fl_initialize args))
  (set-fd-drawfree! drawui (create_form_drawfree))
  (fl_set_object_color (fd->colorobj drawui) FL_FREE_COL1 FL_FREE_COL1)
  (draw_initialize drawui)
  (fl_show_form (fd->drawfree drawui) (logior FL_PLACE_CENTER FL_FREE_SIZE) 
		FL_FULLBORDER "FreeObject")
  (fl_do_forms)
  (fl_finish)
  0)

;/* Structure mantainace */ JL : maintainance ?

(define (draw_triangle fill x y w h col)
  (let* ((xpoint0x x)
	 (xpoint0y (+ y h -1))
	 (xpoint1x (+ x (/ w 2)))
	 (xpoint1y y)
	 (xpoint2x (+ x w -1))
	 (xpoint2y (+ y h -1))
	 (xpoint (list (list xpoint0x xpoint0y)
		       (list xpoint1x xpoint1y)
		       (list xpoint2x xpoint2y)))
	 ;(win (fl_winget))
	 )
    ;(fl_set_foreground (fl_textgc) (fl_get_pixel col))
    (if (= fill FL_TRUE)
	(fl_polyf xpoint 3 col)
	(begin
	  (fl_lines (append xpoint (list (list xpoint0x xpoint0y)))
		    4 col)))
    ))

(define drawfunc (list 'fl_oval 'fl_rectangle 'draw_triangle))

(define-record DrawFigure
  (drawit
   x y w h fill c
   newfig
   col))

(define saved_figure '())
(define cur_fig '())
(define new_fig (make-DrawFigure
		 'fl_oval
		 0 0 30 30 
		 0
		 (make-vector 3 127)
		 1
		 (+ FL_FREE_COL1 1)))

(define (draw_initialize ui)
  (fl_set_form_minsize (fd->drawfree ui) 530 490)
  (fl_set_object_gravity (fd->colgrp ui) FL_West FL_West)
  (fl_set_object_gravity (fd->sizegrp ui) FL_SouthWest FL_SouthWest)
  (fl_set_object_gravity (fd->figgrp ui) FL_NorthWest FL_NorthWest)
  (fl_set_object_gravity (fd->miscgrp ui) FL_South FL_South)
  (fl_set_object_resize (fd->miscgrp ui) FL_RESIZE_NONE)

  (set! cur_fig (make-DrawFigure
		 'fl_oval
		 0 0 30 30 
		 0
		 (make-vector 3 127)
		 0
		 (+ FL_FREE_COL1 1)))
  (fl_mapcolor FL_FREE_COL1 127 127 127)
  (fl_mapcolor (DrawFigure->col cur_fig) 127 127 127)

  (fl_set_slider_bounds (fd->wsli ui) 1 max_w)
  (fl_set_slider_bounds (fd->hsli ui) 1 max_h)
  (fl_set_slider_precision (fd->wsli ui) 0) 
  (fl_set_slider_precision (fd->hsli ui) 0)
  (fl_set_slider_value (fd->wsli ui) (DrawFigure->w cur_fig))
  (fl_set_slider_value (fd->hsli ui) (DrawFigure->h cur_fig))
  
  ;/* color sliders */
  (fl_set_slider_bounds (fd->rsli ui) 1.0 0)
  (fl_set_slider_bounds (fd->gsli ui) 1.0 0)
  (fl_set_slider_bounds (fd->bsli ui) 1.0 0)

  ;/* intial drawing function */
  (fl_set_button (vector-ref (fd->drobj ui) 0) 1)

  ;/* setup the color slider so we can find out colorobject from
  ;   the callback funtions. This is not necessary as drawui
  ;   is static, this is done to show how to access other objects
  ;   from an object callback function */

  (fl_set_object_vdata (fd->rsli ui) ui)
  (fl_set_object_vdata (fd->gsli ui) ui)
  (fl_set_object_vdata (fd->bsli ui) ui)
  )

(define (switch_object ob which)
  (set-DrawFigure-drawit! cur_fig (list-ref drawfunc which)))

(define (change_color ob which)
  (vector-set! (DrawFigure->c cur_fig) which
	       (* (fl_get_slider_value ob) 255))
  (fl_mapcolor (DrawFigure->col cur_fig)
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 0))
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 1))
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 2)))
  (fl_mapcolor FL_FREE_COL1
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 0))
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 1))
	       (inexact->exact (vector-ref (DrawFigure->c cur_fig) 2)))
  (fl_redraw_object (fd->colorobj (fl_get_object_vdata ob)))
  )

(define (fill_cb ob notused)
  (set-DrawFigure-fill! cur_fig
			(if (= (fl_get_button ob) FL_TRUE)
			    FL_FALSE FL_TRUE)))

(define (change_size ob which)
  (if (= which 0)
      (set-DrawFigure-w! cur_fig (fl_get_slider_value ob))
      (set-DrawFigure-h! cur_fig (fl_get_slider_value ob))))

(define (refresh_cb ob which)
  (fl_redraw_object (fd->freeobj drawui)))

(define (clear_cb ob notused)
  (set! cur_fig (make-DrawFigure
		 (DrawFigure->drawit cur_fig)
		 (DrawFigure->w cur_fig)
		 (DrawFigure->y cur_fig)
		 (DrawFigure->w cur_fig)
		 (DrawFigure->h cur_fig)
		 (DrawFigure->fill cur_fig)
		 (make-vector 3 127)
		 0
		 (+ FL_FREE_COL1 1)))
  (set! saved_figure '())
  (fl_redraw_object (fd->freeobj drawui)))

(define (draw_figure fig ob_x ob_y)
  (apply (eval (DrawFigure->drawit cur_fig))
	 (list 
	  (DrawFigure->fill cur_fig)
	  (inexact->exact (+ (DrawFigure->x cur_fig) ob_x))
	  (inexact->exact (+ (DrawFigure->y cur_fig) ob_y))
	  (inexact->exact (DrawFigure->w cur_fig))
	  (inexact->exact (DrawFigure->h cur_fig))
	  (DrawFigure->col cur_fig))))

;/*  The routine that does drawing */
(define (freeobject_handler ob event mx my key xev)
  (let* ((ob_boxtype (fl_get_object_boxtype ob))
	 (obpos (fl_get_object_position ob))
	 (ob_x (car obpos))
	 (ob_y (cadr obpos))
	 (obsiz (fl_get_object_size ob))
	 (ob_w (car obsiz))
	 (ob_h (cadr obsiz))
	 (obcol (fl_get_object_color ob))
	 (ob_col1 (car obcol))
	 (ob_bw (fl_get_object_bw ob)))
    (cond ((= event FL_DRAW)
	   (if (= (DrawFigure->newfig cur_fig) 1)
	       (begin
		 (draw_figure cur_fig ob_x ob_y)
		 (set-DrawFigure-newfig! cur_fig 0))
	       (begin
		 (fl_drw_box 
		  ob_boxtype 
		  ob_x ob_y ob_w ob_h ob_col1 ob_bw)
		 (letrec ((loop (lambda (figs)
				  (if (null? figs)
				      (fl_flush)
				      (begin
					(draw_figure (car figs)
						     ob_x ob_y)
					(loop (cdr figs)))))))
		   (loop saved_figure))))
	   )

	  ((= event FL_PUSH)
	   (if (not (= key 2))
	       (begin
		 (set-DrawFigure-x! cur_fig (- mx
					       (/ (DrawFigure->w cur_fig) 2)))
		 (set-DrawFigure-y! cur_fig (- my
					       (/ (DrawFigure->h cur_fig) 2)))
		 ;/* convert position to relative to the free object */
		 (set-DrawFigure-x! cur_fig 
				    (inexact->exact
				     (- (DrawFigure->x cur_fig) ob_x)))
		 (set-DrawFigure-y! cur_fig 
				    (inexact->exact
				     (- (DrawFigure->y cur_fig) ob_y)))
		 (set-DrawFigure-newfig! cur_fig 1)

		 
		 (set-DRawFigure-fill! 
		  cur_fig
		  (if (= (fl_get_button (fd->fillobj drawui)) FL_TRUE)
		      FL_FALSE FL_TRUE))

		 (fl_redraw_object ob)
		 (set! cur_fig (make-DrawFigure
				(DrawFigure->drawit cur_fig)
				(DrawFigure->x cur_fig)
				(DrawFigure->y cur_fig)
				(DrawFigure->w cur_fig)
				(DrawFigure->h cur_fig)
				(DrawFigure->fill cur_fig)
				(DrawFigure->c cur_fig)
				1
				(DrawFigure->col cur_fig)))

		 (set! saved_figure (append saved_figure (list cur_fig)))
		 (fl_mapcolor (+ (DrawFigure->col cur_fig) 1) 
			      (inexact->exact 
			       (vector-ref (DrawFigure->c cur_fig) 0))
			      (inexact->exact
			       (vector-ref (DrawFigure->c cur_fig) 1))
			      (inexact->exact
			       (vector-ref (DrawFigure->c cur_fig) 2)))
		 ; new cur_fig
		 (set-DrawFigure-col! cur_fig
				      (+ (DrawFigure->col cur_fig) 1))
		 )))
	  (else 
	   '()))
    0))

(define (create_form_drawfree)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  530 490))
    (set! obj (fl_add_box FL_UP_BOX 0 0 530 490 ""))
    (set! obj (fl_add_frame FL_DOWN_FRAME 145 30 370 405 ""))
    (fl_set_object_gravity obj  FL_NorthWest  FL_SouthEast)
    (set! obj (fl_add_free FL_NORMAL_FREE 145 30 370 405 "" 
			   freeobject_handler))
    (set-fd-freeobj! drawui obj)    
    (fl_set_object_gravity obj  FL_NorthWest  FL_SouthEast)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 15 25 100 35 "Outline"))
    (set-fd-fillobj! drawui obj)
    (fl_set_object_color obj FL_MCOL FL_BLUE)
    (fl_set_object_gravity obj  FL_NorthWest  FL_NorthWest)
    (fl_set_object_callback obj fill_cb 0)
    
    (set-fd-figgrp! drawui (fl_bgn_group))
    (set! obj (fl_add_button FL_RADIO_BUTTON 10 60 40 40 "@#circle"))
    (vector-set! (fd->drobj drawui) 0 obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 0)
    (set! obj (fl_add_button FL_RADIO_BUTTON 50 60 40 40 "@#square"))
    (vector-set! (fd->drobj drawui) 1 obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 1)
    (set! obj (fl_add_button FL_RADIO_BUTTON 90 60 40 40 "@#8>"))
    (vector-set! (fd->drobj drawui) 2 obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 2)
    (fl_end_group)

    (set-fd-colgrp! drawui (fl_bgn_group))
    (set! obj (fl_add_box FL_BORDER_BOX 25 140 90 25 ""))
    (set-fd-colorobj! drawui obj)
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 25 170 30 125 ""))
    (set-fd-rsli! drawui obj)
    (fl_set_object_color obj FL_COL1 FL_RED)
    (fl_set_object_callback obj change_color 0)
    (fl_set_slider_return obj  FL_RETURN_CHANGED)
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 55 170 30 125 ""))
    (set-fd-gsli! drawui obj)
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (fl_set_object_callback obj change_color 1)
    (fl_set_slider_return obj  FL_RETURN_CHANGED)
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 85 170 30 125 ""))
    (set-fd-bsli! drawui obj)
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj change_color 2)
    (fl_set_slider_return obj  FL_RETURN_CHANGED)
    (fl_end_group)

    (set-fd-miscgrp! drawui (fl_bgn_group))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 395 445 105 30 "Quit"))
    (fl_set_button_shortcut obj "Qq#q" 1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 280 445 105 30 "Refresh"))
    (fl_set_object_callback obj refresh_cb 0);
    (set! obj (fl_add_button FL_NORMAL_BUTTON 165 445 105 30 "Clear"))
    (fl_set_object_callback obj clear_cb 0)
    (fl_end_group)

    (set-fd-sizegrp! drawui (fl_bgn_group))
    (set! obj (fl_add_valslider FL_HOR_SLIDER 15 410 120 25 "Height"))
    (set-fd-hsli! drawui obj)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (fl_set_object_callback obj change_size 1)
    (fl_set_slider_return obj  FL_RETURN_CHANGED)
    (set! obj (fl_add_valslider FL_HOR_SLIDER 15 370 120 25 "Width"))
    (set-fd-wsli! drawui obj)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (fl_set_object_callback obj change_size 0)
    (fl_set_slider_return obj FL_RETURN_CHANGED)
    (fl_end_group)
    
    (fl_end_form)
    form))

;/*---------------------------------------*/

(freedraw)

