;/* 
; * Demo showing the use of FREE Object with color leakage
; *
; */

(require 'forms)
(require 'struct)

;/* Header file generated with fdesign. */

(define-record fd
  (drawfree
   vdata
   cdata
   ldata
   freeobj
   colorobj
   hsli
   wsli
   rsli
   gsli
   bsli
   drobj0
   drobj1
   drobj2))

(define max_w 150)
(define max_h 150)
(define dpy #f)
(define drawui #f)


(define (freedraw_leak . args)
  (set! dpy (fl_initialize args))
  (set! drawui (create_form_drawfree))
  (fl_set_color_leak 1)
  (draw_initialize drawui)
  (fl_show_form (fd->drawfree drawui) 
		FL_PLACE_CENTER FL_TRANSIENT "FreeObject")
  (fl_do_forms)
  0)


;/* Structure mantainace */

(define (draw_triangle fill x y w h col)
 (let* ((xpoint0x (inexact->exact x))
	(xpoint0y (inexact->exact (+ y h -1)))
	(xpoint1x (inexact->exact (+ x (/ w 2))))
	(xpoint1y (inexact->exact y))
	(xpoint2x (inexact->exact (+ x w -1)))
	(xpoint2y (inexact->exact (+ y h -1)))
	(xpoint (list (list xpoint0x xpoint0y)
		      (list xpoint1x xpoint1y)
		      (list xpoint2x xpoint2y)))
	;(win (fl_winget))
	)
   ;(fl_set_foreground (fl_textgc) (fl_get_pixel col))
   (if (= fill FL_TRUE)
       (fl_polyf xpoint 3 col)
       (fl_lines (append xpoint (list (list xpoint0x xpoint0y)))
		 4 col))))

(define drawfunc (list fl_oval fl_rectangle draw_triangle))

(define-record drfig
  (drawit
   x y w h fill c0 c1 c2
   newfig))

(define saved_figure '())

(define cur_fig (make-drfig #f 0 0 0 0 0 0 0 0 0))
(define cur_figp 0)

(define (copy_fig fig)
  (make-drfig 
   (drfig->drawit fig)
   (inexact->exact (drfig->x fig))
   (inexact->exact (drfig->y fig))
   (inexact->exact (drfig->w fig))
   (inexact->exact (drfig->h fig))
   (inexact->exact (drfig->fill fig))
   (inexact->exact (drfig->c0 fig))
   (inexact->exact (drfig->c1 fig))
   (inexact->exact (drfig->c2 fig))
   (drfig->newfig fig)))
    
(define (draw_initialize ui)
  (set-drfig-c0! cur_fig 127)
  (set-drfig-c1! cur_fig 127)
  (set-drfig-c2! cur_fig 127)
  (set-drfig-w! cur_fig 30)
  (set-drfig-h! cur_fig 30)
  (set-drfig-drawit! cur_fig fl_oval)
  (set-drfig-fill! cur_fig 1)

  (fl_mapcolor FL_FREE_COL1 127 127 127)
  
  (fl_set_slider_bounds (fd->wsli ui) 1 max_w)
  (fl_set_slider_bounds (fd->hsli ui) 1 max_h)
  (fl_set_slider_precision (fd->wsli ui) 0)
  (fl_set_slider_precision (fd->hsli ui) 0)
  (fl_set_slider_value (fd->wsli ui) (drfig->w cur_fig))
  (fl_set_slider_value (fd->hsli ui) (drfig->h cur_fig))
  
  ;/* intial drawing function */
  (fl_set_button (fd->drobj0 ui) 1)
  
  ;/* setup the color slider so we can find out colorobject from
  ; the callback funtions. This is not necessary as drawui
  ; is static, this is done to show how to access other objects
  ; from an object callback function */
  
  (fl_set_object_vdata (fd->rsli ui) ui)
  (fl_set_object_vdata (fd->gsli ui) ui)
  (fl_set_object_vdata (fd->bsli ui) ui)
  )

(define (switch_object ob which)
  (set-drfig-drawit! cur_fig (list-ref drawfunc which)))

(define (change_color ob which)
  (cond ((= which 0)
	 (set-drfig-c0! cur_fig 
			(inexact->exact
			 (* (fl_get_slider_value ob) 255))))
	((= which 1)
	 (set-drfig-c1! cur_fig 
			(inexact->exact
			 (* (fl_get_slider_value ob) 255))))
	((= which 2)
	 (set-drfig-c2! cur_fig 
			(inexact->exact
			 (* (fl_get_slider_value ob) 255))))
	(else #t))
  (fl_mapcolor FL_FREE_COL1 
	       (drfig->c0 cur_fig) (drfig->c1 cur_fig) (drfig->c2 cur_fig))
  (fl_redraw_object (fd->colorobj (fl_get_object_vdata ob)))
  )

(define (fill_cb ob notused)
  (set-drfig-fill! cur_fig (if (= (fl_get_button ob) FL_TRUE) 
			       FL_FALSE 
			       FL_TRUE)))

(define (change_size ob which)
  (if (= which 0)
      (set-drfig-w! cur_fig (fl_get_slider_value ob))
      (set-drfig-h! cur_fig (fl_get_slider_value ob))))

(define (refresh_cb ob which)
  (fl_redraw_object (fd->freeobj drawui)))

(define (clear_cb ob notused)
  (set! saved_figure '()) 
  ;(set! cur_figp 0)
  ;(set! cur_fig (car saved_figure))
  (fl_redraw_object (fd->freeobj drawui))
  )

;/*  The routine that does drawing */
(define (freeobject_handler ob event mx my key xev)
  (let* ((ob_boxtype (fl_get_object_boxtype ob))
         (obpos (fl_get_object_position ob))
         (ob_x (car obpos))
         (ob_y (cadr obpos))
         (obsiz (fl_get_object_size ob))
         (ob_w (car obsiz))
         (ob_h (cadr obsiz))
         (obcol (fl_get_object_color ob))
         (ob_col1 (car obcol)))
    (cond ((= event FL_DRAW)
	   (if (= (drfig->newfig cur_fig) 1)
	       (apply
		(drfig->drawit cur_fig)
		(list 
		 (drfig->fill cur_fig)
		 (+ (drfig->x cur_fig) ob_x)
		 (+ (drfig->y cur_fig) ob_y)
		 (drfig->w cur_fig)
		 (drfig->h cur_fig) FL_FREE_COL1))
	       (begin
		 (fl_drw_box
		  ob_boxtype ob_x ob_y ob_w ob_h ob_col1
		  FL_BOUND_WIDTH)
		 (map (lambda (dr)
			(fl_mapcolor FL_FREE_COL1
				     (drfig->c0 dr)
				     (drfig->c1 dr)
				     (drfig->c2 dr))
			(apply
			 (drfig->drawit dr)
			 (list
			  (drfig->fill dr)
			  (+ (drfig->x dr) ob_x)
			  (+ (drfig->y dr) ob_y)
			  (drfig->w dr)
			  (drfig->h dr) FL_FREE_COL1)))
		      saved_figure)
		 (set-drfig-newfig! cur_fig 0))))
	  ((= event FL_PUSH)
	   (if (not (= key 2))
	       (begin
		 (set-drfig-x! cur_fig (- mx (/ (drfig->w cur_fig) 2)))
		 (set-drfig-y! cur_fig (- my (/ (drfig->h cur_fig) 2)))
		 ;/* convert position to relative to the free object */
		 (set-drfig-x! cur_fig (- (drfig->x cur_fig) ob_x))
		 (set-drfig-y! cur_fig (- (drfig->y cur_fig) ob_y))
		 (set-drfig-newfig! cur_fig  1)
		 (fl_redraw_object ob)
		 (set! saved_figure (append saved_figure 
					    (list (copy_fig cur_fig))))
		 (set! cur_figp (+ cur_figp 1))
		 (set-drfig-newfig! cur_fig 0)
		 )))
	  (else #t)))
  0)

(define (create_form_drawfree)
  (let ((obj '())
	(fdui (make-fd #f #f #f #f #f #f #f #f #f #f #f #f #f #f)))
    (set-fd-drawfree! fdui (fl_bgn_form FL_NO_BOX  530  490))
    (set! obj (fl_add_box FL_UP_BOX 0 0 530 490 ""))
    (set! obj (fl_add_frame FL_DOWN_FRAME 145 55 370 405 ""))
    (set! obj (fl_add_free FL_NORMAL_FREE 
			   145  55  370  405  ""  freeobject_handler))
    (set-fd-freeobj! fdui obj)
    ;/*  (fl_set_object_dblbuffer obj  1) */
    (fl_set_object_boxtype obj  FL_FLAT_BOX)
    (set! obj (fl_add_box FL_BORDER_BOX 25 325 90 25 ""))
    (set-fd-colorobj! fdui obj)
    (fl_set_object_color obj  FL_FREE_COL1  FL_COL1)  
    (set! obj (fl_add_valslider FL_HOR_SLIDER 15 55 120 25 "Height"))
    (set-fd-hsli! fdui obj)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (fl_set_object_callback obj change_size 1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 395 15 105 30 "Quit"))
    (fl_set_object_shortcut obj "Qq#q" 1)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 15 430 100 35 "Outline"))
    (fl_set_object_color obj FL_MCOL FL_BLUE)
    (fl_set_object_callback obj fill_cb 0)
    (set! obj (fl_add_valslider FL_HOR_SLIDER 15 95 120 25 "Width"))
    (set-fd-wsli! fdui obj)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (fl_set_object_callback obj change_size 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 280 15 105 30 "Refresh"))
    (fl_set_object_callback obj refresh_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 165 15 105 30 "Clear"))
    (fl_set_object_callback obj clear_cb 0)
    
    (fl_bgn_group)
    (set! obj (fl_add_button FL_RADIO_BUTTON 10 390 40 40 "@#circle"))
    (set-fd-drobj0! fdui obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 0)
    (set! obj (fl_add_button FL_RADIO_BUTTON 50 390 40 40 "@#square"))
    (set-fd-drobj1! fdui obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 1)
    (set! obj (fl_add_button FL_RADIO_BUTTON 90 390 40 40 "@#8>"))
    (set-fd-drobj2! fdui obj)
    (fl_set_object_lcol obj FL_YELLOW)
    (fl_set_object_callback obj switch_object 2)
    (fl_end_group)
    
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 25 195 30 125 ""))
    (set-fd-rsli! fdui obj)
    (fl_set_object_color obj FL_COL1 FL_RED)
    (fl_set_object_callback obj change_color 0)
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 55 195 30 125 ""))
    (set-fd-gsli! fdui obj)
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (fl_set_object_callback obj change_color 1)
    (set! obj (fl_add_slider FL_VERT_FILL_SLIDER 85 195 30 125 ""))
    (set-fd-bsli! fdui obj)
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj change_color 2)
    (fl_end_form)
    fdui))



(freedraw_leak)


