;/*
; * Show all the input field types
; *
; * This file is part of xforms package.
; *  T.C. Zhao and M. Overmars, 1997
; */
(require 'forms)

(define fd_input '())
(define fd_report '())
(define fd_norminput '())
(define fd_multiinput '())

;/* callbacks for form input */
(define (done_cb ob data)
  (fl_finish)
  (exit 0))

(define (input_cb ob data)
  (let* ((pos (fl_get_input_cursorpos ob))
	 (cx (car pos))
	 (cy (cadr pos))
	 (buf (string-append
	       "x="
	       (number->string cx)
	       " y="
	       (number->string cy))))
    (fl_set_object_label fd_report buf)))

(define (hide_show_cb ob data)
  (if (= (fl_get_object_visible fd_multiinput) FL_TRUE)
      (fl_hide_object fd_multiinput)
      (fl_show_object fd_multiinput)))


(define (inputall . args)
  (fl_initialize args)
  (set! fd_input (create_form_input))
  ; /* fill-in form initialization code */
  (fl_set_object_dblbuffer fd_report 1)
  (fl_set_object_return fd_multiinput FL_RETURN_ALWAYS)
  (fl_set_object_return fd_norminput FL_RETURN_ALWAYS)
  ;/* show the first form */
  (fl_show_form fd_input FL_PLACE_CENTERFREE FL_FULLBORDER "input")
  (letrec ((loop (lambda ()
		   (fl_do_forms)
		   (loop))))
    (loop))
  0)

;/* Form definition file generated with fdesign. */

(define (create_form_input)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  441  441))
    (set! obj (fl_add_box FL_UP_BOX 0 0 441 441 ""))
    (set! obj (fl_add_input FL_NORMAL_INPUT 40 40 340 30 "NormalInput"))
    (set! fd_norminput obj)
    (fl_set_object_lalign obj FL_ALIGN_TOP_LEFT)
    (fl_set_object_callback obj input_cb 0)
    (set! obj (fl_add_input FL_INT_INPUT 40 100 160 30 "IntInput"))
    (fl_set_object_lalign obj FL_ALIGN_TOP_LEFT)
    (set! obj (fl_add_input FL_FLOAT_INPUT 230 100 160 30 "FloatInput"))
    (fl_set_object_lalign obj FL_ALIGN_TOP_LEFT)
    (set! obj (fl_add_input FL_DATE_INPUT 40 150 160 30 "DateInput"))
    (fl_set_object_lalign obj FL_ALIGN_TOP_LEFT)
    (set! obj (fl_add_input FL_SECRET_INPUT 230 150 160 30 "Secretnput"))
    (fl_set_object_lalign obj FL_ALIGN_TOP_LEFT)
    (set! obj (fl_add_input FL_MULTILINE_INPUT 40 210 360 180 "MMM"))
    (set! fd_multiinput obj)
    (fl_set_object_callback obj input_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 30 400 210 30 ""))
    (set! fd_report obj)
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 330 400 70 30 "Done"))
    (fl_set_object_callback obj done_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 250 400 70 30 "Hide/Show"))
    (fl_set_object_callback obj hide_show_cb 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(inputall)

