;/* 
; * Different label alignments 
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars
; */
(require 'forms)
(require 'logical) 

(define TEST_PIXMAP_ALIGN #f) 

;/**** Forms and Objects ****/
(define fd_form0 0)
(define fd_box 0)
(define fd_inside 0)
(define fd_center 0)

(define (lalign . args)
  (let ((align 0))
    (fl_initialize args)
    (set! fd_form0 (create_form_form0))
    ; /* fill-in form initialization code */
    (fl_set_form_dblbuffer fd_form0  1)
    (set! align (logior (fl_get_object_align fd_box) FL_ALIGN_INSIDE))
    (if (not (= align (fl_get_object_align fd_box)))
	(fl_set_button fd_inside  1))
    ; show the first form 
    (fl_show_form fd_form0  fl_place_free  fl_fullborder "form0")
    (fl_do_forms)
    (fl_hide_form fd_form0)
    #t))

(define (align_cb ob data)
  (let ((n data))
    (if  (= (fl_get_button fd_inside) FL_TRUE)
	 (set! n (logior n FL_ALIGN_INSIDE))) ; JL : not setting! parameter
    (if (not TEST_PIXMAP_ALIGN)
	(fl_set_object_lalign fd_box n) ; was : lalign
	(fl_set_pixmap_align fd_box n 3 3))))

(define  (inside_cb ob data)
  (if  (= (fl_get_button ob) FL_TRUE)
       (fl_set_object_align fd_box 
			    (logior (fl_get_object_align fd_box) 
				    fl_align_inside))
       (fl_set_object_align fd_box
			    (logand (fl_get_object_align fd_box) 
				    (lognot fl_align_inside))))
  (if TEST_PIXMAP_ALIGN
      (fl_set_pixmap_align fd_box (fl_get_box_align fd_box)  3  3)
      (fl_redraw_form fd_form0)))

(define (create_form_form0)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form  FL_NO_BOX  351  170))
    (set! obj (fl_add_box  FL_UP_BOX 0 0 351 170 ""))
    (if (not TEST_PIXMAP_ALIGN)
	(begin
	  (set! obj (fl_add_box	FL_UP_BOX 190 45 90 45 "abcdefg\nhijklmno"))
	  (set! fd_box obj))
	(begin
	  (set! obj (fl_add_pixmap  FL_NORMAL_PIXMAP 190 35 90 60 ""))
	  (set! fd_box obj)
	  (fl_set_pixmap_file obj "crab.xpm")
	  (fl_set_object_boxtype obj  FL_UP_BOX)))
    ;/* (fl_set_object_clip obj  1) ? */
    (set! obj (fl_add_lightbutton  FL_PUSH_BUTTON 20 120 90 30 "Inside"))
    (set! fd_inside obj)
    (fl_set_object_callback obj inside_cb 0)
    (fl_bgn_group)
    (set! obj (fl_add_button FL_RADIO_BUTTON 20 20 30 30 "@#7->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_LEFT_TOP)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 50 20 30 30 "@#8->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_TOP)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 80 20 30 30 "@#9->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_RIGHT_TOP)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 80 50 30 30 "@#->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_RIGHT)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 50 50 30 30 "@circle"))
    (set! fd_center obj)
    (fl_set_object_lcol obj  FL_RED)
    (fl_set_object_callback obj align_cb FL_ALIGN_CENTER)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 20 50 30 30 "@#<-"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_LEFT)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 20 80 30 30 "@#1->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_LEFT_BOTTOM)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 50 80 30 30 "@#2->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_BOTTOM)
    (set! obj (fl_add_button  FL_RADIO_BUTTON 80 80 30 30 "@#3->"))
    (fl_set_object_lcol obj  FL_BLUE)
    (fl_set_object_callback obj align_cb FL_ALIGN_RIGHT_BOTTOM)
    (fl_end_group)
    
    (set! obj (fl_add_button  FL_NORMAL_BUTTON 140 120 70 30 "Done"))
    (fl_end_form)
    form))

(lalign)

