;;; JL : I wonder what this demo is good for
(require 'forms)

;/**** Forms and Objects ****/

(define fd_axypform '())
(define fd_xyplot '())
(define fd_status '())

(define LOG FL_TRUE)

;/* callbacks for form axypform */
(define (xyplot_cb ob data)
  (let* ((xyi (fl_get_xyplot ob))
	 (x (car xyi))
	 (y (cadr xyi))
	 (i (caddr xyi)))
    (fl_object_ps_dump ob "test.ps")
    (if (< i 0)
	'()
	(fl_set_object_label fd_status
			     (string-append 
			      "X= " (number->string x)
			      "  Y=" (number->string y))))))

(define (alwaysreturn_cb ob data)
  (fl_set_xyplot_return fd_xyplot (fl_get_button ob)))

(define (interpolate_cb ob data)
  (if LOG
      (fl_set_xyplot_interpolate fd_xyplot 0 
				 (if (= (fl_get_button ob) FL_TRUE)
				     2 0) 20000)
      (fl_set_xyplot_interpolate fd_xyplot 0
				 (if (= (fl_get_button ob) FL_TRUE)
				     2 0) 0.2))
  )

(define (inspect_cb ob data)
  (fl_set_xyplot_inspect fd_xyplot (fl_get_button ob)))

(define (notic_cb ob data)
  (let ((notic (fl_get_button ob)))
    (if (= notic FL_TRUE)
	(begin
	  (fl_set_xyplot_xtics fd_xyplot -1 -1)
	  (fl_set_xyplot_ytics fd_xyplot -1 -1))
	(begin
	  (fl_set_xyplot_xtics fd_xyplot 0 0)
	  (fl_set_xyplot_ytics fd_xyplot 0 0)))))
  

(define (ll . args)
(let ((x '())
      (y '())
      (i 0))
  (fl_initialize args)
  (set! fd_axypform (create_form_axypform))
  ;/* fill-in form initialization code */
  (fl_set_object_dblbuffer fd_status  1)
  (letrec ((loop (lambda (i)
		   (if (<= i 10)
		       (begin
			 (if LOG
			     (begin
			       (set! x (append x (list (expt 10 (- i 12)))))
			       (set! y (append x (list (expt 10 (- i 12)))))
			       )
			     (begin
			       (set! x (append x (list i)))
			       (set! y (append x (list i)))
			       ))
			 (loop (+ i 1)))))))
    (loop 0))
  (fl_set_xyplot_data fd_xyplot x y 11 "" "" "")

   (if LOG
       (begin
	 (fl_set_xyplot_xscale fd_xyplot FL_LOG 5)
	 (fl_set_xyplot_yscale fd_xyplot FL_LOG 5)
	 (fl_set_xyplot_xbounds fd_xyplot  0.01 10) 
	 (fl_set_xyplot_ytics fd_xyplot  3 5)
	 (fl_set_xyplot_xgrid fd_xyplot  FL_GRID_MINOR)
	 ;/*(fl_set_xyplot_ygrid fd_xyplot 2)*/
	 ))
   ;/* show the first form */
   (fl_show_form fd_axypform FL_PLACE_MOUSE FL_TRANSIENT "axypform")
   (fl_do_forms)
   (fl_finish)
   (exit 0)))

(define (create_form_axypform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  431  301))
    (set! obj (fl_add_box FL_UP_BOX 0 0 431 301 ""))
    (set! obj (fl_add_xyplot FL_ACTIVE_XYPLOT 20 50 285 235 ""))
    (set! fd_xyplot obj)
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_color obj  FL_BLACK  FL_GREEN)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj xyplot_cb 0)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 40 80 25 "AlwaysReturn"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj alwaysreturn_cb 0)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 65 80 25 "Interpolate"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj interpolate_cb 0)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 90 85 25 "InspectOnly"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj inspect_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 45 15 170 25 ""))
    (set! fd_status obj)
    (fl_set_object_boxtype obj  FL_DOWN_BOX)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 325 250 90 30 "Done"))
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 120 85 25 "NoTics"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj notic_cb 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/



(ll)