;/* This demo shows the use of menu's. 
; * The first two are PUSH_MENUs (pop-up).
; * The third one is PULLDOWN_MENU
; * and the last one is TOUCH_MENU
; *
; * a confusing demo, but a good testing program ..
; */

(require `forms)

(define lmenu `())
(define abox `())
(define set (make-vector 4))

(define (menu . args)
  (let ((form `())
	(i 0)
	(i0_3 `(0 1 2 3))
	(j5_7 `(5 6 7))
	(j1_4 `(1 2 3 4)))
    (fl_initialize args)
    (set! form (create_form))
    ;/*(fl_setpup_color FL_SLATEBLUE FL_BLACK) */
    (map (lambda (i)
	   (let ((menu_i (list-ref lmenu i)))
	     (fl_show_menu_symbol menu_i  1)
	     (fl_set_menu 
	      menu_i  
	      "Red%r1|Green%r1|Yellow%r1|Blue%r1|Purple%r1|Cyran%r1|White%r1")
	     (fl_set_menu_item_shortcut menu_i  1  "Rr#R#r")
	     (fl_set_menu_item_shortcut menu_i  2  "Gg#G#g")
	     (fl_set_menu_item_shortcut menu_i  3  "Yy#Y#y")
	     (fl_set_menu_item_shortcut menu_i  4  "Bb#B#b")
	     (fl_set_menu_item_shortcut menu_i  5  "Pp#P#p")
	     (fl_set_menu_item_shortcut menu_i  6  "Cc#C#c")
	     (fl_set_menu_item_shortcut menu_i  7  "Ww#W#w")
	     ;
	     ;/* initially the last three entries are enabled */
	     (map (lambda (j)
		    (fl_set_menu_item_mode menu_i  j  FL_PUP_RADIO))
		  j5_7)
	     ;/* the first four are disabled except the item (i+1) */
	     (map (lambda (j)
		    (fl_set_menu_item_mode menu_i  j  
					   (logior FL_PUP_GREY FL_PUP_RADIO)))
		  j1_4)
	     (vector-set! set i (+ i 1))
	     (fl_set_object_color (list-ref abox i) 
				  (+ FL_BLACK (+ i 1)) ; set[i]
				  FL_BLACK)
	     (fl_set_menu_item_mode (list-ref lmenu i)  
				    (vector-ref set i)
				    (logior FL_PUP_CHECK FL_PUP_RADIO))	     
	     )) i0_3)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "Menu")
    ;
    (fl_do_forms)
    (fl_hide_form form)
    0))

;/* m is the menu index 0 - 3 */
(define (menu_cb ob m)
  (let ((i0_3 `(0 1 2 3))
	(item (fl_get_menu ob)))
    (if (or (<= item 0)
	    (= (vector-ref set m) item)) ; equal?
	0
	(begin
	  (map (lambda (i)
		 (if (not (= i m)) 
		     (begin
		       ;/* enable the old selected color for other menus*/
		       (fl_set_menu_item_mode 
			(list-ref lmenu i)  
			(vector-ref set m)  
			FL_PUP_RADIO)
		       ;/* disable the currently selected 
		       ; color for other menus */
		       (fl_set_menu_item_mode 
			(list-ref lmenu i)  
			item  
			(logior FL_PUP_GRAY FL_PUP_RADIO)))))
		 i0_3)
	  (vector-set! set m item)
	  (fl_set_object_color (list-ref abox m)  
			       (+ FL_BLACK item)  FL_BLACK)))))
      

(define (done_cb ob data)
  (fl_finish)
  (exit 0))

(define (create_form)
  (let ((form `())
	(obj `()))
    (set! form (fl_bgn_form FL_NO_BOX 440 380))
    (set! obj (fl_add_box FL_BORDER_BOX 0 0 440 380 ""))
    (fl_set_object_color obj FL_SLATEBLUE FL_COL1)
    ;
    (set! obj (fl_add_menu FL_PUSH_MENU 0 0 110 30 "Color 1"))
    (fl_set_object_shortcut obj  "1#1"  1)
    (fl_set_object_boxtype obj  FL_UP_BOX)
    (fl_set_object_callback obj  menu_cb  0)
    (set! lmenu (append lmenu (list obj)))
    (set! obj (fl_add_menu FL_PUSH_MENU 110 0 110 30 "Color 2"))
    (fl_set_object_shortcut obj  "2#2"  1)
    (fl_set_object_callback obj  menu_cb  1)
    (set! lmenu (append lmenu (list obj)))
    (set! obj (fl_add_menu FL_PULLDOWN_MENU 220 0 110 30 "Color 3"))
    (fl_set_object_shortcut obj  "3#3"  1)
    (fl_set_object_callback obj  menu_cb  2)
    (set! lmenu (append lmenu (list obj)))
    (set! obj (fl_add_menu FL_TOUCH_MENU 330 0 110 30 "Color 4"))
    (fl_set_object_shortcut obj  "4#4"  1)
    (fl_set_object_callback obj  menu_cb  3)
    (set! lmenu (append lmenu (list obj)))
    (set! obj (fl_add_box FL_SHADOW_BOX 20 80 70 230 ""))
    (set! abox (append abox (list obj)))
    (set! obj (fl_add_box FL_SHADOW_BOX 130 80 70 230 ""))
    (set! abox (append abox (list obj)))
    (set! obj (fl_add_box FL_SHADOW_BOX 240 80 70 230 ""))
    (set! abox (append abox (list obj)))
    (set! obj (fl_add_box FL_SHADOW_BOX 350 80 70 230 ""))
    (set! abox (append abox (list obj)))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 310 330 110 30 "Exit"))
    (fl_set_object_callback obj  done_cb  0)
    (fl_end_form)
    (fl_scale_form form  0.9  0.9)
    form))

(menu)
