;/*
; * Demo showing the use of user defined object class: CROSSBUTTON
; *
; * Form definition file generated with fdesign. 
; * changed stub button to crossbutton
; */

(require 'forms)


(define cbform_bexit '())

; JL : crossbutton.h
(define FL_CROSSBUTTON    (+ FL_USER_CLASS_START 1))

(define FL_CROSSBUTTON_BW  2)
;;;


; JL : crossbutton.c
;/* 
; * Routines implementing the "crossbutton" class
; *
; *  ob->col1 is the color of the box. ob->col2 is the color of cross
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars
; */

(define (draw_crossbutton ob)
  (let* ((xx 0)
	 (yy 0)
	 (ww 0)
	 (hh 0)
	 (opos (fl_get_object_position ob))
	 (ob_x (car opos))
	 (ob_y (cadr opos))
	 (osiz (fl_get_object_size ob)) ; JL : get...geometry draws first 
	 (ob_w (car osiz))
	 (ob_h (cadr osiz))
	 (ocol (fl_get_object_color ob))
	 (ob_col1 (car ocol))
	 (ob_col2 (cadr ocol))
	 (ob_lcol (fl_get_object_lcol ob))
	 (ob_bw (fl_get_object_bw ob))
	 (ob_lsize (fl_get_object_lsize ob))
	 (ob_label (fl_get_object_label ob))
	 (ob_lstyle (fl_get_object_lstyle ob))
	 (ob_boxtype (fl_get_object_boxtype ob))
	 (ob_spec (fl_get_button_spec ob))
	 (ob_spec_event (list-ref ob_spec 7))
	 (ob_spec_val (list-ref ob_spec 4))
	 (ob_align (fl_get_object_align ob))
	 (ob_type (fl_get_object_type ob))
	 )
    ; /* if redraw is demanded by FL_ENTER, ignore it */
    (if (= ob_spec_event FL_ENTER)
	(begin
	  0)
	(begin
	  ;/* draw the bounding box first */
	  (fl_drw_box ob_boxtype 
		      (inexact->exact ob_x)
		      (inexact->exact ob_y)
		      (inexact->exact ob_w)
		      (inexact->exact ob_h) ob_col1 ob_bw)
	  ;/* draw the box that contains the cross */
	  (set! ww (- (* 0.5 (fl_min ob_w ob_h)) 1))
	  (set! hh ww)
	  (set! xx (+ ob_x FL_BOUND_WIDTH))
	  (set! yy (+ ob_y (/ (- ob_h hh) 2)))
	  ;/* if pushed, draw a down box with the cross */
	  (if (= ob_spec_val 1)
	      (begin
		(fl_drw_box FL_DOWN_BOX 
			    (inexact->exact xx)
			    (inexact->exact yy)
			    (inexact->exact ww)
			    (inexact->exact hh) ob_col1 ob_bw)
		(fl_drw_text FL_ALIGN_CENTER 
			     (inexact->exact (- xx 2)) 
			     (inexact->exact (- yy 2))
			     (inexact->exact (+ ww 4))
			     (inexact->exact (+ hh 4)) ob_col2 0 0 "@9plus"))
	      (begin
		(fl_drw_box FL_UP_BOX 
			    (inexact->exact xx)
			    (inexact->exact yy)
			    (inexact->exact ww)
			    (inexact->exact hh) ob_col1 ob_bw)))
	  ;/* label */
	  (if (= ob_align FL_ALIGN_CENTER)
	      (fl_drw_text FL_ALIGN_LEFT  
			   (inexact->exact (+ xx ww 3))
			   (inexact->exact ob_y)
			   0 
			   (inexact->exact ob_h)
			   ob_lcol ob_lstyle ob_lsize ob_label)
	      (fl_draw_object_label_outside ob))
	  
	  (if (= ob_type FL_RETURN_BUTTON)
	      (fl_drw_text FL_ALIGN_CENTER
			   (inexact->exact (+ ob_x ob_w (* -0.8 ob_h)))
			   (inexact->exact (+ ob_y (* 0.2 ob_h)))
			   (inexact->exact (* 0.6 ob_h))
			   (inexact->exact (* 0.6 ob_h))
					   ob_lcol 0 0 "@returnarrow"))
	  ))))



;/* creation */
(define (fl_create_crossbutton type x y w h label)
  (let ((ob '()))
    (fl_add_button_class FL_CROSSBUTTON draw_crossbutton (lambda () 0)) 
    (set! ob (fl_create_generic_button FL_CROSSBUTTON type x y w h label))
    (fl_set_object_boxtype ob FL_NO_BOX)
    (fl_set_object_color ob FL_GRAY63 FL_BLACK); /* cross color */
    ob))

(define (fl_add_crossbutton type x y w h label)
  (let ((ob (fl_create_crossbutton type x y w h label)))
    (fl_add_object (fl_current_form) ob)
    ob))
;;;


(define (newbutton . args)
  (let ((cbform '()))
    (fl_initialize args)
    (set! cbform (create_form_newbut))
    (fl_show_form cbform FL_PLACE_CENTER FL_TRANSIENT "newbutton")
    (letrec ((loop (lambda ()
		     (if (not (equal? (fl_do_forms) cbform_bexit))
			 (loop)))))
      (loop))
    (fl_finish)
    0))

(define (create_form_newbut)
  (let ((obj '())
	(form '())
	(oldbw (fl_get_border_width)))
    (fl_set_border_width -2)
    (set! form (fl_bgn_form FL_NO_BOX  310  190))
    (set! obj (fl_add_box FL_UP_BOX 0 0 310 190 ""))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 40 45 100 120 "CrossB"))
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (set! obj (fl_add_crossbutton FL_RADIO_BUTTON 50 115 80 30 "cross1"))
    (fl_set_object_color obj FL_COL1 FL_RED)
    (set! obj (fl_add_crossbutton FL_RADIO_BUTTON 50 85 80 30 "Button"))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_crossbutton FL_RADIO_BUTTON 50 55 80 30 "Button"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 180 45 100 120 "CrossB"))
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (set! obj (fl_add_crossbutton FL_PUSH_BUTTON 190 115 80 30 "Button"))
    (fl_set_object_color obj FL_COL1 FL_RED)
    (set! obj (fl_add_crossbutton FL_PUSH_BUTTON 190 85 90 30 "Button"))
    (fl_set_object_color obj FL_COL1 FL_GREEN)
    (set! obj (fl_add_crossbutton FL_PUSH_BUTTON 190 55 80 30 "Button"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 125 10 65 25 "Exit"))
    (set! cbform_bexit obj)
    (fl_end_form)
    (fl_set_border_width oldbw)
    form))

(newbutton)
