;/*
; * popup tester
; *
; * This file is part of xforms package
; * T.C. Zhao and Mark Overmars
; */
(require 'forms)
; JL : BUG - menu and pup callback interference !
; JL : BUG fixed 

(define fd_pupform '())
(define fd_menu '())
(define fd_button '())
(define fd_choice '())
(define fd_status '())
(define fd_done_cb '())

(define (popup . args)
  (fl_initialize args)
  (set! fd_pupform (create_form_pupform))
  ; /* fill-in form initialization code */
  (init_menu fd_menu)
  (init_choice fd_choice)
  ; /* show the first form */
  (fl_show_form fd_pupform FL_PLACE_CENTER FL_FULLBORDER "pupform")
  (fl_do_forms)
  (fl_finish)
  (exit 0)
  0)

;/********* MENU ***********************************************/

(define (menu_callback ob data)
  (let ((buf
	 (string-append
	  "item "
	  (number->string (fl_get_menu ob))
	  " ("
	  (fl_get_menu_text ob)
	  ") selected")))
    (fl_set_object_label fd_status buf)))

;/** menu initialization entries. No callbacks for the item */
(define menu_entries
  (list (list "Menu Item1" )
	(list "Menu Item2" )
	(list "_Menu Item3")
	(list "/_Menu Item 4")
	(list "Menu Item 5" )
	(list "Menu Item 6" )
	(list "Menu Item 7" )
	(list "Menu Item 8" )
	(list 0)
	(list "Menu Item10")
	(list "menu Item11")
	(list 0)))

(define (menuitem_entercb n data)
  (let ((buf
	 (string-append 
	  "Entered "
	  (number->string n)
	  " ("
	  (fl_get_menu_item_text fd_menu n)
	  ")")))
    (fl_set_object_label fd_status buf)))

(define (init_menu menu)
  ;/* if no entercb is desired, set_menu_entries is much simpler */
  (if (= 0 FL_TRUE)
      (fl_set_menu_entries menu menu_entries)
      (let ((n (fl_newpup (fl_winget)))) ; 0 ; (else)
	(fl_setpup_entries n menu_entries)
	(fl_setpup_entercb n menuitem_entercb 0);  fd_menu)
	(fl_setpup_bw n -2)
	(fl_set_menu_popup menu n))))

;/*********** End of menu *************************/

;/******* PopUP ***********************************/

(define pupID -1)

(define (pupitem_cb selected)
  (let ((buf
	 (string-append
	  "Item "
	  (number->string selected)
	  " ("
	  (fl_getpup_text pupID selected)
	  ") selected")))
    (fl_set_object_label fd_status buf)
    selected))

(define pup_entries
  (list (list "Popup Item1" pupitem_cb "1" FL_PUP_RADIO)
	(list "Popup Item2" pupitem_cb "2" FL_PUP_RADIO)
	(list "Popup Item3" pupitem_cb "3" FL_PUP_RADIO)
	(list "/Popup Item 4" pupitem_cb)
	(list "Popup Item 5" pupitem_cb)
	(list "Popup Item 6" pupitem_cb)
	(list "Popup Item 7" pupitem_cb)
	(list "Popup Item 8" pupitem_cb)
	(list 0)
	(list "Popup Item10" pupitem_cb "" FL_PUP_GRAY)
	(list "Popup Item11" pupitem_cb)
	(list 0)))


(define (pup_entercb n data)
  (let ((buf 
	 (string-append
	  "Entered "
	  (number->string n)
	  " ("
	  (car (list-ref pup_entries (- n 1)))
	  ")")))
    (fl_set_object_label fd_status buf)))

(define (dopup_callback ob data)
  (if (< pupID 0)
      (begin
	(set! pupID (fl_newpup (fl_winget))) ; 0
        (fl_setpup_entries pupID pup_entries)
        (fl_setpup_entercb pupID pup_entercb 0)))
  ;/* since each item has its own callback, ignore the return value */
  (fl_dopup pupID))

;/********* End of pup *****************/ 

(define (init_choice ob)
  (fl_addto_choice ob "Choice1|Choice2|Choice3")
  (fl_addto_choice ob "Choice4|Choice5|Choice6")
  (fl_addto_choice ob "Choice7|Choice8|Choice9"))

(define (choice_callback ob data)
  (let ((buf
	 (string-append
	  (number->string (fl_get_choice ob))
	  " ("
	  (fl_get_choice_text ob)
	  ") selected")))
    (fl_set_object_label fd_status buf)))

;/* Form definition file generated with fdesign. */

(define (create_form_pupform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  320  250))
    (set! obj (fl_add_box FL_UP_BOX 0 0 320 250 ""))
    (set! obj (fl_add_menu FL_PULLDOWN_MENU 20 95 60 20 "Menu"))
    (set! fd_menu obj)
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_callback obj  menu_callback 0)
    (set! obj (fl_add_button FL_MENU_BUTTON 100 90 75 30 "Button"))
    (set! fd_button obj)
    (fl_set_object_callback obj  dopup_callback  0)
    (fl_set_object_shortcut obj  "#BB"  1)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE2 195 90 105 30 ""))
    (set! fd_choice obj)
    (fl_set_object_callback obj choice_callback  0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 25 30 265 30 ""))
    (set! fd_status obj)
    (fl_set_object_boxtype obj FL_FRAME_BOX)
    (fl_set_object_lalign obj FL_ALIGN_CENTER)
    (fl_set_object_dblbuffer obj  1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 210 200 85 30 "Done"))
    (set! fd_done_cb obj)
    (fl_end_form)
    (fl_adjust_form_size form)
    form))

;/*---------------------------------------*/

(popup)