;/*
; * This demo shows the use of a positioner with XOR drawmode, most
; * useful for overlaying positioner on top of other object
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars  1997
; */

(require `forms)

(define xval `())
(define yval `())

;/* callback routine */
(define (positioner_cb ob q)
  (let ((str1 (number->string (fl_get_positioner_xvalue ob)))
	(str2 (number->string (fl_get_positioner_yvalue ob)))
	(str ""))
    (set! str (if (> (string-length str1) 8)
		  (substring str1 0 8)
		  str1))
    (fl_set_object_label xval str)
    (set! str (if (> (string-length str2) 8)
		  (substring str2 0 8)
		  str2))
    (fl_set_object_label yval str)))

(define (positionerXOR . args)
  (let ((form `())
	(pos `())
	(button `())
	(ob `()))
    ;
    (fl_set_border_width -2)
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 350 250))
    ;
    (set! ob (fl_add_pixmap FL_NORMAL_PIXMAP  60  70  100  100  ""))
    (fl_set_object_boxtype ob  FL_DOWN_BOX)
    (fl_set_pixmap_file ob  "porsche.xpm")
    ;
    (set! pos (fl_add_positioner FL_OVERLAY_POSITIONER 60 70 100 100 ""))
    ;
    (fl_set_positioner_xbounds pos 0 1)
    (fl_set_positioner_ybounds pos 0 1)
    (fl_set_object_callback pos positioner_cb 0)
    (set! xval (fl_add_box FL_DOWN_BOX 230 40 100 30 ""))
    (set! yval (fl_add_box FL_DOWN_BOX 230 90 100 30 ""))
    (fl_set_object_color xval FL_COL1 FL_COL1)
    (fl_set_object_color yval FL_COL1 FL_COL1)
    (set! button (fl_add_button FL_NORMAL_BUTTON 230 200 100 30 "Exit"))
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "XOR Positioner")
    ;
    (positioner_cb pos 0)
    (fl_do_forms)
    (fl_hide_form form)
    ;
    0))

(positionerXOR)
