;; Demo for scaling forms. 

; JL : BUG - exits when rescaling smaller, scaling large does not work
; JL : BUG fixed

(require 'forms)
(require 'logical)

(define form 0)
(define smallerobj 0)
(define largerobj 0)
(define scaleobj 0)
(define exitobj 0)
(define obj 0)
(define ui 0)

(define (create_form_form)
  (set! form (fl_bgn_form fl_no_box 470 370))
  (set! obj (fl_add_box fl_up_box 0 0 470 370 ""))
  (set! obj (fl_add_box fl_shadow_box 30 30 410 70 "Scaling Forms"))
  (fl_set_object_color obj 9 47)
  (fl_set_object_lsize obj 16)
  (set! obj (fl_add_button fl_normal_button 30 220 130 40 "Smaller"))
  (set! smallerobj obj)
  (set! obj (fl_add_button fl_normal_button 310 220 130 40 "Larger"))
  (set! largerobj obj)
  (set! obj (fl_add_input fl_float_input 170 140 270 40 "Scale:"))
  (set! scaleobj obj)
  (set! obj (fl_add_button fl_normal_button 310 300 130 40 "Exit"))
  (set! exitobj obj)
  (fl_end_form)
  form)

(define sc 0)
(define oldsc 0)

(define (rescale . args)
  (fl_initialize args)
  (set! form (create_form_form))
  (set! sc 1.00)
  (fl_set_input scaleobj (number->string sc))
  (fl_show_form form (logior fl_place_center fl_free_size)  
		fl_fullborder  "Scaling")

; (fl_show_form ui (logior fl_place_center fl_free_size)  
;		fl_fullborder  "Scaling")
  
  (letrec ((loop
	    (lambda ()
	      (set! oldsc sc)
	      (set! obj (fl_do_forms))
	      (if (equal? obj smallerobj) (set! sc (* sc 0.8)))
	      (if (equal? obj largerobj)  (set! sc (* sc (/ 1 0.8))))
	      (if (equal? obj scaleobj)   
		  (if (number? (string->number (fl_get_input scaleobj)))
		      (set! sc (string->number 
				(fl_get_input scaleobj)))))
	      (if (< sc 0.50) (set! sc 0.50))
	      (if (> sc 3)    (set! sc 3))
	      (if (not (= sc oldsc))
		  (begin
		    (fl_scale_form form  
				   (/ sc oldsc)  
				   (/ sc oldsc))
		    (fl_set_input scaleobj (number->string sc))
		    )) 
	      (fl_redraw_form form)
	      (if  (equal? obj exitobj) 
		   #t
		   (loop)))))
    (loop))
  (fl_hide_form form)
  #t)

(rescale)


