;/*
; * timer routine tester
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars (1997)
; */
(require 'forms)

;/**** Callback routines ****/

;/**** Forms and Objects ****/

(define fd_timerform '())
(define fd_timer '())
(define fd_down '())

(define BigT 80) ; JL : t == #t in Scheme

;/* callbacks for form timerform */
(define (suspend_resume ob data)
  (if (= data FL_TRUE)
      (fl_resume_timer fd_timer)
      (fl_suspend_timer fd_timer)))

(define (reset ob data)
  (fl_set_timer fd_timer BigT))

(define (timer_direction ob data)
  (fl_set_timer_countup fd_timer data))

(define (expired ob data)
  (if (= (fl_show_question "Expired!\n\nQuit ?" 0) FL_TRUE)
      (begin
	(fl_finish)
	(exit 0))
      (fl_set_timer fd_timer BigT)))

(define (timer . args)
  (fl_set_border_width -2)
  ;
  (fl_initialize args)
  (set! fd_timerform (create_form_timerform))
  ;/* fill-in form initialization code */
  (fl_set_timer fd_timer BigT)
  (fl_set_button fd_down 1)
  ;/* show the first form */
  (fl_show_form fd_timerform FL_PLACE_CENTER FL_FULLBORDER "timerform")
  (fl_do_forms)
  (fl_finish)
  (exit 0))

;/* Form definition file generated with fdesign. */

(define (create_form_timerform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  290  210))
    (set! obj (fl_add_box FL_UP_BOX 0 0 290 210 ""))
    (set! obj (fl_add_frame FL_UP_FRAME 0 0 290 94 ""))
    (set! obj (fl_add_frame FL_UP_FRAME 0 100 330 190 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 100 170 80 30 "Done"))
    (set! obj (fl_add_timer FL_VALUE_TIMER 20 30 180 40 "Timer"))
    (set! fd_timer obj)
    (fl_set_object_boxtype obj FL_UP_BOX)
    (fl_set_object_lsize obj FL_MEDIUM_SIZE)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (fl_set_object_lstyle obj FL_TIMES_STYLE)
    (fl_set_object_callback obj expired 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 120 80 30 "Suspend"))
    (fl_set_object_callback obj suspend_resume 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 100 120 80 30 "Resume"))
    (fl_set_object_callback obj suspend_resume 1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 180 120 80 30 "Reset"))
    (fl_set_object_callback obj reset 0)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 220 20 70 30 "Down"))
    (set! fd_down obj)
    (fl_set_object_callback obj timer_direction 0)
    (set! obj (fl_add_checkbutton FL_RADIO_BUTTON 220 50 70 30 "Up"))
    (fl_set_object_callback obj timer_direction 1)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(timer)