;/*
; * Test the accuracy of timer
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars  (1997)
; */

(require 'forms)

;/**** Forms and Objects ****/

(define fd_form0 '())
(define fd_ldata '())
(define fd_timer '())
(define fd_restart '())
(define fd_report '())

(define (exit_cb ob data)
  (fl_finish)
  (exit 0))

(define start_sec 0)
(define start_usec 0)
(define end_sec 0)
(define end_usec 0)

;/* timer expired */
(define (timer_cb ob data)
  (let* ((timerval (* fd_ldata 0.001))
	 (gt (fl_gettime))
	 (e_s (car gt))
	 (e_us (cadr gt))
	 (df (+ e_s (* start_sec -1) (* (- e_us start_usec) 1.e-6)))
	 (buf
	  (string-append
	   "Timeout:"
	   (number->string timerval)
	   "  Actual:"
	   (number->string df)
	   "  DeltaE=" ; JL : string not cut
	   (number->string (- df timerval)))))
    (set! end_sec e_s)
    (set! end_usec e_us)
    (fl_set_object_label fd_report buf)))

(define (start_timer ob data)
  (set! fd_ldata (+ fd_ldata 200))
  (let* ((buf 
	  (string-append 
	   "Timer accuracy testing "
	   (number->string (* fd_ldata 0.001))
	   " sec..."))
	 (gt (fl_gettime))
	 (s_s (car gt))
	 (s_us (cadr gt)))
    (fl_set_object_label fd_report buf)
    (set! start_sec s_s)
    (set! start_usec s_us)
    (fl_set_timer fd_timer (* fd_ldata 0.001))))

(define (timerprec . args)
  (fl_initialize args)
  (set! fd_form0 (create_form_form0))
  ; /* fill-in form initialization code */
  (set! fd_ldata 2800)
  (start_timer fd_timer 0)
  ;/* show the first form */
  (fl_show_form fd_form0 FL_PLACE_CENTER FL_FULLBORDER "form0")
  (fl_do_forms)
  0)

;/* Form definition file generated with fdesign. */

(define (create_form_form0)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  320  250))
    (set! obj (fl_add_box FL_UP_BOX 0 0 320 250 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 210 200 90 35 "Done"))
    (fl_set_object_callback obj exit_cb 0)
    (set! obj (fl_add_button FL_TOUCH_BUTTON 110 200 90 35 "ReStart"))
    (set! fd_restart obj)    
    (fl_set_object_callback obj start_timer 0)
    (set! obj (fl_add_timer FL_HIDDEN_TIMER 10 40 100 40 "Timer"))
    (set! fd_timer obj)    
    (fl_set_object_callback obj timer_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 40 100 250 50 ""))
    (set! fd_report obj)
    (fl_end_form)
    (fl_scale_form form 0.9 0.9)
    form))

;/*---------------------------------------*/

(timerprec)
