;/* Demo showing object gravity, form minsize etc. (also double click). 
; *
; * With some more work, this could be made into a useful program ...
; *
; */
(require 'forms)
(require 'struct)

(define WWW_BROWSER -1)

(if (equal? (software-type) 'vms)
    (set! WWW_BROWSER "mosaic")
    (set! WWW_BROWSER "mosaic_dir:mosaic"))

(set! WWW_BROWSER "netscape") ; JL : sorry, no mosaic

;/* Header file generated with fdesign. */

(define-record fdui
  (www
   vdata
   ldata
   listbr
   cat
   file
   shown
   ))

(define ui (make-fdui 0 0 0 0 0 0 0))
(define show_sites 1)

;/* Application program begins */
(define MAX_SITES 30)

;/* real program should have these on disks */
(define www_sites
  '(
    (
     "XForms App." 
     ( 
      ("@b@C4XForms Home Page" 
       "http://bragg.phys.uwm.edu/xforms")
      ("UnixCockpit - File Manager" 
       "ftp://ftp.uni-wuppertal.de/pub/unix/cockpit")
      ("xfmail - mailer " 
       "http://Burka.NetVision.net.il/xfmail/xfmail.html")
      ("XRPlay - RPlay audio" 
       "ftp://ftp.sdsu.edu/pub/rplay")
      ("Lyx - LaTeX Frontend" 
       "http://www.lehigh.edu/~dlj0/LyriX.html")
      ("XWatch - Sys Monitor" 
       "http://www.icce.rug.nl/docs/programs/xwatch/xwatch.html")
      ("xamixer - Sound mixer" 
       "ftp://sunsite.unc.edu/pub/Linux/apps/sound/mixers")
      ("pyxforms - A Python binding to xforms" 
       "ftp://ultra7.unl.edu.ar/pub/pyxforms")
      ("xirc - An IRC client with GUI"  
       "http://www.bitgate.com/xirc")
      ("xdata - An appointment manager" 
       "ftp://jurassic.upr.clu.edu/pub/xforms")
      ("xfmixer - Audio mixer" 
       "http://linux.ms.mff.cuni.cz/~rdou3187/xfmix/xfmix.html")
      ("CaXmix - Audio mixer" 
       "http://synergy.caltech.edu/~john/programs.html")
      ))
    (
     "X related" 
     (
      ("@b@C4XForms Home Page" 
       "http://bragg.phys.uwm.edu/xforms")
      ("X Journal"  
       "http://landru.unx.com/SIGS/TXJ/docs/txjhome.html")
      ("X Archive Site" 
       "ftp://ftp.x.org") 
      ("OpenGL and X"  
       "http://www.sgi.com/Technology/openGL/opengl.html")
      ))

    ;/* useful FAQS */
    (
     "All FAQs" 
     (
      ("Usenet FAQs"  
       "http://www.cis.ohio-state.edu/hypertext/faq/usenet")
      ))
    ;/* Sports related www sites */
    (
     "Sports" 
     (
      ("SatchelSports" 
       "http://www.starwave.com/SatchelSports.html") 
      ("Game Recap"  
       "http://www.starwave.com/SatchelSports.html") 
      ("Patricia's NBA Daily News" 
       "http://www.primenet.com/~terra/news.html") 
      ("Houston Rockets" 
       "http://hyrax.med.uth.tmc.edu/misc/rockets.html")
      ))
    ;/* money */
    (
     "Financial" 
     (
      ("@f Holt Report" 
       "ftp://ftp.netcom.com/pub/ge/geoholt/holt_rpt.htm")
      ))
    (
     "Travel" 
     (
      ("New York" 
       "http://www.panix.com/clay/nyc.html")
      ))
    ;/* things that do not belong to any of the above */
    (
     "Misc" 
     (
      ("Star Trek: Voyager" 
       "http://voyager.paramount.com")
      ("Linux Journal"  
       "http://www.ssc.com/lj/mags.html")
      ))
    (
     ; JL : something completely different (?) 
     "Scheme"
     (
      ("SCM 5b2 - a scheme interpreter"
       "ftp-swiss.ai.mit.edu:pub/scm/scm5b2.tar.gz") 
      ("SCM documentation"
       "http://www-swiss.ai.mit.edu/~jaffer/SCM.html")
      ("SLIB 2b3 - a portable scheme library"
       "ftp-swiss.ai.mit.edu:pub/scm/slib2b3.tar.gz")
      ))
    ;/* sentinel */
    ( 
     ; JL : display contents of $HOME directory
     "Test"
     (
      ("Testfile"
       "file:$HOME") 
      ; 127.0.0.1
       ))
    ))


;/* initialize and show how many categories we have got */
(define (init_cat)
  (map (lambda (we)
	 (fl_addto_choice (fdui->cat ui) (car we))) ; add cat
       www_sites))

;/* initialize file menu */
(define (init_file_menu)
  (fl_fit_object_label (fdui->file ui) 1 0)
  (fl_addto_menu (fdui->file ui) "Save|Load|Quit"))

;/* initialize sites given category cat */
(define (init_sites cat)
  (if (<= cat 0)
      '()
      (begin
	;/* cat changed. Update sites */
	(fl_freeze_form (fdui->www ui))
	(fl_clear_browser (fdui->listbr ui))
	(map (lambda (ws)
	       (fl_addto_browser (fdui->listbr ui)
				 (list-ref ws (- show_sites 1))))
	     (cadr (list-ref www_sites (- cat 1))))
	(fl_unfreeze_form (fdui->www ui)))))


;/* new catogrey is selected */
(define (change_cat ob data)
  (init_sites (fl_get_choice ob)))

;/* we can show either the subject a site carries or the site name*/
(define (init_shown)
  (fl_addto_choice (fdui->shown ui) "Subject|Sites"))

;/* request a change of what is shown, site name or subject */ 
(define (change_shown ob data)
(display "change_shown\n");
  (let ((oldshow show_sites))
    (set! show_sites (fl_get_choice ob))
    (if (not (= show_sites oldshow)) 
	(init_sites (fl_get_choice (fdui->cat ui))))))

;/* file menu is selected. Currently we do nothing except exit */ 
(define (do_file_menu ob data)
  (if (= (fl_get_menu ob) 3)
      (begin
        (fl_end_all_command)
        (exit 1))
      (fl_show_alert "Sorry" "Not implemented yet" ""  0)))

;/* give category, cat, and the line no. within the browser, get sitename*/
(define (get_site cat thesite)
  (cadr (list-ref (cadr (list-ref www_sites (- cat 1))) (- thesite 1))))

;/* either double-clicked or connect button is pressed */
(define (connect_cb ob data)
  (if (not (= (fl_get_object_vdata ob) 100))
      (begin
	(display "something is wrong: ")
	(display (fl_get_object_vdata ob) )
	(newline))
      (let ((i (fl_get_browser (fdui->listbr ui))))
	(if (> i 0)
	    (begin
	      (fl_set_cursor (fl_get_object_window (fdui->listbr ui))
			     150) ; JL : XC_watch
	      (fl_flush) ; JL : (XFlush (fl_get_display))
	      (let ((cmdbuf
		     (string-append WWW_BROWSER " "
				    (get_site 
				     (fl_get_choice (fdui->cat ui)) i))))
		; JL : (display cmdbuf)
		(if (< (fl_exe_command cmdbuf 0) 0)
		    (display (string-append "Error running " cmdbuf "\n")))
		(fl_reset_cursor (fl_get_object_window 
				  (fdui->listbr ui)))))))))

(define (change_sites ob data)
  ;/* no-op */
  '())

(define (wwwl . args)
  (fl_initialize args)
  ;
  (set-fdui-www! ui (create_form_www))
  ;/* some basic resizing policy */
  (fl_set_form_minsize (fdui->www ui) 320 330)
  (init_file_menu)
  (init_cat)
  (init_sites 1)
  (init_shown)
  (fl_set_object_vdata (fdui->listbr ui) 100)
  (fl_set_browser_dblclick_callback (fdui->listbr ui) connect_cb  0)
  ;
  (fl_show_form (fdui->www ui) (logior FL_PLACE_CENTER FL_FREE_SIZE)
		FL_FULLBORDER  "www launcher")
  (fl_do_forms)
  (fl_end_all_command)
  (fl_finish)
  0)

(define (create_form_www)
  (let ((obj '())
	(form '())
	(old_bw (fl_get_border_width))) 
    (fl_set_border_width -3)
    (set! form (fl_bgn_form FL_NO_BOX  371  331))
    (set! obj (fl_add_box FL_UP_BOX 0 0 371 331 ""))
    (set! obj (fl_add_frame FL_UP_FRAME 3 2 365 25 ""))
    (fl_set_object_gravity obj  FL_North  FL_North)
    (set! obj (fl_add_browser FL_HOLD_BROWSER 20 90 250 220 ""))
    (set-fdui-listbr! ui obj)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_gravity obj  FL_NorthWest  FL_SouthEast)
    (fl_set_object_callback obj change_sites 0)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE 20 50 112 25 ""))
    (set-fdui-cat! ui obj)
    (fl_set_object_gravity obj  FL_North  FL_North)
    (fl_set_object_callback obj change_cat 0)
    (set! obj (fl_add_menu FL_PULLDOWN_MENU 15 5 42 20 "File"))
    (set-fdui-file! ui obj)
    (fl_set_object_shortcut obj "Ff#f" 1)
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_gravity obj  FL_NorthWest  FL_NorthWest)
    (fl_set_object_callback obj do_file_menu 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 280 280 75 30 "Done"))
    (fl_set_button_shortcut obj "#Dd]" 1)
    (fl_set_object_gravity obj  FL_SouthEast  FL_SouthEast)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 280 90 75 30 "Connect"))
    (fl_set_button_shortcut obj "C#cc" 1)
    (fl_set_object_gravity obj  FL_NorthEast  FL_NorthEast)
    (fl_set_object_callback obj connect_cb 0)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE 156 50 112 25 ""))
    (set-fdui-shown! ui obj)
    (fl_set_object_gravity obj  FL_North  FL_North)
    (fl_set_object_callback obj change_shown 0)
    (fl_end_form)
    (fl_set_border_width old_bw)
    form))

;/*---------------------------------------*/

(wwwl)