;/* test screen/world conversion in addition to showing the xyplot styles */
(require `logical)
(require `forms)

(define fxyplot #f)
(define xyplot '())

(define x (make-array 0 6 21))
(define y (make-array 0 6 21))


(define xytype 
  (list
   (list FL_NORMAL_XYPLOT "FL_NORMAL_XYPLOT" FL_BLACK)
   (list FL_SQUARE_XYPLOT "FL_SQUARE_XYPLOT" FL_RED)
   (list FL_CIRCLE_XYPLOT "FL_CIRCLE_XYPLOT" FL_GREEN)
   (list FL_POINTS_XYPLOT "FL_POINTS_XYPLOT" FL_BLUE)
   (list FL_DASHED_XYPLOT "FL_DASHED_XYPLOT" FL_INDIANRED)
   (list FL_FILL_XYPLOT   "FL_FILL_XYPLOT"   FL_SLATEBLUE)
    ))

(define (done_xyplot ob q)
  (fl_hide_form fxyplot)
  (exit 0))


(define (post ob ev mx my key xev) ; JL : changed 
  (if (or (= ev FL_PUSH)
	  (= ev FL_MOUSE))
      (let* ((s2w (fl_xyplot_s2w ob mx my))
	     (wx (car s2w))
	     (wy (cadr s2w))
	     (buf
	      (string-append
	       "x=" 
	       (substring (string-append (number->string mx) "    ") 0 4) 
	       " y=" 
	       (substring (string-append (number->string my) "    ") 0 4) 
	       " wx=" 
	       (substring (string-append (number->string wx) "    ") 0 4) 
	       " wy=" 
	       (substring (string-append (number->string wy) "    ") 0 4)))
	     (op (fl_get_object_position ob))
	     (obx (car op))
	     (oby (cadr op))
	     (wp (fl_get_win_geometry (fl_objwin ob)))
	     (wx (car wp))
	     (wy (cadr wp)))
	(fl_show_oneliner buf (+ obx wx 5) (+ oby wy))
	;(fl_object_ps_dump ob "test.ps") 
	(fl_set_object_wantkey ob FL_KEY_ALL) ; JL : added as extra fct
	(fl_set_object_input ob 1)            ; JL : added as extra fct
	)
      (if (= ev FL_RELEASE)
	  (fl_hide_oneliner)
	  (if (= ev FL_KEYBOARD) ; does not work
	      (display (string-append "key=" (number->string key) "\n") 
		       (default-output-port)))))
  0)

(define (xyplotall . args)
  (fl_initialize args)
  (create_form_xyplot)
  ;/* make sure double buffer also works */
  (fl_set_object_dblbuffer (list-ref xyplot 0) 0)
  (fl_set_object_dblbuffer (list-ref xyplot 1) 0)
  (fl_set_object_dblbuffer (list-ref xyplot 2) 0)
  ;
  (map (lambda (i)
	 (let ((xyplot_i (list-ref xyplot i))
	       (xij '())
	       (yij '())
	       (cx 0))
	   (map (lambda (j)
		  (set! cx (+ (/ (* j 3.1415) 10) 0.2))
		  (set! xij (append xij (list cx)))
		  (set! yij (append yij (list
					 (+ (sin (* 2 cx))
					    (cos cx))))))
		(list  0  1  2  3  4  5  6  7  8  9 10
		       11 12 13 14 15 16 17 18 19 20))
	   ;
         (fl_set_xyplot_data xyplot_i  xij yij 21 "TestTitle"
			     "X-axis" "Y|axis")
	 ;
         (if (= i 0)
	     (fl_add_xyplot_text xyplot_i  (list-ref xij 15)  0.1
				 "@2->" FL_ALIGN_TOP FL_BLUE)
	     (fl_add_xyplot_text xyplot_i  (list-ref xij 8)  1.4
				 "Text Inset" FL_ALIGN_CENTER FL_BLUE))
	 ;
         (if (= i 3)
	     (begin
	       (fl_set_xyplot_xgrid xyplot_i FL_GRID_MAJOR)
	       (fl_set_xyplot_xgrid xyplot_i FL_GRID_MINOR))
	     (if (= i 0)
		 (begin
		   (fl_set_xyplot_xtics xyplot_i  7 2)
		   (fl_set_xyplot_xbounds xyplot_i 6.0 0.0))
		 (if (= i 1)
		     (begin
		       (fl_set_xyplot_ytics xyplot_i  5 2)
		       (fl_set_xyplot_ybounds xyplot_i 2.4 -2.4))
		     )))
	 ;
         (fl_set_object_posthandler xyplot_i post)
	 ))
       (list 0 1 2 3 4 5))
  (fl_show_form fxyplot FL_PLACE_ASPECT FL_TRANSIENT "XYplot")
  (letrec ((loop (lambda ()
		   (and (fl_do_forms)
			(loop)))))
    (loop))
  0)

  (define (tnc i) (list-ref xytype i))
  (define (xy_type i) (list-ref (tnc i) 0))
  (define (xy_name i) (list-ref (tnc i) 1))
  (define (xy_color i) (list-ref (tnc i) 2))

(define (create_form_xyplot)
  (let ((obj '())
	(dx 180)
	(dy 160))
    (if (not fxyplot)
	(begin
	  (set! fxyplot (fl_bgn_form FL_NO_BOX 570 430))
	  (set! obj (fl_add_box FL_UP_BOX 0 0 570 430 ""))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 0) 20 40 dx dy (xy_name 0)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 0));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 1) 200 40 dx dy (xy_name 1)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 1));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 2) 380 40 dx dy (xy_name 2)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 2));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 3) 20 210 dx dy (xy_name 3)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 3));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 4) 200 210 dx dy (xy_name 4)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 4));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_xyplot (xy_type 5) 380 210 dx dy (xy_name 5)))
	  (fl_set_object_lsize obj  FL_TINY_SIZE)
	  (fl_set_object_color obj  FL_COL1  (xy_color 5));
	  (set! xyplot (append xyplot (list obj)))
	  ;
	  (set! obj (fl_add_button FL_NORMAL_BUTTON 230 390 100 30 "Exit"))
	  (fl_set_object_callback obj  done_xyplot  0)
	  ;
	  (set! obj (fl_add_text FL_NORMAL_TEXT 180 15 240 30 "FL_XYPLOT"))
	  (fl_set_object_lcol obj  FL_SLATEBLUE)
	  (fl_set_object_lsize obj  FL_HUGE_SIZE)
	  (fl_set_object_lstyle obj  (logior FL_BOLD_STYLE FL_EMBOSSED_STYLE))
	  (fl_set_object_boxtype obj  FL_FLAT_BOX)
	  (fl_end_form)))))

(xyplotall)


