;/*
; * Demo showing the use of xyplot overlay, plot key and
; * PostScript output. 
; *
; *  This file is part of xforms package
; *  T.C. Zhao and M. Overmars
; */
(require 'forms)

;/**** Forms and Objects ****/
(define fd_fff '())
(define fd_xyplot '())

(define (xyplotover . args)
  (fl_initialize args)
  (set! fd_fff (create_form_fff))
  ;/* fill-in form initialization code */
  (init_xyplot fd_fff)
  ;/* show the first form */
  (fl_show_form fd_fff FL_PLACE_MOUSE FL_TRANSIENT "XYPlot Overlay")
  (fl_do_forms)
  (if (>= (fl_object_ps_dump fd_xyplot "test.ps") 0)
      (display "PostScript output test.ps written\n"))
  (fl_finish)
  (exit 0))

(define (init_xyplot fff)
  (let ((i 0)
	(xx '())
	(yy '()))
    (letrec ((init_xy (lambda (i)
			(if (<= i 10)
			    (begin
			      (set! xx (append xx (list i)))
			      (set! yy (append yy (list
						   (exp (* -1
							   (- i 5) ; xx[i]
							   (- i 5)
							   (/ 1 8))))))
			      (init_xy (+ i 1)))))))
      (init_xy 0))
    (fl_set_xyplot_data fd_xyplot xx yy 8 "Plot Title"  "X-Axis"  "Y|Axis")
    (fl_set_xyplot_ybounds fd_xyplot  0  1.1)
    (fl_set_xyplot_xbounds fd_xyplot  0  10)
    (fl_add_xyplot_overlay fd_xyplot  1  xx  yy  11  FL_YELLOW)
    (fl_set_xyplot_overlay_type fd_xyplot  1  FL_LINEPOINTS_XYPLOT)
    (fl_set_xyplot_interpolate fd_xyplot  1  2  0.1)

    (fl_add_xyplot_text fd_xyplot  0.5  1.0  "Gaussian\nDistribution" 
			FL_ALIGN_RIGHT  FL_WHITE)

    (fl_set_xyplot_key fd_xyplot  0  "Original")
    (fl_set_xyplot_key fd_xyplot  1  "Overlay")
    (fl_set_xyplot_key_position fd_xyplot  9.8  1.08  FL_ALIGN_BOTTOM_LEFT)
    ))

(define (create_form_fff)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX 370 310))
    (set! obj (fl_add_box FL_UP_BOX  0  0  370  310  ""))
    (set! obj (fl_add_xyplot FL_IMPULSE_XYPLOT  10  20  350  260  
			     "An XYPlot with overlay"))
    (set! fd_xyplot obj)    
    (fl_set_object_lalign obj  (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_lsize obj  FL_NORMAL_SIZE)
    (fl_set_object_boxtype obj  FL_DOWN_BOX)
    (fl_set_object_color obj  FL_BLACK  FL_GREEN)
    (set! obj (fl_add_button FL_HIDDEN_BUTTON  10  10  350  290  ""))
    (fl_set_button_shortcut obj "qQ"  0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(xyplotover)