;;; function plotting

(require `forms)

(define fplot_form '())
(define fplot_status '())
(define fplot_xyplot '())
(define fplot_resolution 100)
(define fplot_function sin)
(define fplot_minx -1)
(define fplot_maxx 1)

(define (done_fplot ob q)
  (fl_hide_form fplot_form)
  (exit 0))

;/* callbacks for form afpform */
(define (fplot_cb ob data)
  (let* ((fp (fl_get_xyplot ob))
	 (x (car fp))
	 (y (cadr fp))
	 (i (caddr fp)))
    (if (not (< i 0))
	(fl_set_object_label fplot_status 
			     (string-append 
			      "X="
			      (substring 
			       (string-append (number->string x) "    ")
			       0 4)
			      " Y="
			      (substring 
			       (string-append (number->string y) "    ")
			       0 4)))
	)))

(define (fplot_interpolate_cb ob data)
  (fl_set_xyplot_interpolate fplot_xyplot 0 
                             (if (= (fl_get_button ob) FL_TRUE)
                                 3 0)
                             0.2)) ; JL : adapt

(define (fplot_resolution_cb ob f)
  (fl_clear_xyplot fplot_xyplot)
  (set! fplot_resolution (fl_get_slider_value ob))
  (let* ((xy (make-fplot-data fplot_function fplot_minx fplot_maxx))
	 (xs (reverse (car xy)))
	 (ys (reverse (cdr xy)))
	 (i (- (length xy) 1))) ; JL : ?
    (fl_set_xyplot_data fplot_xyplot xs ys i "Fplot" "X axis" "Y axis")))

(define (make-fplot-data f minx maxx)
  (letrec ((loop 
	    (lambda (i xl yl)
	      (if (>= i maxx)
		  (cons xl yl)
		  (loop (+ i (/ (- maxx minx) fplot_resolution)) 
			(cons i xl) (cons (f i) yl))))))
    (loop minx '() '())))

(define (fplot f minx maxx . args)
  (let* ((xy (make-fplot-data f minx maxx))
	 (xs (reverse (car xy)))
	 (ys (reverse (cdr xy)))
	 (i (- (length xy) 1))) ; JL : ?
    ;
    (set! fplot_function f)
    (set! fplot_minx minx)
    (set! fplot_maxx maxx)
    (fl_initialize args)
    (create_form_afpform)
    ; /* fill-in form initialization code */
    (fl_set_object_dblbuffer fplot_status 1)
    (fl_set_xyplot_data fplot_xyplot xs ys i "Fplot" "X axis" "Y axis")
    (fl_set_xyplot_linewidth fplot_xyplot 0 2)
    (fl_set_xyplot_xgrid fplot_xyplot FL_GRID_MINOR)
    ;
    ; /* show the first form */
    (fl_show_form fplot_form FL_PLACE_MOUSE FL_TRANSIENT "function plotting")
    (fl_do_forms)
    (fl_finish)
    0))

(define (create_form_afpform)
  (let ((obj '()))
    (set! fplot_form (fl_bgn_form FL_NO_BOX  431  301))
    (set! obj (fl_add_box FL_UP_BOX 0 0 431 301 ""))
    (set! obj (fl_add_xyplot FL_NORMAL_XYPLOT 20 50 285 235 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_color obj FL_BLACK FL_GREEN)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_xyplot_inspect obj FL_TRUE)
    (fl_set_object_callback obj fplot_cb 0)
    (set! fplot_xyplot obj)
    (set! obj (fl_add_box FL_BORDER_BOX 45 15 170 25 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (set! fplot_status obj)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 40 80 25 "Interpolate"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj fplot_interpolate_cb 0)
    (set! obj (fl_add_slider FL_HOR_SLIDER 315 70 80 25 "Resolution"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_slider_bounds obj 10 1000)
    (fl_set_slider_value obj fplot_resolution)
    (fl_set_object_return obj FL_RETURN_END_CHANGED)
    (fl_set_object_callback obj fplot_resolution_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 325 250 90 30 "Done"))
    (fl_end_form)
    #t))

;/*---------------------------------------*/
(fplot sin 0 10)
;(fplot tan (- (/ 3.14 2) 1) (+ (/ 3.14 2) 1))
;(fplot atan -1 1)










