;;; probability 'rain'

(require 'forms)
(require 'random)


(define rain_form '())
(define rain_obj '())
(define slid1_obj '())
(define rain_rnd '())
(define rain_text "")

(define rain_xpm_line1 " . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ")
(define rain_xpm_line2 ". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .")

(define rain_xpm 
  (list
    "109 109 2 1"
    " 	c #FFFFFFFFFFFF"
    ".	c #000000000000"
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1 rain_xpm_line2 rain_xpm_line1 rain_xpm_line2
    rain_xpm_line1
    ))

(define (init_rnd rx ry)
  (define (rnd)
    (let ((r (random:exp)))
      (if (and (>= r 0) (<= r 1))
	  r
	  (rnd))))
  (define (rnd-x x)
    (if (>= x rx)
	'()
	(cons (rnd) 
	      (rnd-x (+ x 1)))))
  (define (rnd-y y)
    (if (>= y ry)
	'()		     
	(cons (rnd-x 0)
	      (rnd-y (+ y 1)))))
  ;
  (display "Initializing ...")
  (set! rain_rnd (rnd-y 0))
  (display " done.\n"))

(define (rain_dot prob x y)
  (if (< (list-ref (list-ref rain_rnd x) y) prob)
      "." " "))


(define (let_it_rain_down ob data)
  (fl_freeze_form rain_form)
  (let* ((prob (fl_get_slider_value slid1_obj))
	 (pinit (list (car rain_xpm) (cadr rain_xpm) (caddr rain_xpm)))
	 (rsiz (fl_get_object_size rain_obj))
	 (rx (car rsiz))
	 (ry (cadr rsiz)))
    (define (loop-x x y)
      (if (>= x rx)
	  ""
	  (string-append (rain_dot prob x y)
			 (loop-x (+ x 1) y))))
    (define (loop-y y)
      (if (>= y ry)
	  '()		     
	  (cons (loop-x 0 y)
		(loop-y (+ y 1)))))
    ;
    (set! rain_xpm (append pinit (loop-y 0)))
    (fl_set_pixmap_data rain_obj rain_xpm)
    (fl_set_object_label 
     rain_text 
     (substring (string-append 
		 "Probability : " 
		 (number->string prob)
		 (make-string 8 #\space)) 0 20))
    )
  (fl_unfreeze_form rain_form))
  
(define (rainprb pstring . args)
  (let ((obj '())
	(button '())
	(prob 0.5)
	(eps 3)
	(rbx 100)
	(rby 120)
	(rbw 109)
	(rbh 109))
    (fl_initialize args)
    (init_rnd rbw rbh)
    ;
    (set! rain_form (fl_bgn_form FL_UP_BOX 300 330))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 15 15 270 55 
				 "Probability `rain'"))
    (fl_set_object_lsize obj FL_MEDIUM_SIZE)
    (set! obj (fl_add_text FL_NORMAL_TEXT 20 20 260 45 
			   pstring))
    (fl_set_object_align obj FL_ALIGN_CENTER)
    (set! obj (fl_add_box FL_EMBOSSED_BOX (- rbx eps) (- rby eps)
			  (+ rbw eps eps) (+ rbh eps eps) ""))
    (set! obj (fl_add_pixmap FL_NORMAL_PIXMAP rbx rby rbw rbh ""))
    (fl_set_object_color obj FL_WHITE FL_DIAL_COL2)
    (fl_set_pixmap_data obj rain_xpm)
    (fl_set_object_align obj FL_ALIGN_CENTER)
    (set! rain_obj obj)
    (set! obj (fl_add_valslider FL_VERT_SLIDER (+ rbx rbw 20) (- rby 30) 
				30 (+ rbh 30) "")) 
    (fl_set_slider_value obj prob)
    (fl_set_slider_bounds obj 0.0 1.0)
    (fl_set_object_callback obj let_it_rain_down 0)
    (fl_set_object_return obj FL_RETURN_END_CHANGED)
    (set! slid1_obj obj)
    (set! rain_text (fl_add_box FL_FRAME_BOX 15 240 270 30 
				(string-append "Probability : "
					       (number->string prob)))) 

    (set! button (fl_add_button FL_NORMAL_BUTTON 45 280 210 35 
				"Done"))
    (fl_set_object_lsize button FL_MEDIUM_SIZE)
    (fl_end_form)
    (let_it_rain_down rain_obj 0)
    (fl_show_form rain_form FL_PLACE_MOUSE FL_TRANSIENT 
		  "Probability assessment")
    ;
    (letrec ((loop 
              (lambda ()
                (if (not (equal? (fl_do_forms) button))
                    (loop)
		    (fl_get_slider_value slid1_obj)))))
      (set! prob (loop))
      (fl_hide_form rain_form)
      prob)
    ))

(rainprb 
 (string-append "Select probability represented by\n"
		"amount of black color by changing\n"
		"the sliders value."))


