; Scribble - simple freehand drawing
(require 'forms)

(define last_x 100)
(define last_y 100)

(define (scribble . args)
  (let ((form '()))
    (fl_initialize args)
    (set! form (create_form))
    (fl_show_form form  (logior FL_PLACE_CENTER FL_FREE_SIZE) 
		  FL_FULLBORDER "Scribble")
    (fl_set_clipping 30 30 470 405)
    (letrec ((loop (lambda ()
		     (if (not (equal? (fl_do_forms) #f))
			 (loop)))))
      (loop))
    (fl_finish)
    0))

(define (freeobject_handler ob event mx my key xev)
  (cond ((= event FL_MOUSE) 
	 (fl_line last_x last_y mx my FL_BLACK)
	 (set! last_x mx)
	 (set! last_y my)
	 )
	((= event FL_PUSH)
	 (set! last_x mx)
	 (set! last_y my)
	)
	(else 
	 ;(display "Key : ")
	 ;(display key)
	 ;(display "Event : ")
	 ;(display event)
	 #t))
  0)


(define (quit_cb ob data)
  (exit 0))

(define (create_form)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  530 490))
    (set! obj (fl_add_box FL_UP_BOX 0 0 530 490 ""))
    (set! obj (fl_add_frame FL_DOWN_FRAME 30 30 470 405 ""))
    (fl_set_object_gravity obj  FL_NorthWest  FL_SouthEast)
    (set! obj (fl_add_free FL_NORMAL_FREE 30 30 470 405 "" 
			   freeobject_handler))
    (fl_set_object_gravity obj  FL_NorthWest  FL_SouthEast)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 395 445 105 30 "Quit"))
    (fl_set_object_callback obj quit_cb 0)
    ;(fl_set_button_shortcut obj "Qq#q" 1)
    ;(set! obj (fl_add_button FL_NORMAL_BUTTON 165 445 105 30 "Clear"))
    ;(fl_set_object_callback obj clear_cb 0)
    (fl_end_form)
    form))

(scribble)

