;;; probability wheel

(require 'forms)

;
(define wheel_xpm
  '(
    ; width height num_colors chars_per_pixel 
    "    63    39        5            1"
    ; colors 
    ". c #a6a2a6"
    "a c #595959"
    "b c #ffffff"
    "c c #cfcfcf"
    "d c #282828"
    ; pixels 
    "........................ddaaaabbbaaaadd........................"
    ".......................daaaaaabcbaaaaaad......................."
    "......................daaaaaabcccbaaaaaad......................"
    "......................daaaaaabcccbaaaaaad......................"
    ".....................daaaaaabcccccbaaaaaad....................."
    "....................daaaaaaabcccccbaaaaaaad...................."
    "...................daaaaaaabcccccccbaaaaaaad..................."
    "...................daaaaaabcccccccccbaaaaaad..................."
    "..................daaaaaabcccccccccccbaaaaaad.................."
    ".................daaaaaabcccccccccccccbaaaaaad................."
    "................daaaaaabcccccccccccccccbaaaaaad................"
    "...............daaaaaabcccccccccccccccccbaaaaaad..............."
    "...............daaaaaabbbbbbbbbccbbbbbbbbaaaaaad..............."
    "..............daaaaaaaaaaaaaaabccbaaaaaaaaaaaaaad.............."
    ".............daaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaad............."
    "............daaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaad............"
    "............daaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaad............"
    "...........daaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaad..........."
    "..........daaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaad.........."
    ".........daaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaad........."
    ".........daaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaad........."
    "........daaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaad........"
    ".......daaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaad......."
    "......daaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaad......"
    ".....daaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaad....."
    ".....daaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaad....."
    "....daaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaad...."
    "...daaaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaaad..."
    "..daaaaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaaaad.."
    "..daaaaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaaaad.."
    ".daaaaaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaaaaad."
    ".daaaaaaaaaaaaaaaaaaaaaaaaaaaabccbaaaaaaaaaaaaaaaaaaaaaaaaaaad."
    "daaaaaaaaaaaaaaaaaaaaaaaaaaaabccccbaaaaaaaaaaaaaaaaaaaaaaaaaaad"
    "daaaaaaaaaaaaaaaaaaaaaaaaaaabccccccbaaaaaaaaaaaaaaaaaaaaaaaaaad"
    "daaaaaaaaaaaaaaaaaaaaaaaaaabccccccccbaaaaaaaaaaaaaaaaaaaaaaaaad"
    "daaaaaaaaaaaaaaaaaaaaaaaaabccccccccccbaaaaaaaaaaaaaaaaaaaaaaaad"
    "daaaaaaaaaaaaaaaaaaaaaaaaabccccccccccbaaaaaaaaaaaaaaaaaaaaaaaad"
    "daaaaaaaaaaaaaaaaaaaaaaaaabccccccccccbaaaaaaaaaaaaaaaaaaaaaaaad"
    "ddddddddddddddddddddddddddbbbbbbbbbbbbddddddddddddddddddddddddd"
    ))
  
(define (wheelprb pstring . args)
  (let ((form '())
	(obj '())
	(wheel_obj '())
	(objtext "")
	(button '())
	(prob 0.5))
    ;
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 300 330))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 15 15 270 55 
				 "Probability wheel"))
    (fl_set_object_lsize obj FL_MEDIUM_SIZE)
    (set! obj (fl_add_text FL_NORMAL_TEXT 30 30 240 30 
			   pstring))
    (fl_set_object_align obj FL_ALIGN_CENTER)
    (set! wheel_obj (fl_add_dial FL_FILL_DIAL 100 90 109 109 ""))
    (fl_set_object_boxtype wheel_obj FL_EMBOSSED_BOX)
    (fl_set_dial_bounds wheel_obj 0.0 1.0)
    (fl_set_dial_value wheel_obj prob)
    (fl_set_object_color wheel_obj FL_WHITE FL_DIAL_COL2)
    (fl_set_object_align wheel_obj FL_ALIGN_CENTER)
    (set! obj (fl_add_pixmap FL_NORMAL_PIXMAP 
			     100 199 109 39 "")) ; -3
    (fl_set_pixmap_data obj wheel_xpm)
    (set! objtext (fl_add_box FL_FRAME_BOX 15 240 270 30 
			      (string-append "Probability : "
					     (number->string prob)))) 

    (set! button (fl_add_button FL_NORMAL_BUTTON 45 280 210 35 
				"Done"))
    (fl_set_object_lsize button FL_MEDIUM_SIZE)
    (fl_end_form)
    (fl_show_form form FL_PLACE_MOUSE FL_TRANSIENT 
		  "Probability assessment")

    (letrec ((loop 
              (lambda ()
		(fl_set_object_label 
		 objtext 
		 (substring (string-append 
			     "Probability : " 
			     (number->string (max ; Bug ! (negative value)
					      (fl_get_dial_value wheel_obj)
					      0))
			     (make-string 8 #\space)) 0 20))
                (if (not (equal? (fl_do_forms) button))
                    (loop)
		    (fl_get_dial_value wheel_obj)))))
      (set! prob (loop))
      (fl_hide_form form)
      prob)
    ))

(display (wheelprb 
	  (string-append "Select probability by changing the size\n"
			 "of the wheels black sector.")))
