/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_basic.c
** nov 26 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_basic_sym()
{
  /* */
  sysintern("fl_false",             MAKINUM(FALSE));
  sysintern("fl_true",              MAKINUM(TRUE));
  /* some general constants */
  sysintern("fl_on",                MAKINUM(FL_ON)); 
  sysintern("fl_ok",                MAKINUM(FL_OK)); 
  sysintern("fl_valid",             MAKINUM(FL_VALID)); 
  sysintern("fl_preempt",           MAKINUM(FL_PREEMPT)); 
  sysintern("fl_auto",              MAKINUM(FL_AUTO));
  sysintern("fl_when_needed",       MAKINUM(FL_WHEN_NEEDED)); 
  sysintern("fl_off",               MAKINUM(FL_OFF)); 
  sysintern("fl_cancel",            MAKINUM(FL_CANCEL));
  sysintern("fl_invalid",           MAKINUM(FL_INVALID)); 
  /* FL_NONE */
  sysintern("fl_ignore",            MAKINUM(FL_IGNORE)); 
  sysintern("fl_close",             MAKINUM(FL_CLOSE)); 
  /* Max directory length */
  sysintern("fl_path_max",          MAKINUM(FL_PATH_MAX));
  /* 1 if FL_Coord is of type float */
  sysintern("fl_coordisfloat",      MAKINUM(FL_CoordIsFloat));
  /* Coordinates */
  sysintern("fl_coord_pixel",       MAKINUM(FL_COORD_PIXEL));
  sysintern("fl_coord_mm",          MAKINUM(FL_COORD_MM));
  sysintern("fl_coord_point",       MAKINUM(FL_COORD_POINT));
  sysintern("fl_coord_centimm",     MAKINUM(FL_COORD_centiMM));
  sysintern("fl_coord_centipoint",  MAKINUM(FL_COORD_centiPOINT  )); 
  /* All object classes */
  sysintern("fl_invalid_class",     MAKINUM(FL_INVALID_CLASS)); 
  sysintern("fl_button",            MAKINUM(FL_BUTTON)); 
  sysintern("fl_lightbutton",       MAKINUM(FL_LIGHTBUTTON));
  sysintern("fl_roundbutton",       MAKINUM(FL_ROUNDBUTTON)); 
  sysintern("fl_round3dbutton",     MAKINUM(FL_ROUND3DBUTTON));
  sysintern("fl_checkbutton",       MAKINUM(FL_CHECKBUTTON));
  sysintern("fl_bitmapbutton",      MAKINUM(FL_BITMAPBUTTON)); 
  sysintern("fl_pixmapbutton",      MAKINUM(FL_PIXMAPBUTTON));
  sysintern("fl_bitmap",            MAKINUM(FL_BITMAP)); 
  sysintern("fl_pixmap",            MAKINUM(FL_PIXMAP));
  sysintern("fl_box",               MAKINUM(FL_BOX)); 
  sysintern("fl_text",              MAKINUM(FL_TEXT));
  sysintern("fl_menu",              MAKINUM(FL_MENU)); 
  sysintern("fl_chart",             MAKINUM(FL_CHART)); 
  sysintern("fl_choice",            MAKINUM(FL_CHOICE));
  sysintern("fl_counter",           MAKINUM(FL_COUNTER)); 
  sysintern("fl_slider",            MAKINUM(FL_SLIDER)); 
  sysintern("fl_valslider",         MAKINUM(FL_VALSLIDER)); 
  sysintern("fl_input",             MAKINUM(FL_INPUT));
  sysintern("fl_browser",           MAKINUM(FL_BROWSER));
  sysintern("fl_dial",              MAKINUM(FL_DIAL));
  sysintern("fl_timer",             MAKINUM(FL_TIMER));
  sysintern("fl_clock",             MAKINUM(FL_CLOCK));
  sysintern("fl_postioner",         MAKINUM(FL_POSITIONER));
  sysintern("fl_free",              MAKINUM(FL_FREE));
  sysintern("fl_xyplot",            MAKINUM(FL_XYPLOT));
  sysintern("fl_frame",             MAKINUM(FL_FRAME));
  sysintern("fl_labelframe",        MAKINUM(FL_LABELFRAME));
  sysintern("fl_canvas",            MAKINUM(FL_CANVAS));
  sysintern("fl_glcanvas",          MAKINUM(FL_GLCANVAS));
  sysintern("fl_tabfolder",         MAKINUM(FL_TABFOLDER));
  sysintern("fl_scrollbar",         MAKINUM(FL_SCROLLBAR));
  sysintern("fl_scrollbutton",      MAKINUM(FL_SCROLLBUTTON));
  sysintern("fl_menubar",           MAKINUM(FL_MENUBAR));
  sysintern("fl_imagecanvas",       MAKINUM(FL_IMAGECANVAS));
  sysintern("fl_textbox",           MAKINUM(FL_TEXTBOX)); 
  /* */
  sysintern("fl_begin_group",       MAKINUM(FL_BEGIN_GROUP)); 
  sysintern("fl_cend_group",        MAKINUM(FL_END_GROUP)); 
  /* */
  sysintern("fl_user_class_start",  MAKINUM(FL_USER_CLASS_START));
  sysintern("fl_user_class_end",    MAKINUM(FL_USER_CLASS_END));
  /* how to display a form onto screen */
  sysintern("fl_place_free",        MAKINUM(FL_PLACE_FREE));
  sysintern("fl_place_mouse",       MAKINUM(FL_PLACE_MOUSE));
  sysintern("fl_place_center",      MAKINUM(FL_PLACE_CENTER));
  sysintern("fl_place_position",    MAKINUM(FL_PLACE_POSITION));
  sysintern("fl_place_size",        MAKINUM(FL_PLACE_SIZE));
  sysintern("fl_place_geometry",    MAKINUM(FL_PLACE_GEOMETRY));
  sysintern("fl_place_aspect",      MAKINUM(FL_PLACE_ASPECT));
  sysintern("fl_place_fullscreen",  MAKINUM(FL_PLACE_FULLSCREEN));
  sysintern("fl_place_hotspot",     MAKINUM(FL_PLACE_HOTSPOT));
  sysintern("fl_place_iconic",      MAKINUM(FL_PLACE_ICONIC));
  /* modifier */
  sysintern("fl_free_size",         MAKINUM(FL_FREE_SIZE));
  sysintern("fl_fix_size",          MAKINUM(FL_FIX_SIZE));
  /* */
  /* WM decorations */
  sysintern("fl_fullborder",        MAKINUM(FL_FULLBORDER));
  sysintern("fl_transient",         MAKINUM(FL_TRANSIENT));
  sysintern("fl_noborder",          MAKINUM(FL_NOBORDER));
  sysintern("fl_modal",             MAKINUM(FL_MODAL));
  /* All box types */
  sysintern("fl_no_box",            MAKINUM(FL_NO_BOX));
  sysintern("fl_up_box",            MAKINUM(FL_UP_BOX));
  sysintern("fl_down_box",          MAKINUM(FL_DOWN_BOX));
  sysintern("fl_border_box",        MAKINUM(FL_BORDER_BOX));
  sysintern("fl_shadow_box",        MAKINUM(FL_SHADOW_BOX));
  sysintern("fl_frame_box",         MAKINUM(FL_FRAME_BOX));
  sysintern("fl_rounded_box",       MAKINUM(FL_ROUNDED_BOX));
  sysintern("fl_embossed_box",      MAKINUM(FL_EMBOSSED_BOX));
  sysintern("fl_flat_box",          MAKINUM(FL_FLAT_BOX));
  sysintern("fl_rflat_box",         MAKINUM(FL_RFLAT_BOX));
  sysintern("fl_rshadow_box",       MAKINUM(FL_RSHADOW_BOX));
  sysintern("fl_oval_box",          MAKINUM(FL_OVAL_BOX));
  sysintern("fl_rounded3d_upbox",   MAKINUM(FL_ROUNDED3D_UPBOX));
  sysintern("fl_rounded3d_downbox", MAKINUM(FL_ROUNDED3D_DOWNBOX));
  sysintern("fl_oval3d_upbox",      MAKINUM(FL_OVAL3D_UPBOX));
  sysintern("fl_oval3d_downbox",    MAKINUM(FL_OVAL3D_DOWNBOX));
  sysintern("fl_oval3d_framebox",   MAKINUM(FL_OVAL3D_FRAMEBOX));
  sysintern("fl_oval3d_embossedbox", MAKINUM(FL_OVAL3D_EMBOSSEDBOX));
  /* for internal use only */
  sysintern("fl_toptab_upbox",      MAKINUM(FL_TOPTAB_UPBOX));
  sysintern("fl_selected_toptab_upbox", MAKINUM(FL_SELECTED_TOPTAB_UPBOX));
  sysintern("fl_bottomtab_upbox",   MAKINUM(FL_BOTTOMTAB_UPBOX));
  sysintern("fl_selected_bottomtab_upbox", 
            MAKINUM(FL_SELECTED_BOTTOMTAB_UPBOX));
  sysintern("fl_oshadow_box",       MAKINUM(FL_OSHADOW_BOX));
  /* how to place text relative to a box */
  sysintern("fl_align_center",      MAKINUM(FL_ALIGN_CENTER));
  sysintern("fl_align_top",         MAKINUM(FL_ALIGN_TOP));
  sysintern("fl_align_bottom",      MAKINUM(FL_ALIGN_BOTTOM));
  sysintern("fl_align_left",        MAKINUM(FL_ALIGN_LEFT));
  sysintern("fl_align_right",       MAKINUM(FL_ALIGN_RIGHT));
  sysintern("fl_align_top_left",    MAKINUM(FL_ALIGN_TOP_LEFT));
  sysintern("fl_align_top_right",   MAKINUM(FL_ALIGN_TOP_RIGHT));
  sysintern("fl_align_bottom_left", MAKINUM(FL_ALIGN_BOTTOM_LEFT));
  sysintern("fl_align_bottom_right",MAKINUM(FL_ALIGN_BOTTOM_RIGHT));
  sysintern("fl_align_inside",      MAKINUM(FL_ALIGN_INSIDE));
  sysintern("fl_align_vert",        MAKINUM(FL_ALIGN_VERT));
  /* */
  sysintern("fl_align_left_top",    MAKINUM(FL_ALIGN_LEFT_TOP));
  sysintern("fl_align_right_top",   MAKINUM(FL_ALIGN_RIGHT_TOP));
  sysintern("fl_align_left_bottom", MAKINUM(FL_ALIGN_LEFT_BOTTOM));
  sysintern("fl_align_right_bottom",MAKINUM(FL_ALIGN_RIGHT_BOTTOM));
  /* mouse buttons */
  sysintern("fl_mbutton1",          MAKINUM(FL_MBUTTON1));
  sysintern("fl_mbutton2",          MAKINUM(FL_MBUTTON2));
  sysintern("fl_mbutton3",          MAKINUM(FL_MBUTTON3));
  sysintern("fl_mbutton4",          MAKINUM(FL_MBUTTON4)); 
  sysintern("fl_mbutton5",          MAKINUM(FL_MBUTTON5));
  /* control when to return input */
  sysintern("fl_return_end_changed",MAKINUM(FL_RETURN_END_CHANGED));
  sysintern("fl_return_changed",    MAKINUM(FL_RETURN_CHANGED));
  sysintern("fl_return_end",        MAKINUM(FL_RETURN_END));
  sysintern("fl_return_always",     MAKINUM(FL_RETURN_ALWAYS));
  sysintern("fl_return_dblclick",   MAKINUM(FL_RETURN_DBLCLICK));
  /* color indices */
  sysintern("fl_black",             MAKINUM(FL_BLACK));
  sysintern("fl_red",               MAKINUM(FL_RED));
  sysintern("fl_green",             MAKINUM(FL_GREEN)); 
  sysintern("fl_yellow",            MAKINUM(FL_YELLOW));
  sysintern("fl_blue",              MAKINUM(FL_BLUE)); 
  sysintern("fl_magenta",           MAKINUM(FL_MAGENTA)); 
  sysintern("fl_cyan",              MAKINUM(FL_CYAN)); 
  sysintern("fl_white",             MAKINUM(FL_WHITE));
  /* */
  sysintern("fl_tomato",            MAKINUM(FL_TOMATO)); 
  sysintern("fl_indianred",         MAKINUM(FL_INDIANRED)); 
  sysintern("fl_slateblue",         MAKINUM(FL_SLATEBLUE));
  /* */
  sysintern("fl_col1",              MAKINUM(FL_COL1)); 
  sysintern("fl_right_bcol",        MAKINUM(FL_RIGHT_BCOL)); 
  sysintern("fl_bottom_bcol",       MAKINUM(FL_BOTTOM_BCOL)); 
  sysintern("fl_top_bcol",          MAKINUM(FL_TOP_BCOL)); 
  sysintern("fl_left_bcol",         MAKINUM(FL_LEFT_BCOL));
  sysintern("fl_mcol",              MAKINUM(FL_MCOL));
  /* */
  sysintern("fl_inactive",          MAKINUM(FL_INACTIVE)); 
  sysintern("fl_palegreen",         MAKINUM(FL_PALEGREEN)); 
  sysintern("fl_darkgold",          MAKINUM(FL_DARKGOLD));
  /* */
  sysintern("fl_orchid",            MAKINUM(FL_ORCHID)); 
  sysintern("fl_darkcyan",          MAKINUM(FL_DARKCYAN)); 
  sysintern("fl_darktomato",        MAKINUM(FL_DARKTOMATO)); 
  sysintern("fl_wheat",             MAKINUM(FL_WHEAT)); 
  sysintern("fl_darkorange",        MAKINUM(FL_DARKORANGE));
  sysintern("fl_deeppink",          MAKINUM(FL_DEEPPINK)); 
  sysintern("fl_chartreuse",        MAKINUM(FL_CHARTREUSE)); 
  sysintern("fl_darkviolet",        MAKINUM(FL_DARKVIOLET)); 
  sysintern("fl_springgreen",       MAKINUM(FL_SPRINGGREEN)); 
  sysintern("fl_dodgerblue",        MAKINUM(FL_DODGERBLUE));
  /* */
  sysintern("fl_free_col1",         MAKINUM(FL_FREE_COL1)); 
  sysintern("fl_free_col2",         MAKINUM(FL_FREE_COL2));
  sysintern("fl_free_col3",         MAKINUM(FL_FREE_COL3)); 
  sysintern("fl_free_col4",         MAKINUM(FL_FREE_COL4));
  sysintern("fl_free_col5",         MAKINUM(FL_FREE_COL5)); 
  sysintern("fl_free_col6",         MAKINUM(FL_FREE_COL6));
  sysintern("fl_free_col7",         MAKINUM(FL_FREE_COL7)); 
  sysintern("fl_free_col8",         MAKINUM(FL_FREE_COL8));
  sysintern("fl_free_col9",         MAKINUM(FL_FREE_COL9)); 
  sysintern("fl_free_col10",        MAKINUM(FL_FREE_COL10));
  sysintern("fl_free_col11",        MAKINUM(FL_FREE_COL11)); 
  sysintern("fl_free_col12",        MAKINUM(FL_FREE_COL12));
  sysintern("fl_free_col13",        MAKINUM(FL_FREE_COL13)); 
  sysintern("fl_free_col14",        MAKINUM(FL_FREE_COL14));
  sysintern("fl_free_col15",        MAKINUM(FL_FREE_COL15)); 
  sysintern("fl_free_col16",        MAKINUM(FL_FREE_COL16));
  /* */
  /* Events that a form reacts to */
  sysintern("fl_noevent",           MAKINUM(FL_NOEVENT));
  sysintern("fl_draw",              MAKINUM(FL_DRAW));
  sysintern("fl_push",              MAKINUM(FL_PUSH));
  sysintern("fl_release",           MAKINUM(FL_RELEASE));
  sysintern("fl_enter",             MAKINUM(FL_ENTER));
  sysintern("fl_leave",             MAKINUM(FL_LEAVE));
  sysintern("fl_mouse",             MAKINUM(FL_MOUSE));
  sysintern("fl_focus",             MAKINUM(FL_FOCUS));
  sysintern("fl_unfocus",           MAKINUM(FL_UNFOCUS));
  sysintern("fl_keyboard",          MAKINUM(FL_KEYBOARD));
  sysintern("fl_motion",            MAKINUM(FL_MOTION));
  sysintern("fl_step",              MAKINUM(FL_STEP));
  sysintern("fl_shortcut",          MAKINUM(FL_SHORTCUT));
  sysintern("fl_freemem",           MAKINUM(FL_FREEMEM));
  sysintern("fl_other",             MAKINUM(FL_OTHER));
  sysintern("fl_drawlabel",         MAKINUM(FL_DRAWLABEL));
  sysintern("fl_dblclick",          MAKINUM(FL_DBLCLICK));
  sysintern("fl_trplclick",         MAKINUM(FL_TRPLCLICK));
  sysintern("fl_attrib",            MAKINUM(FL_ATTRIB));
  sysintern("fl_ps",                MAKINUM(FL_PS));
  /* Resize policies */
  sysintern("fl_resize_none",       MAKINUM(FL_RESIZE_NONE)); 
  sysintern("fl_resize_x",          MAKINUM(FL_RESIZE_X)); 
  sysintern("fl_resize_y",          MAKINUM(FL_RESIZE_Y));
  /* Keyboard focus control */
  sysintern("fl_key_normal",        MAKINUM(FL_KEY_NORMAL));
  sysintern("fl_key_tab",           MAKINUM(FL_KEY_TAB));
  sysintern("fl_key_special",       MAKINUM(FL_KEY_SPECIAL));
  sysintern("fl_key_all",           MAKINUM(FL_KEY_ALL));
  /* */
  sysintern("fl_alt_mask",          MAKINUM(FL_ALT_MASK));
  sysintern("fl_control_mask",      MAKINUM(FL_CONTROL_MASK));
  sysintern("fl_shift_mask",        MAKINUM(FL_SHIFT_MASK));
  /* Internal use */
  sysintern("fl_find_input",        MAKINUM(FL_FIND_INPUT));
  sysintern("fl_find_automatic",    MAKINUM(FL_FIND_AUTOMATIC));
  sysintern("fl_find_mouse",        MAKINUM(FL_FIND_MOUSE));
  sysintern("fl_find_canvas",       MAKINUM(FL_FIND_CANVAS));
  sysintern("fl_find_keyspecial",   MAKINUM(FL_FIND_KEYSPECIAL));
  /* Pop-up menu item attributes */
  sysintern("fl_pup_none",          MAKINUM(FL_PUP_NONE));
  sysintern("fl_pup_grey",          MAKINUM(FL_PUP_GREY));
  sysintern("fl_pup_box",           MAKINUM(FL_PUP_BOX));
  sysintern("fl_pup_check",         MAKINUM(FL_PUP_CHECK));
  sysintern("fl_pup_radio",         MAKINUM(FL_PUP_RADIO));
  /* max number of fonts */
  sysintern("fl_maxfonts",          MAKINUM(FL_MAXFONTS));
  /* font styles */
  sysintern("fl_invalid_style",     MAKINUM(FL_INVALID_STYLE));
  sysintern("fl_normal_style",      MAKINUM(FL_NORMAL_STYLE));
  sysintern("fl_bold_style",        MAKINUM(FL_BOLD_STYLE));
  sysintern("fl_italic_style",      MAKINUM(FL_ITALIC_STYLE));
  sysintern("fl_bolditalic_style",  MAKINUM(FL_BOLDITALIC_STYLE));
  /* */  
  sysintern("fl_fixed_style",       MAKINUM(FL_FIXED_STYLE));
  sysintern("fl_fixedbold_style",   MAKINUM(FL_FIXEDBOLD_STYLE));
  sysintern("fl_fixeditalic_style", MAKINUM(FL_FIXEDITALIC_STYLE));
  sysintern("fl_fixedbolditalic_style", MAKINUM(FL_FIXEDBOLDITALIC_STYLE));
  /* */
  sysintern("fl_times_style",       MAKINUM(FL_TIMES_STYLE));
  sysintern("fl_timesbold_style",   MAKINUM(FL_TIMESBOLD_STYLE));
  sysintern("fl_timesitalic_style", MAKINUM(FL_TIMESITALIC_STYLE));
  sysintern("fl_timesbolditalic_style", MAKINUM(FL_TIMESBOLDITALIC_STYLE));
  /* modifier masks */
  sysintern("fl_shadow_style",      MAKINUM(FL_SHADOW_STYLE));
  sysintern("fl_engraved_style",    MAKINUM(FL_ENGRAVED_STYLE));
  sysintern("fl_embossed_style",    MAKINUM(FL_EMBOSSED_STYLE));
  /* Standard sizes in XForms */
  sysintern("fl_tiny_size",         MAKINUM(FL_TINY_SIZE));
  sysintern("fl_small_size",        MAKINUM(FL_SMALL_SIZE));
  sysintern("fl_normal_size",       MAKINUM(FL_NORMAL_SIZE));
  sysintern("fl_medium_size",       MAKINUM(FL_MEDIUM_SIZE));
  sysintern("fl_large_size",        MAKINUM(FL_LARGE_SIZE));
  sysintern("fl_huge_size",         MAKINUM(FL_HUGE_SIZE));
  /* Border width of boxes */
  sysintern("fl_bound_width",       MAKINUM(FL_BOUND_WIDTH));
  /* double click interval */
  sysintern("fl_click_timeout",     MAKINUM(FL_CLICK_TIMEOUT));
  /* async IO stuff */
  sysintern("fl_read",              MAKINUM(FL_READ));
  sysintern("fl_write",             MAKINUM(FL_WRITE));
  sysintern("fl_except",            MAKINUM(FL_EXCEPT));
  /* */
  sysintern("fl_slider_none",       MAKINUM(FL_SLIDER_NONE));
  sysintern("fl_slider_box",        MAKINUM(FL_SLIDER_BOX));
  sysintern("fl_slider_knob",       MAKINUM(FL_SLIDER_KNOB));
  sysintern("fl_slider_up",         MAKINUM(FL_SLIDER_UP));
  sysintern("fl_slider_down",       MAKINUM(FL_SLIDER_DOWN));
  sysintern("fl_slider_all",        MAKINUM(FL_SLIDER_ALL));
  /* */
  sysintern("fl_max_menu_choice_items", MAKINUM(FL_MAX_MENU_CHOICE_ITEMS));
  return;
}

/* routines */

/* IO other than XEvent Q */
static char s_fl_add_io_callback[]="fl_add_io_callback";
SCM nfl_add_io_callback(SCM _i1, SCM _i2, SCM _args)
{
  SCM _proc, _v;
  ASSERT(ilength(_args)==2, _args, ARG3, s_fl_add_io_callback);
  _proc=CAR(_args); _args=CDR(_args);
  _v=CAR(_args);
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_add_io_callback);
  ASSERT(INUMP(_i2) && INUM(_i2)>=0, _i2, ARG2, s_fl_add_io_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG3, s_fl_add_io_callback);
  /*ASSERT(INUMP(_v), _v, ARG4, s_fl_add_io_callback);*/
  SFDEBUGMSG(s_fl_add_io_callback);
  cb_add(loc_io_callback, _i1, _proc);
  fl_add_io_callback(INUM(_i1), INUM(_i2), cb_io_callback, 
		     (void *)_v);
  return UNSPECIFIED;
}

static char s_fl_remove_io_callback[]="fl_remove_io_callback";
SCM nfl_remove_io_callback(SCM _i1, SCM _i2, SCM _proc)
{
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_remove_io_callback);
  ASSERT(INUMP(_i2) && INUM(_i2)>=0, _i2, ARG2, s_fl_remove_io_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG3, s_fl_remove_io_callback);
  SFDEBUGMSG(s_fl_remove_io_callback);
  cb_del(loc_io_callback, _i1);
  fl_remove_io_callback(INUM(_i1), INUM(_i2), cb_io_callback);
  return UNSPECIFIED;
}

/* signals */
static char s_fl_add_signal_callback[]="fl_add_signal_callback";
SCM nfl_add_signal_callback(SCM _i, SCM _proc, SCM _v)
{
  ASSERT(INUMP(_i), _i, ARG1, s_fl_add_signal_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_add_signal_callback);
  /*ASSERT(INUMP(_v), _v, ARG3, s_fl_add_signal_callback);*/
  SFDEBUGMSG(s_fl_add_signal_callback);
  cb_add(loc_signal_callback, _i, _proc);
  fl_add_signal_callback(INUM(_i), cb_signal_callback, 
			 (void *)_v);
  return UNSPECIFIED;
}
static char s_fl_remove_signal_callback[]="fl_remove_signal_callback";
SCM nfl_remove_signal_callback(SCM _i)
{
  ASSERT(INUMP(_i), _i, ARG1, s_fl_remove_signal_callback);
  SFDEBUGMSG(s_fl_remove_signal_callback);
  /*cb_del(loc_signal_callback, _i);*/
  fl_remove_signal_callback(INUM(_i));
  return UNSPECIFIED;
}
SUBR_void__int(fl_signal_caught);
SUBR_void__int(fl_app_signal_direct);

/* timeouts */
static char s_fl_add_timeout[]="fl_add_timeout";
SCM nfl_add_timeout(SCM _i, SCM _proc, SCM _data)
{
  SCM r;
  ASSERT(INUMP(_i), _i, ARG1, s_fl_add_timeout);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_add_timeout);
  /*ASSERT(INUMP(_data), _data, ARG3, s_fl_add_timeout);*/
  SFDEBUGMSG(s_fl_add_timeout);
  r=MAKINUM(fl_add_timeout(INUM(_i), cb_timeout_handler, 
			   (void *)_data));
  cb_add(loc_timeout_handler, r, _proc);
  return r;
} /* fl_add_timeout */
static char s_fl_remove_timeout[]="fl_remove_timeout";
SCM nfl_remove_timeout(SCM _i)
{
  ASSERT(INUMP(_i), _i, ARG1, s_fl_add_timeout);
  SFDEBUGMSG(s_fl_add_timeout);
  cb_del(loc_timeout_handler, _i);
  fl_remove_timeout(INUM(_i));
  return UNSPECIFIED;
} /* fl_remove_timeout */

/* some utility stuff */
SUBR_dummy2(fl_get_vn_value); /* ? */
SUBR_dummy2(fl_get_vn_name);  /* ? */
SUBR_int__uint(fl_msleep);
/* basic public routine prototypes */
static char s_fl_library_version[]="fl_library_version";
SCM nfl_library_version()
{
  int i1, i2, r;
  r=fl_library_version(&i1, &i2);
  return cons(MAKINUM(r), 
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), EOL)));
} /* fl_library_version */
/* generic routines */
static char s_fl_bgn_form[]="fl_bgn_form";
SCM nfl_bgn_form(SCM _i1, SCM _i2, SCM _i3)
{
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_bgn_form);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_bgn_form);
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_bgn_form);
  SFDEBUGMSG(s_fl_bgn_form);
  return mkform(fl_bgn_form(INUM(_i1), INUM(_i2), INUM(_i3)));
} /* fl_bgn_form */
SUBR_void__void(fl_end_form);
SUBR_objectptr__void(fl_do_forms);
SUBR_objectptr__void(fl_check_forms);
SUBR_objectptr__void(fl_do_only_forms);
SUBR_objectptr__void(fl_check_only_forms);
SUBR_void__formptr(fl_freeze_form);
/* */
SUBR_void__formptr_objectptr(fl_set_focus_object);
SUBR_objectptr__formptr(fl_get_focus_object);
SUBR_void__objectptr(fl_reset_focus_object);
static char s_fl_set_form_atclose[]="fl_set_form_atclose";
SCM nfl_set_form_atclose(SCM _f, SCM _proc, SCM _v)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_set_form_atclose);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_form_atclose);
  /*ASSERT(INUMP(_v), _v, ARG3, s_fl_set_form_atclose);*/
  SFDEBUGMSG(s_fl_set_form_atclose);
  cb_add(loc_form_atclose_callback, _f, _proc);
  fl_set_form_atclose(FORM(_f), cb_form_atclose_callback, (void *)_v);
  return UNSPECIFIED;
} /* fl_set_form_atclose */
static char s_fl_set_atclose[]="fl_set_atclose";
SCM nfl_set_atclose(SCM _proc, SCM _v)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG1, s_fl_set_atclose);
  /*ASSERT(INUMP(_v), _v, ARG2, s_fl_set_atclose);*/
  SFDEBUGMSG(s_fl_set_atclose);
  cb_add(loc_atclose_callback, MAKINUM(0), _proc);
  fl_set_atclose(cb_atclose_callback, (void *)_v);
  return UNSPECIFIED;
}
static char s_fl_set_form_atdeactivate[]="fl_set_form_atdeactivate";
SCM nfl_set_form_atdeactivate(SCM _f, SCM _proc, SCM _v)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_set_form_atdeactivate);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_form_atdeactivate);
  /*ASSERT(INUMP(_v), _v, ARG3, s_fl_set_form_atdeactivate);*/
  SFDEBUGMSG(s_fl_set_form_atdeactivate);
  cb_add(loc_form_atdeactivate_callback, _f, _proc);
  fl_set_form_atdeactivate(FORM(_f), cb_form_atdeactivate_callback, 
			   (void *)_v);
  return UNSPECIFIED;
}
static char s_fl_set_form_atactivate[]="fl_set_form_atactivate";
SCM nfl_set_form_atactivate(SCM _f, SCM _proc, SCM _v)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_set_form_atactivate);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_form_atactivate);
  /*ASSERT(INUMP(_v), _v, ARG3, s_fl_set_form_atactivate);*/
  SFDEBUGMSG(s_fl_set_form_atactivate);
  cb_add(loc_form_atactivate_callback, _f, _proc);
  fl_set_form_atactivate(FORM(_f), cb_form_atactivate_callback, 
			 (void *)_v);
  return UNSPECIFIED;
}

/* */
SUBR_void__formptr(fl_unfreeze_form);
SUBR_void__formptr(fl_deactivate_form);
SUBR_void__formptr(fl_activate_form);
SUBR_void__void(fl_deactivate_all_forms);
SUBR_void__void(fl_activate_all_forms);
SUBR_void__void(fl_freeze_all_forms);
SUBR_void__void(fl_unfreeze_all_forms);
SUBR_void__formptr_2double(fl_scale_form);
SUBR_void__formptr_2int(fl_set_form_position);
SUBR_void__formptr_charptr(fl_set_form_title);
/* */
SUBR_void__formptr_uint(fl_set_form_property);
SUBR_void__formptr(fl_set_app_mainform);
SUBR_formptr__void(fl_get_app_mainform);
SUBR_void__int(fl_set_app_nomainform);
/* */
static char s_fl_set_form_callback[]="fl_set_form_callback";
SCM nfl_set_form_callback(SCM _f, SCM _proc, SCM _v)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_set_form_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_form_callback);
  ASSERT(INUMP(_v), _v, ARG3, s_fl_set_form_callback);
  SFDEBUGMSG(s_fl_set_form_callback);
  cb_add(loc_form_callback, _f, _proc);
  fl_set_form_callback(FORM(_f), cb_form_callback, (void *)_v);
  return UNSPECIFIED;
} /* fl_set_form_callback */
/* */
SUBR_void__formptr_2int(fl_set_form_size);
SUBR_void__formptr_2int(fl_set_form_hotspot);
SUBR_void__formptr_objectptr(fl_set_form_hotobject);
SUBR_void__formptr_2int(fl_set_form_minsize);
SUBR_void__formptr_2int(fl_set_form_maxsize);
SUBR_void__formptr_uint(fl_set_form_event_cmask);
SUBR_int__formptr(fl_get_form_event_cmask);
/* */
SUBR_void__formptr_4int(fl_set_form_geometry);
/* */
SUBR_int__formptr_2int_charptr(fl_show_form);
SUBR_void__formptr(fl_hide_form);
SUBR_void__formptr(fl_free_form);
SUBR_void__formptr(fl_redraw_form);
SUBR_void__formptr_int(fl_set_form_dblbuffer);
SUBR_int__formptr_2int_charptr(fl_prepare_form_window);
SUBR_int__formptr(fl_show_form_window);
SUBR_double__formptr(fl_adjust_form_size);
SUBR_int__formptr(fl_form_is_visible);
/* */
static char s_fl_register_raw_callback[]="fl_register_raw_callback";
SCM nfl_register_raw_callback(SCM _f, SCM _i, SCM _proc)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_register_raw_callback);
  ASSERT(INUMP(_i), _i, ARG2, s_fl_register_raw_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG3, s_fl_register_raw_callback);
  SFDEBUGMSG(s_fl_register_raw_callback);
  cb_add(loc_raw_callback, _f, _proc);
  fl_register_raw_callback(FORM(_f), INUM(_i), cb_raw_callback);
  return UNSPECIFIED;
} /* fl_register_raw_callback */
/* */
static char s_fl_bgn_group[]="fl_bgn_group";
SCM nfl_bgn_group()
{
  FL_OBJECT *obj;
  SFDEBUGMSG(s_fl_bgn_group);
  obj=fl_bgn_group();
  return mkobj(obj);
} /* fl_bgn_group */
static char s_fl_end_group[]="fl_end_group";
SCM nfl_end_group()
{
  SFDEBUGMSG(s_fl_end_group);
  fl_end_group();
  return UNSPECIFIED;
} /* fl_end_group */
static char s_fl_addto_group[]="fl_addto_group";
SCM nfl_addto_group(SCM _o)
{
  SFDEBUGMSG(s_fl_addto_group);
  ASSERT(OBJP(_o), _o, ARG1, s_fl_addto_group);
  fl_addto_group(OBJ(_o));
  return UNSPECIFIED;
} /* fl_addto_group */
/* routines that deal with fl_objects */
SUBR_void__objectptr_int(fl_set_object_boxtype);
SUBR_void__objectptr_int(fl_set_object_bw);
SUBR_void__objectptr_uint(fl_set_object_resize);
SUBR_void__objectptr_2uint(fl_set_object_gravity);
SUBR_void__objectptr_int(fl_set_object_lsize);
SUBR_void__objectptr_int(fl_set_object_lstyle);
SUBR_void__objectptr_uint(fl_set_object_lcol);
SUBR_void__objectptr_int(fl_set_object_return);
SUBR_void__objectptr_int(fl_set_object_lalign);
SUBR_void__objectptr_charptr_int(fl_set_object_shortcut);
SUBR_void__objectptr_uint(fl_set_object_shortcutkey);
SUBR_void__objectptr_int(fl_set_object_dblbuffer);
SUBR_void__objectptr_2uint(fl_set_object_color);
SUBR_void__objectptr_charptr(fl_set_object_label);
SUBR_void__objectptr_2int(fl_set_object_position);
SUBR_void__objectptr_2int(fl_set_object_size);
SUBR_void__objectptr_int(fl_set_object_automatic);
SUBR_void__objectptr(fl_draw_object_label);
SUBR_void__objectptr(fl_draw_object_label_outside);
static char s_fl_get_object_component[]="fl_get_object_component";
SCM nfl_get_object_component(SCM _o, SCM _i1, SCM _args)
{
  SCM _i2, _i3;
  ASSERT(ilength(_args)==2, _args, ARG3, s_fl_get_object_component);
  _i2=CAR(_args); _args=CDR(_args);
  _i3=CAR(_args);
  ASSERT(OBJP(_o), _o, ARG1, s_fl_get_object_component);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_get_object_component);
  ASSERT(INUMP(_i2), _i2, ARG3, s_fl_get_object_component);
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_get_object_component);
  SFDEBUGMSG(s_fl_get_object_component);
  return mkobj(fl_get_object_component(OBJ(_o), 
				       INUM(_i1), INUM(_i2), INUM(_i3)));
} /* fl_get_object_component */
SUBR_void__objectptr_int(fl_set_object_dblclick);
SUBR_void__objectptr_4int(fl_set_object_geometry);
/* */
SUBR_void__objectptr_2int(fl_fit_object_label);
SUBR_4int__objectptr(fl_get_object_geometry);
SUBR_2int__objectptr(fl_get_object_position);
/* this one takes into account the label */
SUBR_4int__objectptr(fl_get_object_bbox);
SUBR_void__objectptr(fl_call_object_callback);
static char s_fl_set_object_prehandler[]="fl_set_object_prehandler";
SCM nfl_set_object_prehandler(SCM _o, SCM _proc)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_object_prehandler);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_object_prehandler);
  SFDEBUGMSG(s_fl_set_object_prehandler);
  cb_add(loc_object_prehandler, _o, _proc);
  fl_set_object_prehandler(OBJ(_o), cb_object_prehandler);
  return UNSPECIFIED;
} /* fl_set_object_prehandler */
static char s_fl_set_object_posthandler[]="fl_set_object_posthandler";
SCM nfl_set_object_posthandler(SCM _o, SCM _proc)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_object_posthandler);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_object_posthandler);
  SFDEBUGMSG(s_fl_set_object_posthandler);
  cb_add(loc_object_posthandler, _o, _proc);
  fl_set_object_posthandler(OBJ(_o), cb_object_posthandler);
  return UNSPECIFIED;
} /* fl_set_object_posthandler */

static char s_fl_set_object_callback[]="fl_set_object_callback";
SCM nfl_set_object_callback(SCM _o, SCM _proc, SCM _data)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_object_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_object_callback);
  ASSERT(INUMP(_data), _data, ARG3, s_fl_set_object_callback);
  SFDEBUGMSG(s_fl_set_object_callback);
  cb_add(loc_object_callback, _o, _proc);
  fl_set_object_callback(OBJ(_o), cb_object_callback, INUM(_data));
  return UNSPECIFIED;
} /* fl_set_object_callback */
/* */
SUBR_void__objectptr(fl_redraw_object);
SUBR_void__objectptr_2double(fl_scale_object);
SUBR_void__objectptr(fl_show_object);
SUBR_void__objectptr(fl_hide_object);
SUBR_void__objectptr(fl_free_object);
SUBR_void__objectptr(fl_delete_object);
SUBR_void__objectptr(fl_trigger_object);
SUBR_void__objectptr(fl_activate_object);
SUBR_void__objectptr(fl_deactivate_object);
/* */
static char s_fl_enumerate_fonts[]="fl_enumerate_fonts";
SCM nfl_enumerate_fonts(SCM _proc, SCM _i)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG1, s_fl_enumerate_fonts);
  ASSERT(INUMP(_i), _i, ARG2, s_fl_enumerate_fonts);
  SFDEBUGMSG(s_fl_enumerate_fonts);
  cb_add(loc_font_enumerator, MAKINUM(0), _proc);
  return MAKINUM(fl_enumerate_fonts(cb_font_enumerator, INUM(_i)));
} /* fl_enumerate_fonts */
SUBR_int__int_charptr(fl_set_font_name);
SUBR_void__2int(fl_set_font);
/* routines that facilitate free object */
static char s_fl_get_char_height[]="fl_get_char_height";
SCM nfl_get_char_height(SCM _i1, SCM _i2)
{
  int r, i1, i2;
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_get_char_height);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_get_char_height);
  SFDEBUGMSG(s_fl_get_char_height);
  r=fl_get_char_height(INUM(_i1), INUM(_i2), &i1, &i2);
  return cons(MAKINUM(r), 
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), EOL)));
} /* fl_get_char_height */
SUBR_int__2int(fl_get_char_width);
static char s_fl_get_string_height[]="fl_get_string_height";
SCM nfl_get_string_height(SCM _i1, SCM _i2, SCM _args)
{
  SCM _s, _i3;
  int r, i1, i2;
  ASSERT(ilength(_args)==2, _args, ARG3, s_fl_get_string_height);
  _s=CAR(_args); _args=CDR(_args);
  _i3=CAR(_args);
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_get_string_height);  
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_get_string_height);  
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG3, s_fl_get_string_height);  
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_get_string_height);  
  SFDEBUGMSG(s_fl_get_string_height);
  r=fl_get_string_height(INUM(_i1), INUM(_i2), CHARS(_s), 
			 INUM(_i3), &i1, &i2);
  return cons(MAKINUM(r), 
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), EOL)));
} /* fl_get_string_height */
SUBR_int__2int_charptr_int(fl_get_string_width);
SUBR_int__2int_charptr_int(fl_get_string_widthTAB);
static char s_fl_get_string_dimension[]="fl_get_string_dimension";
SCM nfl_get_string_dimension(SCM _i1, SCM _i2, SCM _args)
{
  SCM _s, _i3;
  int i1, i2;
  ASSERT(ilength(_args)==2, _args, ARG3, s_fl_get_string_dimension);
  _s=CAR(_args); _args=CDR(_args);
  _i3=CAR(_args);
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_get_string_dimension);  
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_get_string_dimension);  
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG3, s_fl_get_string_dimension);  
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_get_string_dimension);  
  SFDEBUGMSG(s_fl_get_string_dimension);
  fl_get_string_dimension(INUM(_i1), INUM(_i2), CHARS(_s), 
			  INUM(_i3), &i1, &i2);
  return cons(MAKINUM(i1), 
	      cons(MAKINUM(i2), EOL));
} /* fl_get_string_dimension */
static char s_fl_get_align_xy[]="fl_get_align_xy";
SCM nfl_get_align_xy(SCM _i1, SCM _i2, SCM _args)
{
  SCM _i3, _i4, _i5, _i6, _i7, _i8, _i9;
  int i1, i2;
  ASSERT(ilength(_args)==7, _args, ARG3, s_fl_get_align_xy);
  _i3=CAR(_args); _args=CDR(_args);
  _i4=CAR(_args); _args=CDR(_args);
  _i5=CAR(_args); _args=CDR(_args);
  _i6=CAR(_args); _args=CDR(_args);
  _i7=CAR(_args); _args=CDR(_args);
  _i8=CAR(_args); _args=CDR(_args);
  _i9=CAR(_args); 
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_get_align_xy);  
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_get_align_xy);  
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_get_align_xy);  
  ASSERT(INUMP(_i4), _i4, ARG4, s_fl_get_align_xy);  
  ASSERT(INUMP(_i5), _i5, ARG5, s_fl_get_align_xy);  
  ASSERT(INUMP(_i6), _i6, ARGn, s_fl_get_align_xy);  
  ASSERT(INUMP(_i7), _i7, ARGn, s_fl_get_align_xy);  
  ASSERT(INUMP(_i8), _i8, ARGn, s_fl_get_align_xy);  
  ASSERT(INUMP(_i9), _i9, ARGn, s_fl_get_align_xy);  
  SFDEBUGMSG(s_fl_get_align_xy);
  fl_get_align_xy(INUM(_i1), INUM(_i2), INUM(_i3), 
		  INUM(_i4), INUM(_i5), INUM(_i6), 
		  INUM(_i7), INUM(_i8), INUM(_i9), &i1, &i2);
  return cons(MAKINUM(i1), 
	      cons(MAKINUM(i2), EOL));
} /* fl_get_align_xy */
SUBR_void__8int_charptr(fl_drw_text); 
SUBR_void__8int_charptr(fl_drw_text_beside); 
static char s_fl_drw_text_cursor[]="fl_drw_text_cursor";
SCM nfl_drw_text_cursor(SCM _i1, SCM _i2, SCM _args)
{ 
  SCM _i3, _i4, _i5, _i6, _i7, _i8, _s, _i9, _i10; 
  ASSERT(ilength(_args)==10, _args, ARG3, s_fl_drw_text_cursor);
  _i3=CAR(_args); _args=CDR(_args);     
  _i4=CAR(_args); _args=CDR(_args);     
  _i5=CAR(_args); _args=CDR(_args);     
  _i6=CAR(_args); _args=CDR(_args);     
  _i7=CAR(_args); _args=CDR(_args);     
  _i8=CAR(_args); _args=CDR(_args);     
  _s=CAR(_args);  _args=CDR(_args);     
  _i9=CAR(_args); _args=CDR(_args);     
  _i10=CAR(_args);                  
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i4), _i4, ARG4, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i5), _i5, ARG5, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i6), _i6, ARGn, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i7), _i7, ARGn, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i8), _i8, ARGn, s_fl_drw_text_cursor);
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARGn, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i9), _i9, ARGn, s_fl_drw_text_cursor);
  ASSERT(INUMP(_i10), _i10, ARGn, s_fl_drw_text_cursor);
  SFDEBUGMSG(s_fl_drw_text_cursor);                    
  fl_drw_text_cursor(INUM(_i1), INUM(_i2), INUM(_i3),
		     INUM(_i4), INUM(_i5), INUM(_i6),
		     INUM(_i7), INUM(_i8), CHARS(_s), 
		     INUM(_i9), INUM(_i10));          
  return UNSPECIFIED;
} /* fl_drw_text_cursor */
SUBR_void__7int(fl_drw_box);
static char s_fl_add_symbol[]="fl_add_symbol";
SCM nfl_add_symbol(SCM _s, SCM _proc, SCM _i)
{
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG1, s_fl_add_symbol);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_add_symbol);
  ASSERT(INUMP(_i), _i, ARG3, s_fl_add_symbol);
  SFDEBUGMSG(s_fl_add_symbol);
  cb_add(loc_symbol_handler, _s, _proc);
  return MAKINUM(fl_add_symbol(CHARS(_s), cb_symbol_handler, INUM(_i)));
} /* fl_add_symbol */
static char s_fl_draw_symbol[]="fl_draw_symbol";
SCM nfl_draw_symbol(SCM _s, SCM _i1, SCM _args)
{
  SCM _i2, _i3, _i4, _i5;
  ASSERT(ilength(_args)==4, _args, ARG3, s_fl_draw_symbol);
  _i2=CAR(_args); _args=CDR(_args);     
  _i3=CAR(_args); _args=CDR(_args);     
  _i4=CAR(_args); _args=CDR(_args);     
  _i5=CAR(_args); 
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG1, s_fl_draw_symbol);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_draw_symbol);
  ASSERT(INUMP(_i2), _i2, ARG3, s_fl_draw_symbol);
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_draw_symbol);
  ASSERT(INUMP(_i4), _i4, ARG5, s_fl_draw_symbol);
  ASSERT(INUMP(_i5), _i5, ARGn, s_fl_draw_symbol);
  SFDEBUGMSG(s_fl_draw_symbol);
  return MAKINUM(fl_draw_symbol(CHARS(_s), INUM(_i1), INUM(_i2), 
				INUM(_i3), INUM(_i4), INUM(_i5)));
} /* fl_draw_symbol */
static char s_fl_drw_slider[]="fl_drw_slider"; 
/* to show what 14 args look like ... */
SCM nfl_drw_slider(SCM _i1, SCM _i2, SCM _args)
{ 
  SCM _i3, _i4, _i5, _i6, _i7, _i8, _d1, _d2, _s, _i9, _i10, _i11; 
  ASSERT(ilength(_args)==12, _args, ARG3, s_fl_drw_slider);
  _i3=CAR(_args); _args=CDR(_args);     
  _i4=CAR(_args); _args=CDR(_args);     
  _i5=CAR(_args); _args=CDR(_args);     
  _i6=CAR(_args); _args=CDR(_args);     
  _i7=CAR(_args); _args=CDR(_args);     
  _i8=CAR(_args); _args=CDR(_args);     
  _d1=CAR(_args); _args=CDR(_args);     
  _d2=CAR(_args); _args=CDR(_args);
  _s=CAR(_args);  _args=CDR(_args);                      
  _i9=CAR(_args); _args=CDR(_args);     
  _i10=CAR(_args); _args=CDR(_args);     
  _i11=CAR(_args); 
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_drw_slider);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_drw_slider);
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_drw_slider);
  ASSERT(INUMP(_i4), _i4, ARG4, s_fl_drw_slider);
  ASSERT(INUMP(_i5), _i5, ARG5, s_fl_drw_slider);
  ASSERT(INUMP(_i6), _i6, ARGn, s_fl_drw_slider);
  ASSERT(INUMP(_i7), _i7, ARGn, s_fl_drw_slider);
  ASSERT(INUMP(_i8), _i8, ARGn, s_fl_drw_slider);
  ASSERT(DOUBLEP(_d1), _d1, ARGn, s_fl_drw_slider);
  ASSERT(DOUBLEP(_d2), _d2, ARGn, s_fl_drw_slider);
  ASSERT(NIMP(_s) &&STRINGP(_s), _s, ARGn, s_fl_drw_slider);
  ASSERT(INUMP(_i9), _i9, ARGn, s_fl_drw_slider);
  ASSERT(INUMP(_i10), _i10, ARGn, s_fl_drw_slider);
  ASSERT(INUMP(_i11), _i11, ARGn, s_fl_drw_slider);
  SFDEBUGMSG(s_fl_drw_slider);                    
  fl_drw_slider(INUM(_i1), INUM(_i2), INUM(_i3),
		INUM(_i4), INUM(_i5), INUM(_i6),
		INUM(_i7), INUM(_i8), DOUBLE(_d1), 
		DOUBLE(_d2), CHARS(_s), INUM(_i9), 
		INUM(_i10), INUM(_i11));       
  return UNSPECIFIED;
} /* fl_drw_slider */
SUBR_int__4int(fl_mapcolor);
SUBR_int__int_charptr(fl_mapcolorname);
SUBR_dummy2(fl_free_colors);
SUBR_dummy2(fl_free_pixels);
SUBR_void__int(fl_set_color_leak);
static char s_fl_getmcolor[]="fl_getmcolor";
SCM nfl_getmcolor(SCM _i)
{
  int r, i1, i2, i3;
  ASSERT(INUMP(_i), _i, ARG1, s_fl_getmcolor);
  SFDEBUGMSG(s_fl_getmcolor);
  r=fl_getmcolor(INUM(_i), &i1, &i2, &i3);
  return cons(MAKINUM(r), 
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), 
			cons(MAKINUM(i3), EOL))));
} /* fl_getmcolor */
static char s_fl_get_pixel[]="fl_get_pixel";
SCM nfl_get_pixel(SCM _i)
{
  ASSERT(INUMP(_i), _i, ARG1, s_fl_get_pixel);
  SFDEBUGMSG(s_fl_get_pixel);
  return ulong2num(fl_get_pixel(INUM(_i)));
} /* fl_get_pixel */
static char s_fl_get_icm_color[]="fl_get_icm_color";
SCM nfl_get_icm_color(SCM _i)
{
  int i1, i2, i3;
  ASSERT(INUMP(_i), _i, ARG1, s_fl_get_icm_color);
  SFDEBUGMSG(s_fl_get_icm_color);
  fl_get_icm_color(INUM(_i), &i1, &i2, &i3);
  return cons(MAKINUM(i1), 
	      cons(MAKINUM(i2), 
		   cons(MAKINUM(i3), EOL)));
} /* fl_get_icm_color */
SUBR_void__4int(fl_set_icm_color);
/* */
SUBR_void__int(fl_color);
SUBR_void__int(fl_bk_color);
SUBR_void__int(fl_textcolor);
SUBR_void__int(fl_bk_textcolor);
SUBR_void__3double(fl_set_gamma);
/* */
SUBR_void__int(fl_show_errors);
static char s_fl_set_error_handler[]="fl_set_error_handler";
SCM nfl_set_error_handler(SCM _proc)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_error_handler);
  SFDEBUGMSG(s_fl_set_error_handler);
  cb_add(loc_error_handler, MAKINUM(0), _proc);
  fl_set_error_handler(cb_error_handler);
  return UNSPECIFIED;
} /* fl_set_error_handler */
SUBR_dummy1(fl_set_error_logfp);
/* some macros */
SUBR_void__formptr_objectptr(fl_add_object);
static char s_fl_addto_form[]="fl_addto_form";
SCM nfl_addto_form(SCM _f)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_addto_form);
  SFDEBUGMSG(s_fl_addto_form);
  fl_addto_form(FORM(_f));
  return UNSPECIFIED;
} /* fl_addto_form */
static char s_fl_make_object[]="fl_make_object";
SCM nfl_make_object(SCM _i1, SCM _i2, SCM _args)
{
  SCM _i3, _i4, _i5, _i6, _s, _proc;
  ASSERT(ilength(_args)==6, _args, ARG3, s_fl_make_object);
  _i3=CAR(_args); _args=CDR(_args);
  _i4=CAR(_args); _args=CDR(_args);
  _i5=CAR(_args); _args=CDR(_args);
  _i6=CAR(_args); _args=CDR(_args);
  _s=CAR(_args); _args=CDR(_args);
  _proc=CAR(_args); 
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_make_object);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_make_object);
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_make_object);
  ASSERT(INUMP(_i4), _i4, ARG4, s_fl_make_object);
  ASSERT(INUMP(_i5), _i5, ARG5, s_fl_make_object);
  ASSERT(INUMP(_i6), _i6, ARGn, s_fl_make_object);
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARGn, s_fl_make_object);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARGn, s_fl_make_object);
  cb_add(loc_new_object_handler, MAKINUM(0), _proc);
  return mkobj(fl_make_object(INUM(_i1), INUM(_i2), 
			      INUM(_i3), INUM(_i4),
			      INUM(_i5), INUM(_i6),
			      CHARS(_s), cb_new_object_handler));
}
SUBR_void__int(fl_set_coordunit);
SUBR_void__int(fl_set_border_width);
SUBR_void__int(fl_set_scrollbar_type);
/* */
SUBR_void__void(fl_flip_yorigin);
/* */
SUBR_int__void(fl_get_coordunit);
SUBR_int__void(fl_get_border_width);
/* misc. routines */
SUBR_void__int(fl_ringbell);
SUBR_2int__void(fl_gettime);
SUBR_charptr__void(fl_now);
SUBR_charptr__void(fl_whoami);
SUBR_int__void(fl_mouse_button);
SUBR_dummy1(fl_free);     
SUBR_dummy1(fl_malloc);   
SUBR_dummy2(fl_calloc);  
SUBR_dummy2(fl_realloc); 

void s_init_basic_fct()
{
  MSUBR_L(fl_add_io_callback);
  MSUBR_3(fl_remove_io_callback);
  MSUBR_3(fl_add_signal_callback);
  MSUBR_1(fl_remove_signal_callback);
  MSUBR_1(fl_signal_caught);
  MSUBR_1(fl_app_signal_direct);
  MSUBR_3(fl_add_timeout);
  MSUBR_1(fl_remove_timeout);
  MSUBR_d2(fl_get_vn_value);
  MSUBR_d2(fl_get_vn_name); 
  MSUBR_1(fl_msleep);
  MSUBR_0(fl_library_version);
  MSUBR_3(fl_bgn_form);
  MSUBR_0(fl_end_form);
  MSUBR_0(fl_do_forms);
  MSUBR_0(fl_check_forms);
  MSUBR_0(fl_do_only_forms);
  MSUBR_0(fl_check_only_forms);
  MSUBR_1(fl_freeze_form);
  MSUBR_2(fl_set_focus_object);
  MSUBR_1(fl_get_focus_object);
  MSUBR_1(fl_reset_focus_object);
  MSUBR_3(fl_set_form_atclose);
  MSUBR_2(fl_set_atclose);
  MSUBR_3(fl_set_form_atdeactivate);
  MSUBR_3(fl_set_form_atactivate);
  MSUBR_1(fl_unfreeze_form);
  MSUBR_1(fl_deactivate_form);
  MSUBR_1(fl_activate_form);
  MSUBR_0(fl_deactivate_all_forms);
  MSUBR_0(fl_activate_all_forms);
  MSUBR_0(fl_freeze_all_forms);
  MSUBR_0(fl_unfreeze_all_forms);
  MSUBR_3(fl_scale_form);
  MSUBR_3(fl_set_form_position);
  MSUBR_2(fl_set_form_title);
  MSUBR_2(fl_set_form_property);
  MSUBR_1(fl_set_app_mainform);
  MSUBR_0(fl_get_app_mainform);
  MSUBR_1(fl_set_app_nomainform);
  MSUBR_3(fl_set_form_callback);
  MSUBR_3(fl_set_form_size);
  MSUBR_3(fl_set_form_hotspot);
  MSUBR_2(fl_set_form_hotobject);
  MSUBR_3(fl_set_form_minsize);
  MSUBR_3(fl_set_form_maxsize);
  MSUBR_2(fl_set_form_event_cmask);
  MSUBR_1(fl_get_form_event_cmask);
  MSUBR_L(fl_set_form_geometry);
  MSUBR_L(fl_show_form);
  MSUBR_1(fl_hide_form);
  MSUBR_1(fl_free_form);
  MSUBR_1(fl_redraw_form);
  MSUBR_2(fl_set_form_dblbuffer);
  MSUBR_L(fl_prepare_form_window);
  MSUBR_1(fl_show_form_window);
  MSUBR_1(fl_adjust_form_size);
  MSUBR_1(fl_form_is_visible);
  MSUBR_3(fl_register_raw_callback);
  MSUBR_0(fl_bgn_group);
  MSUBR_0(fl_end_group);
  MSUBR_1(fl_addto_group);
  MSUBR_2(fl_set_object_boxtype);
  MSUBR_2(fl_set_object_bw);
  MSUBR_2(fl_set_object_resize);
  MSUBR_3(fl_set_object_gravity);
  MSUBR_2(fl_set_object_lsize);
  MSUBR_2(fl_set_object_lstyle);
  MSUBR_2(fl_set_object_lcol);
  MSUBR_2(fl_set_object_return);
  MSUBR_2(fl_set_object_lalign);
  MSUBR_3(fl_set_object_shortcut);
  MSUBR_2(fl_set_object_shortcutkey);
  MSUBR_2(fl_set_object_dblbuffer);
  MSUBR_3(fl_set_object_color);
  MSUBR_2(fl_set_object_label);
  MSUBR_3(fl_set_object_position);
  MSUBR_3(fl_set_object_size);
  MSUBR_2(fl_set_object_automatic);
  MSUBR_1(fl_draw_object_label);
  MSUBR_1(fl_draw_object_label_outside);
  MSUBR_L(fl_get_object_component);
  MSUBR_2(fl_set_object_dblclick);
  MSUBR_L(fl_set_object_geometry);
  MSUBR_3(fl_fit_object_label);
  MSUBR_1(fl_get_object_geometry);
  MSUBR_1(fl_get_object_position);
  MSUBR_1(fl_get_object_bbox);
  MSUBR_1(fl_call_object_callback);
  MSUBR_2(fl_set_object_prehandler);
  MSUBR_2(fl_set_object_posthandler);
  MSUBR_3(fl_set_object_callback);
  MSUBR_1(fl_redraw_object);
  MSUBR_3(fl_scale_object);
  MSUBR_1(fl_show_object);
  MSUBR_1(fl_hide_object);
  MSUBR_1(fl_free_object);
  MSUBR_1(fl_delete_object);
  MSUBR_1(fl_trigger_object);
  MSUBR_1(fl_activate_object);
  MSUBR_1(fl_deactivate_object);
  MSUBR_2(fl_enumerate_fonts);
  MSUBR_2(fl_set_font_name);
  MSUBR_2(fl_set_font);
  MSUBR_2(fl_get_char_height);
  MSUBR_2(fl_get_char_width);
  MSUBR_L(fl_get_string_height);
  MSUBR_L(fl_get_string_width);
  MSUBR_L(fl_get_string_widthTAB);
  MSUBR_L(fl_get_string_dimension);
  MSUBR_L(fl_get_align_xy);
  MSUBR_L(fl_drw_text);
  MSUBR_L(fl_drw_text_beside);
  MSUBR_L(fl_drw_text_cursor);
  MSUBR_L(fl_drw_box);
  MSUBR_3(fl_add_symbol);
  MSUBR_L(fl_draw_symbol);
  MSUBR_L(fl_drw_slider);
  MSUBR_L(fl_mapcolor);
  MSUBR_2(fl_mapcolorname);
  MSUBR_d2(fl_free_colors);
  MSUBR_d2(fl_free_pixels);
  /* */
  MSUBR_1(fl_set_color_leak);
  MSUBR_1(fl_getmcolor);
  MSUBR_1(fl_get_pixel);
  MSUBR_1(fl_get_icm_color);
  MSUBR_L(fl_set_icm_color);
  MSUBR_1(fl_color);
  MSUBR_1(fl_bk_color);
  MSUBR_1(fl_textcolor);
  MSUBR_1(fl_bk_textcolor);
  MSUBR_3(fl_set_gamma);
  MSUBR_1(fl_show_errors);
  MSUBR_1(fl_set_error_handler);
  MSUBR_d1(fl_set_error_logfp);
  MSUBR_2(fl_add_object);
  MSUBR_1(fl_addto_form);
  MSUBR_L(fl_make_object);
  MSUBR_1(fl_set_coordunit);
  MSUBR_1(fl_set_border_width);
  MSUBR_1(fl_set_scrollbar_type);
  MSUBR_0(fl_flip_yorigin);
  MSUBR_0(fl_get_coordunit);
  MSUBR_0(fl_get_border_width);
  MSUBR_1(fl_ringbell);
  MSUBR_0(fl_gettime);
  MSUBR_0(fl_now);
  MSUBR_0(fl_whoami);
  MSUBR_0(fl_mouse_button);
  /* */
  MSUBR_d1(fl_free);
  MSUBR_d1(fl_malloc);
  MSUBR_d2(fl_calloc);
  MSUBR_d2(fl_realloc);
  return;
}

/*
** EOF
*/
