/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_browser.c
** oct 25 1998
** nov 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_browser_sym()
{
  /* types */
  sysintern("fl_normal_browser",     MAKINUM(FL_NORMAL_BROWSER));
  sysintern("fl_select_browser",     MAKINUM(FL_SELECT_BROWSER));
  sysintern("fl_hold_browser",       MAKINUM(FL_HOLD_BROWSER));
  sysintern("fl_multi_browser",      MAKINUM(FL_MULTI_BROWSER));
  /* others */
  sysintern("fl_browser_linelength", MAKINUM(FL_BROWSER_LINELENGTH));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_browser);
SUBR_objectptr__5int_charptr(fl_add_browser);
/* */
SUBR_void__objectptr(fl_clear_browser);
SUBR_void__objectptr_charptr(fl_add_browser_line);
SUBR_void__objectptr_charptr(fl_addto_browser);
SUBR_void__objectptr_charptr(fl_addto_browser_chars);
SUBR_void__objectptr_int_charptr(fl_insert_browser_line);
SUBR_void__objectptr_int(fl_delete_browser_line);
SUBR_void__objectptr_int_charptr(fl_replace_browser_line);
SUBR_charptr__objectptr_int(fl_get_browser_line);
SUBR_int__objectptr_charptr(fl_load_browser);
/* */
SUBR_void__objectptr_int(fl_select_browser_line);
SUBR_void__objectptr_int(fl_deselect_browser_line);
SUBR_void__objectptr(fl_deselect_browser);
SUBR_int__objectptr_int(fl_isselected_browser_line);
/* */
SUBR_int__objectptr(fl_get_browser_topline);
SUBR_int__objectptr(fl_get_browser);
SUBR_int__objectptr(fl_get_browser_maxline);
SUBR_int__objectptr(fl_get_browser_screenlines);
/* */
SUBR_void__objectptr_int(fl_set_browser_topline);
SUBR_void__objectptr_int(fl_set_browser_fontsize);
SUBR_void__objectptr_int(fl_set_browser_fontstyle);
SUBR_void__objectptr_int(fl_set_browser_specialkey);
SUBR_void__objectptr_int(fl_set_browser_vscrollbar);
SUBR_void__objectptr_int(fl_set_browser_hscrollbar);
SUBR_void__objectptr_2int(fl_set_browser_line_selectable);
SUBR_4int__objectptr(fl_get_browser_dimension);
static char s_fl_set_browser_dblclick_callback[]=
"fl_set_browser_dblclick_callback";
SCM nfl_set_browser_dblclick_callback(SCM _o, SCM _proc, SCM _data)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_browser_dblclick_callback);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, 
	 s_fl_set_browser_dblclick_callback);
  ASSERT(INUMP(_data), _data, ARG3, s_fl_set_browser_dblclick_callback);
  SFDEBUGMSG(s_fl_set_browser_dblclick_callback);
  cb_add(loc_browser_dblclick_callback, _o, _proc);
  fl_set_browser_dblclick_callback(OBJ(_o), 
				   cb_browser_dblclick_callback, 
				   MAKINUM(_data));
  return UNSPECIFIED;
} /* fl_set_browser_dblclick_callback */
SUBR_void__objectptr_int(fl_set_browser_xoffset);
SUBR_int__objectptr(fl_get_browser_xoffset);
SUBR_void__objectptr_2int(fl_set_browser_scrollbarsize);
SUBR_void__objectptr_int(fl_show_browser_line);

/* initialize functions */
void s_init_browser_fct()
{
  MSUBR_L(fl_create_browser);
  MSUBR_L(fl_add_browser);
  MSUBR_1(fl_clear_browser);
  MSUBR_2(fl_add_browser_line);
  MSUBR_2(fl_addto_browser);
  MSUBR_2(fl_addto_browser_chars);
  MSUBR_3(fl_insert_browser_line);
  MSUBR_2(fl_delete_browser_line);
  MSUBR_3(fl_replace_browser_line);
  MSUBR_2(fl_get_browser_line);
  MSUBR_2(fl_load_browser);
  MSUBR_2(fl_select_browser_line);
  MSUBR_2(fl_deselect_browser_line);
  MSUBR_1(fl_deselect_browser);
  MSUBR_2(fl_isselected_browser_line);
  MSUBR_1(fl_get_browser_topline);
  MSUBR_1(fl_get_browser);
  MSUBR_1(fl_get_browser_maxline);
  MSUBR_1(fl_get_browser_screenlines);
  MSUBR_2(fl_set_browser_topline);
  MSUBR_2(fl_set_browser_fontsize);
  MSUBR_2(fl_set_browser_fontstyle);
  MSUBR_2(fl_set_browser_specialkey);
  MSUBR_2(fl_set_browser_vscrollbar);
  MSUBR_2(fl_set_browser_hscrollbar);
  MSUBR_3(fl_set_browser_line_selectable);
  MSUBR_1(fl_get_browser_dimension);
  MSUBR_3(fl_set_browser_dblclick_callback);
  MSUBR_2(fl_set_browser_xoffset);
  MSUBR_1(fl_get_browser_xoffset);
  MSUBR_3(fl_set_browser_scrollbarsize);
  MSUBR_2(fl_show_browser_line);
  return;
}

/*
** EOF
*/
