/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_button.c
** oct 28 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_button_sym()
{
  /* types */
  sysintern("fl_normal_button",         MAKINUM(FL_NORMAL_BUTTON));
  sysintern("fl_push_button",           MAKINUM(FL_PUSH_BUTTON));
  sysintern("fl_radio_button",          MAKINUM(FL_RADIO_BUTTON));
  sysintern("fl_hidden_button",         MAKINUM(FL_HIDDEN_BUTTON));
  sysintern("fl_touch_button",          MAKINUM(FL_TOUCH_BUTTON));
  sysintern("fl_inout_button",          MAKINUM(FL_INOUT_BUTTON));
  sysintern("fl_return_button",         MAKINUM(FL_RETURN_BUTTON));
  sysintern("fl_hidden_ret_button",     MAKINUM(FL_HIDDEN_RET_BUTTON));
  sysintern("fl_menu_button",           MAKINUM(FL_MENU_BUTTON));
  /* */
  sysintern("fl_lightbutton_minsize",   MAKINUM(FL_LIGHTBUTTON_MINSIZE));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_button);
SUBR_objectptr__5int_charptr(fl_create_roundbutton);
SUBR_objectptr__5int_charptr(fl_create_round3dbutton);
SUBR_objectptr__5int_charptr(fl_create_lightbutton);
SUBR_objectptr__5int_charptr(fl_create_checkbutton);
SUBR_objectptr__5int_charptr(fl_create_bitmapbutton);
SUBR_objectptr__5int_charptr(fl_create_pixmapbutton);
SUBR_objectptr__5int_charptr(fl_create_scrollbutton);
/* */
SUBR_objectptr__5int_charptr(fl_add_roundbutton);
SUBR_objectptr__5int_charptr(fl_add_round3dbutton);
SUBR_objectptr__5int_charptr(fl_add_lightbutton);
SUBR_objectptr__5int_charptr(fl_add_checkbutton);
SUBR_objectptr__5int_charptr(fl_add_button);
SUBR_objectptr__5int_charptr(fl_add_bitmapbutton);
SUBR_objectptr__5int_charptr(fl_add_scrollbutton);
/* */
SUBR_void__objectptr_charptr(fl_set_bitmapbutton_file);
SUBR_void__objectptr_2int_charptr(fl_set_bitmapbutton_data);
SUBR_objectptr__5int_charptr(fl_add_pixmapbutton);
/* */
SUBR_void__objectptr_int(fl_set_pixmapbutton_focus_outline);
SUBR_int__objectptr(fl_get_button);
SUBR_void__objectptr_int(fl_set_button);
SUBR_int__objectptr(fl_get_button_numb);
static char s_fl_create_generic_button[]="fl_create_generic_button";
SCM nfl_create_generic_button(SCM _i1, SCM _i2, SCM _args)
{
  SCM _i3, _i4, _i5, _i6, _s;
  ASSERT(ilength(_args)==5, UNDEFINED, WNA, s_fl_create_generic_button);
  _i3=CAR(_args); _args=CDR(_args);
  _i4=CAR(_args); _args=CDR(_args);
  _i5=CAR(_args); _args=CDR(_args);
  _i6=CAR(_args); _args=CDR(_args);
  _s=CAR(_args); _args=CDR(_args);
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_create_generic_button);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_create_generic_button);
  ASSERT(INUMP(_i3), _i3, ARG3, s_fl_create_generic_button);
  ASSERT(INUMP(_i4), _i4, ARG4, s_fl_create_generic_button);
  ASSERT(INUMP(_i5), _i5, ARG5, s_fl_create_generic_button);
  ASSERT(INUMP(_i6), _i6, ARGn, s_fl_create_generic_button);
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARGn, s_fl_create_generic_button);
  SFDEBUGMSG(s_fl_create_generic_button);
  return mkobj(fl_create_generic_button(INUM(_i1), INUM(_i2), 
					INUM(_i3), INUM(_i4), 
					INUM(_i5), INUM(_i6), CHARS(_s)));
} /* fl_create_generic_button */
static char s_fl_add_button_class[]="fl_add_button_class";
SCM nfl_add_button_class(SCM _i, SCM _proc1, SCM _proc2)
{
  ASSERT(INUMP(_i), _i, ARG1, s_fl_add_button_class);
  ASSERT(BOOL_T==procedurep(_proc1), _proc1, ARG2, s_fl_add_button_class);
  ASSERT(BOOL_T==procedurep(_proc2), _proc2, ARG3, s_fl_add_button_class);
  SFDEBUGMSG(s_fl_add_button_class);
  cb_add(loc_draw_button, _i, _proc1);
  cb_add(loc_cleanup_button, MAKINUM(0), _proc2); /* */
  fl_add_button_class(INUM(_i), cb_draw_button, cb_cleanup_button);
  return UNSPECIFIED;
} /* fl_ad_button_class */

/* initialize functions */
void s_init_button_fct()
{
  MSUBR_L(fl_create_button);
  MSUBR_L(fl_create_roundbutton);
  MSUBR_L(fl_create_round3dbutton);
  MSUBR_L(fl_create_lightbutton);
  MSUBR_L(fl_create_checkbutton);
  MSUBR_L(fl_create_bitmapbutton);
  MSUBR_L(fl_create_pixmapbutton);
  MSUBR_L(fl_add_roundbutton);
  MSUBR_L(fl_add_round3dbutton);
  MSUBR_L(fl_add_lightbutton);
  MSUBR_L(fl_add_checkbutton);
  MSUBR_L(fl_add_button);
  MSUBR_L(fl_add_bitmapbutton);
  MSUBR_2(fl_set_bitmapbutton_file);
  MSUBR_L(fl_set_bitmapbutton_data);
  MSUBR_L(fl_add_pixmapbutton);
  MSUBR_2(fl_set_pixmapbutton_focus_outline);
  MSUBR_1(fl_get_button);
  MSUBR_2(fl_set_button);
  MSUBR_1(fl_get_button_numb);
  MSUBR_L(fl_create_generic_button);
  MSUBR_3(fl_add_button_class);
  return;
}

/*
** EOF
*/
