/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_chart.c
** oct 26 1998
** nov 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_chart_sym()
{
  /* types */
  sysintern("fl_bar_chart",        MAKINUM(FL_BAR_CHART));
  sysintern("fl_horbar_chart",     MAKINUM(FL_HORBAR_CHART));
  sysintern("fl_line_chart",       MAKINUM(FL_LINE_CHART));
  sysintern("fl_fill_chart",       MAKINUM(FL_FILL_CHART));
  sysintern("fl_spike_chart",      MAKINUM(FL_SPIKE_CHART));
  sysintern("fl_pie_chart",        MAKINUM(FL_PIE_CHART));
  sysintern("fl_specialpie_chart", MAKINUM(FL_SPECIALPIE_CHART));
  /* others */
  sysintern("fl_chart_max",        MAKINUM(FL_CHART_MAX));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_chart);
SUBR_objectptr__5int_charptr(fl_add_chart);
SUBR_void__objectptr(fl_clear_chart);
SUBR_void__objectptr_double_charptr_int(fl_add_chart_value);
SUBR_void__objectptr_int_double_charptr_int(fl_insert_chart_value);
SUBR_void__objectptr_int_double_charptr_int(fl_replace_chart_value);
SUBR_void__objectptr_2double(fl_set_chart_bounds);
SUBR_void__objectptr_int(fl_set_chart_maxnumb);
SUBR_void__objectptr_int(fl_set_chart_autosize);
SUBR_void__objectptr_int(fl_set_chart_lstyle);
SUBR_void__objectptr_int(fl_set_chart_lsize);
SUBR_void__objectptr_int(fl_set_chart_lcolor);

/* initialize functions */
void s_init_chart_fct()
{
  MSUBR_L(fl_create_chart);
  MSUBR_L(fl_add_chart);
  MSUBR_1(fl_clear_chart);
  MSUBR_L(fl_add_chart_value);
  MSUBR_L(fl_insert_chart_value);
  MSUBR_L(fl_replace_chart_value);
  MSUBR_3(fl_set_chart_bounds);
  MSUBR_2(fl_set_chart_maxnumb);
  MSUBR_2(fl_set_chart_autosize);
  MSUBR_2(fl_set_chart_lstyle);
  MSUBR_2(fl_set_chart_lsize);
  MSUBR_2(fl_set_chart_lcolor);
  return;
}

/*
** EOF
*/
