/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_clipbd.c
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_clipbd_sym()
{
  /* */
  return;
}

/* routines */
static char s_fl_stuff_clipboard[]="fl_stuff_clipboard";
SCM nfl_stuff_clipboard(SCM _o, SCM _i1, SCM _args)
{
  SCM _data, _i2, _proc;
  ASSERT(ilength(_args)==3, _args, UNDEFINED, s_fl_stuff_clipboard);
  _data=CAR(_args); _args=CDR(_args);
  _i2=CAR(_args); _args=CDR(_args);
  _proc=CAR(_args); 
  ASSERT(OBJP(_o), _o, ARG1, s_fl_stuff_clipboard);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_stuff_clipboard);
  /*ASSERT(INUMP(_data), _data, ARG3, s_fl_stuff_clipboard);*/
  ASSERT(INUMP(_i2), _i2, ARG4, s_fl_stuff_clipboard);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG5, s_fl_stuff_clipboard);
  cb_add(loc_stuff_clipboard_callback, _o, _proc);
  return MAKINUM(fl_stuff_clipboard(OBJ(_o), INUM(_i1), 
				    (void *)_data, INUM(_i2), 
				    cb_stuff_clipboard));
} /* fl_stuff_clipboard */
static char s_fl_request_clipboard[]="fl_request_clipboard";
SCM nfl_request_clipboard(SCM _o, SCM _i1, SCM _proc)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_request_clipboard);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_request_clipboard);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG3, s_fl_request_clipboard);
  cb_add(loc_request_clipboard_callback, _o, _proc);
  return MAKINUM(fl_request_clipboard(OBJ(_o), INUM(_i1), 
				      cb_request_clipboard));
} /* fl_request_clipboard */

/* initialize functions */
void s_init_clipbd_fct()
{
  MSUBR_L(fl_stuff_clipboard);
  MSUBR_L(fl_request_clipboard);
  return;
}

/*
** EOF
*/
