/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_clock.c
** oct 25 1998
** nov 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_clock_sym()
{
  /* types */
  sysintern("fl_analog_clock",  MAKINUM(FL_ANALOG_CLOCK));
  sysintern("fl_digital_clock", MAKINUM(FL_DIGITAL_CLOCK));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_clock);
SUBR_objectptr__5int_charptr(fl_add_clock);
static char s_fl_get_clock[]="fl_get_clock";
SCM nfl_get_clock(SCM _o)
{
  int i1, i2, i3;
  ASSERT(OBJP(_o), _o, ARG1, s_fl_get_clock);
  SFDEBUGMSG(s_fl_get_clock);
  fl_get_clock(OBJ(_o), &i1, &i2, &i3);
  return cons(MAKINUM(i1), 
	      cons(MAKINUM(i2), 
		   cons(MAKINUM(i3), EOL)));
} /* fl_get_clock */
static char s_fl_set_clock_adjustment[]="fl_set_clock_adjustment";
SCM nfl_set_clock_adjustment(SCM _o, SCM _i)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_clock_adjustment);
  ASSERT(INUMP(_i), _i, ARG2, s_fl_set_clock_adjustment);
  SFDEBUGMSG(s_fl_set_clock_adjustment);
  return long2num(fl_set_clock_adjustment(OBJ(_o), INUM(_i)));
} /* fl_set_clock_adjustment */
SUBR_void__objectptr_int(fl_set_clock_ampm);

/* initialize functions */
void s_init_clock_fct()
{
  MSUBR_L(fl_create_clock);
  MSUBR_L(fl_add_clock);
  MSUBR_1(fl_get_clock);
  MSUBR_2(fl_set_clock_adjustment);
  MSUBR_2(fl_set_clock_ampm);
  return;
}

/*
** EOF
*/




