/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_counter.c
** oct 25 1998 
** nov 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_counter_sym()
{
  /* types */
  sysintern("fl_normal_counter",  MAKINUM(FL_NORMAL_COUNTER));
  sysintern("fl_simple_counter",  MAKINUM(FL_SIMPLE_COUNTER));
  /* others */
  sysintern("fl_counter_bw",      MAKINUM(FL_COUNTER_BW));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_counter);
SUBR_objectptr__5int_charptr(fl_add_counter);
SUBR_void__objectptr_double(fl_set_counter_value);
SUBR_void__objectptr_2double(fl_set_counter_bounds);
SUBR_void__objectptr_2double(fl_set_counter_step);
SUBR_void__objectptr_int(fl_set_counter_precision);
SUBR_void__objectptr_int(fl_set_counter_return);
SUBR_double__objectptr(fl_get_counter_value);
SUBR_2double__objectptr(fl_get_counter_bounds);
SUBR_2float__objectptr(fl_get_counter_step);
static char s_fl_set_counter_filter[]="fl_set_counter_filter";
SCM nfl_set_counter_filter(SCM _o, SCM _proc)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_counter_filter);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_counter_filter);
  SFDEBUGMSG(s_fl_set_counter_filter);
  cb_add(loc_counter_filter, _o, _proc);
  fl_set_counter_filter(OBJ(_o), cb_counter_filter);
  return UNSPECIFIED;
} /* fl_set_counter_filter */

/* initialize functions */
void s_init_counter_fct()
{
  MSUBR_L(fl_create_counter);
  MSUBR_L(fl_add_counter);
  MSUBR_2(fl_set_counter_value);
  MSUBR_3(fl_set_counter_bounds);
  MSUBR_3(fl_set_counter_step);
  MSUBR_2(fl_set_counter_precision);
  MSUBR_2(fl_set_counter_return);
  MSUBR_1(fl_get_counter_value);
  MSUBR_1(fl_get_counter_bounds);
  MSUBR_1(fl_get_counter_step);
  MSUBR_2(fl_set_counter_filter);
  return;
}

/*
** EOF
*/
