/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_dial.c
** oct 25 1998
** nov 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_dial_sym()
{
  /* types */
  sysintern("fl_normal_dial",  MAKINUM(FL_NORMAL_DIAL));
  sysintern("fl_line_dial",    MAKINUM(FL_LINE_DIAL));
  sysintern("fl_fill_dial",    MAKINUM(FL_FILL_DIAL));
  /* */
  sysintern("fl_dial_cw",      MAKINUM(FL_DIAL_CW)); 
  sysintern("fl_dial_ccw",     MAKINUM(FL_DIAL_CCW));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_dial);
SUBR_objectptr__5int_charptr(fl_add_dial);
/* */
SUBR_void__objectptr_double(fl_set_dial_value);
SUBR_double__objectptr(fl_get_dial_value);
SUBR_void__objectptr_2double(fl_set_dial_bounds);
SUBR_2double__objectptr(fl_get_dial_bounds);
/* */
SUBR_void__objectptr_double(fl_set_dial_step);
SUBR_void__objectptr_int(fl_set_dial_return);
SUBR_void__objectptr_2double(fl_set_dial_angles);
SUBR_void__objectptr_int(fl_set_dial_cross);
SUBR_void__objectptr_int(fl_set_dial_direction);

/* initialize functions */
void s_init_dial_fct()
{
  MSUBR_L(fl_create_dial);
  MSUBR_L(fl_add_dial);
  MSUBR_2(fl_set_dial_value);
  MSUBR_1(fl_get_dial_value);
  MSUBR_3(fl_set_dial_bounds);
  MSUBR_1(fl_get_dial_bounds);
  MSUBR_2(fl_set_dial_step);
  MSUBR_2(fl_set_dial_return);
  MSUBR_3(fl_set_dial_angles);
  MSUBR_2(fl_set_dial_cross);
  MSUBR_2(fl_set_dial_direction);
  return;
}

/*
** EOF
*/
