/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_dmacro.h - function return a real/double precision number
** nov 07 1998
*/

#define SUBR_double__double(_func)         \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(SCM _d){                    \
ASSERT(DOUBLEP(_d), _d, ARG1, #_func);     \
SFDEBUGMSG(s_ ##_func);                    \
return makdbl(_func(DOUBLE(_d)),           \
              0.0);}                /* ok */

#define SUBR_double__2double(_func)        \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(SCM _d1, SCM _d2){          \
ASSERT(DOUBLEP(_d1), _d1, ARG1, #_func);   \
ASSERT(DOUBLEP(_d2), _d2, ARG2, #_func);   \
SFDEBUGMSG(s_ ##_func);                    \
return makdbl(_func(DOUBLE(_d1),           \
              DOUBLE(_d2)), 0.0);}  /* ok */

#define SUBR_double__objectptr(_func)      \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(SCM _o){                    \
ASSERT(OBJP(_o), _o, ARG1, #_func);        \
SFDEBUGMSG(s_ ##_func);                    \
return makdbl(_func(OBJ(_o)),              \
              0.0);}                /* ok */

#define SUBR_double__formptr(_func)        \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(SCM _f){                    \
ASSERT(FORMP(_f), _f, ARG1, #_func);       \
SFDEBUGMSG(s_ ##_func);                    \
return makdbl(_func(FORM(_f)),             \
              0.0);}                 /* ok */

/*
** EOF
*/
