/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_event.c
** dec 07 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_event_sym()
{
  /* used as indices for XEvent structure members */
  sysintern("xev_type",              MAKINUM( 1));
  sysintern("xev_serial",            MAKINUM( 2));
  sysintern("xev_send_event",        MAKINUM( 3));
  sysintern("xev_display",           MAKINUM( 4));
  sysintern("xev_window",            MAKINUM( 5));
  /* */
  sysintern("xev_root",              MAKINUM( 6));
  sysintern("xev_subwindow",         MAKINUM( 7));
  sysintern("xev_time",              MAKINUM( 8));
  sysintern("xev_x",                 MAKINUM(19));
  sysintern("xev_y",                 MAKINUM(10));
  sysintern("xev_x_root",            MAKINUM(11));
  sysintern("xev_y_root",            MAKINUM(12));
  sysintern("xev_width",             MAKINUM(13));
  sysintern("xev_height",            MAKINUM(14));
  sysintern("xev_count",             MAKINUM(15));
  sysintern("xev_state",             MAKINUM(16));
  sysintern("xev_button",            MAKINUM(17));
  sysintern("xev_is_hint",           MAKINUM(18));
  sysintern("xev_mode",              MAKINUM(19));
  sysintern("xev_detail",            MAKINUM(20));
  sysintern("xev_same_screen",       MAKINUM(21));
  sysintern("xev_focus",             MAKINUM(22));
  sysintern("xev_drawable",          MAKINUM(23));
  sysintern("xev_major_code",        MAKINUM(24));
  sysintern("xev_minor_code",        MAKINUM(25));
  sysintern("xev_parent",            MAKINUM(26));
  sysintern("xev_border_width",      MAKINUM(27));
  sysintern("xev_override_redirect", MAKINUM(28));
  sysintern("xev_event",             MAKINUM(29));
  sysintern("xev_from_configure",    MAKINUM(30));
  sysintern("xev_above",             MAKINUM(31));
  sysintern("xev_value_mask",        MAKINUM(32));
  sysintern("xev_place",             MAKINUM(33));
  sysintern("xev_atom",              MAKINUM(34));
  sysintern("xev_selection",         MAKINUM(35));
  sysintern("xev_target",            MAKINUM(36));
  sysintern("xev_property",          MAKINUM(37));
  sysintern("xev_owner",             MAKINUM(38));
  sysintern("xev_requestor",         MAKINUM(39));
  sysintern("xev_colormap",          MAKINUM(40));
  sysintern("xev_new",               MAKINUM(41));
  sysintern("xev_message_type",      MAKINUM(42));
  sysintern("xev_format",            MAKINUM(43));
  sysintern("xev_data",              MAKINUM(44));
  sysintern("xev_error_code",        MAKINUM(45));
  sysintern("xev_request_code",      MAKINUM(46));
  sysintern("xev_resourceid",        MAKINUM(47));
  sysintern("xev_key_vector",        MAKINUM(48));
  sysintern("xev_keycode",           MAKINUM(49));
  sysintern("xev_first_keycode",     MAKINUM(50));
  sysintern("xev_request",           MAKINUM(51));
  return;
}

#define xev_type               1
#define xev_serial             2
#define xev_send_event         3
#define xev_display            4
#define xev_window             5
/* */
#define xev_root               6
#define xev_subwindow          7
#define xev_time               8
#define xev_x                 19
#define xev_y                 10
#define xev_x_root            11
#define xev_y_root            12
#define xev_width             13
#define xev_height            14
#define xev_count             15
#define xev_state             16
#define xev_button            17
#define xev_is_hint           18
#define xev_mode              19
#define xev_detail            20
#define xev_same_screen       21
#define xev_focus             22
#define xev_drawable          23
#define xev_major_code        24
#define xev_minor_code        25
#define xev_parent            26
#define xev_border_width      27
#define xev_override_redirect 28
#define xev_event             29
#define xev_from_configure    30
#define xev_above             31
#define xev_value_mask        32
#define xev_place             33
#define xev_atom              34
#define xev_selection         35
#define xev_target            36
#define xev_property          37
#define xev_owner             38
#define xev_requestor         39
#define xev_colormap          40
#define xev_new               41
#define xev_message_type      42
#define xev_format            43
#define xev_data              44
#define xev_error_code        45
#define xev_request_code      46
#define xev_resourceid        47
#define xev_key_vector        48
#define xev_keycode           49
#define xev_first_keycode     50
#define xev_request           51


#define rtype \
if (i==xev_type) return MAKINUM(xsev.type);
#define rserial \
if (i==xev_serial) return ulong2num(xsev.serial);
#define rsend_event \
if (i==xev_send_event) return MAKINUM(xsev.send_event); /* bool */
#define rdisplay \
if (i==xev_display) return mkdis(xsev.display);
#define rwindow \
if (i==xev_window) return mkwin(xsev.window);
/* */
#define rroot \
if (i==xev_root) return mkwin(xsev.root);
#define rsubwindow \
if (i==xev_subwindow) return mkwin(xsev.subwindow);
#define rtime \
if (i==xev_time) return BOOL_F; /* ? Time*/
#define rx \
if (i==xev_x) return MAKINUM(xsev.x);
#define ry \
if (i==xev_y) return MAKINUM(xsev.y);
#define rx_root \
if (i==xev_x_root) return MAKINUM(xsev.x_root);
#define ry_root \
if (i==xev_y_root) return MAKINUM(xsev.y_root);
#define rwidth \
if (i==xev_width) return MAKINUM(xsev.width);
#define rheight \
if (i==xev_height) return MAKINUM(xsev.height);
#define rcount \
if (i==xev_count) return MAKINUM(xsev.count);
#define rstate \
if (i==xev_state) return MAKINUM(xsev.state); /* unsigned */
#define rbutton \
if (i==xev_button) return MAKINUM(xsev.button); /* unsigned */
#define ris_hint \
if (i==xev_is_hint) return MAKICHR(xsev.is_hint); /* char */
#define rmode \
if (i==xev_mode) return MAKINUM(xsev.mode);
#define rdetail \
if (i==xev_detail) return MAKINUM(xsev.detail);
#define rsame_screen \
if (i==xev_same_screen) return MAKINUM(xsev.same_screen); /* bool */
#define rfocus \
if (i==xev_focus) return MAKINUM(xsev.focus);
#define rdrawable \
if (i==xev_drawable) return BOOL_F; /* drawable */
#define rmajor_code \
if (i==xev_major_code) return MAKINUM(xsev.major_code);
#define rminor_code \
if (i==xev_minor_code) return MAKINUM(xsev.minor_code);
#define rparent \
if (i==xev_parent) return mkwin(xsev.parent);
#define rborder_width \
if (i==xev_border_width) return MAKINUM(xsev.border_width);
#define roverride_redirect \
if (i==xev_override_redirect) return MAKINUM(xsev.override_redirect);
#define revent \
if (i==xev_event) return mkwin(xsev.event);
#define rfrom_configure \
if (i==xev_from_configure) return MAKINUM(xsev.from_configure);
#define rabove \
if (i==xev_above) return mkwin(xsev.above);
#define rvalue_mask \
if (i==xev_value_mask) return ulong2num(xsev.value_mask);
#define rplace \
if (i==xev_place) return MAKINUM(xsev.place);
#define ratom \
if (i==xev_atom) return BOOL_F; /* Atom */
#define rselection \
if (i==xev_selection) return BOOL_F; /* Atom */
#define rtarget \
if (i==xev_target) return BOOL_F; /* Atom */
#define rproperty \
if (i==xev_property) return BOOL_F; /* Atom */
#define rowner \
if (i==xev_owner) return mkwin(xsev.owner);
#define rrequestor \
if (i==xev_requestor) return mkwin(xsev.requestor);
#define rcolormap \
if (i==xev_colormap) return BOOL_F; /* Colormap = int */
#define rnew \
if (i==xev_new) return MAKINUM(xsev.new);
#define rmessage_type \
if (i==xev_message_type) return BOOL_F; /* Atom */
#define rformat \
if (i==xev_format) return MAKINUM(xsev.format);
#define rdata \
if (i==xev_data) return BOOL_F; /* union ... */
#define rerror_code \
if (i==xev_error_code) return MAKICHR(xsev.error_code);
#define rrequest_code \
if (i==xev_request_code) return MAKICHR(xsev.request_code);
#define rresourceid \
if (i==xev_resourceid) return BOOL_F; /* */
#define rkey_vector \
if (i==xev_key_vector) return BOOL_F; /* */
#define rkeycode \
if (i==xev_keycode) return MAKINUM(xsev.keycode); /* unsigned */
#define rfirst_keycode \
if (i==xev_first_keycode) return MAKINUM(xsev.first_keycode);
#define rrequest \
if (i==xev_request) return MAKINUM(xsev.request);

SCM get_xkeypress(XKeyEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rroot; rsubwindow; rtime; rx; ry; rx_root; ry_root;
  rstate; rkeycode; rsame_screen;
  return BOOL_F;
}

SCM get_xbutton(XButtonEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rroot; rsubwindow; rtime; rx; ry; rx_root; ry_root;
  rstate; rbutton; rsame_screen;
  return BOOL_F;
}

SCM get_xmotion(XMotionEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rroot; rsubwindow; rtime; rx; ry; rx_root; ry_root;
  rstate; ris_hint; rsame_screen;
  return BOOL_F;
}

SCM get_xcrossing(XCrossingEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rroot; rsubwindow; rtime; rx; ry; rx_root; ry_root;
  rmode; rdetail; rsame_screen; rfocus; rstate;
  return BOOL_F;
}

SCM get_xfocus(XFocusChangeEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rmode; rdetail; 
  return BOOL_F;
}

SCM get_xexpose(XExposeEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rx; ry; rwidth; rheight; rcount;
  return BOOL_F;
}

SCM get_xgraphicsexpose(XGraphicsExposeEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; /* */
  rdrawable; rx; ry; rwidth; rheight; rcount;
  rmajor_code; rminor_code;
  return BOOL_F;
}

SCM get_xnoexpose(XNoExposeEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; /* */
  rdrawable; rmajor_code; rminor_code;
  return BOOL_F;
}

SCM get_xvisibility(XVisibilityEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rstate;
  return BOOL_F;
}

SCM get_xcreatewindow(XCreateWindowEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rparent; 
  rx; ry; rwidth; rheight; rborder_width; roverride_redirect;
  return BOOL_F;
}

SCM get_xdestroywindow(XDestroyWindowEvent xsev, int i)
{  
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent;
  return BOOL_F;
}

SCM get_xunmap(XUnmapEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; rfrom_configure;
  return BOOL_F;
}

SCM get_xmap(XMapEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; roverride_redirect;
  return BOOL_F;
}

SCM get_xmaprequest(XMapRequestEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rparent;
  return BOOL_F;
}

SCM get_xreparent(XReparentEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; rparent; rx; ry; roverride_redirect;
  return BOOL_F;
}

SCM get_xconfigure(XConfigureEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; rx; ry; rwidth; rheight; rborder_width;
  rabove; roverride_redirect;
  return BOOL_F;
}

SCM get_xgravity(XGravityEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; rx; ry;
  return BOOL_F;
}

SCM get_xresizerequest(XResizeRequestEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rwidth; rheight;
  return BOOL_F;
}

SCM get_xconfigurerequest(XConfigureRequestEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rparent; rx; ry; rwidth; rheight; rborder_width;
  rabove; rdetail;
  return BOOL_F;
}

SCM get_xcirculate(XCirculateEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  revent; rplace;
  return BOOL_F;
}

SCM get_xcirculaterequest(XCirculateRequestEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rparent; rplace;
  return BOOL_F;
}

SCM get_xproperty(XPropertyEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  ratom; rtime; rstate;
  return BOOL_F;
}

SCM get_xselectionclear(XSelectionClearEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rselection; rtime;
  return BOOL_F;
}

SCM get_xselectionrequest(XSelectionRequestEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; /* */
  rowner; rrequestor; rselection; rtarget; rproperty; rtime;
  return BOOL_F;
}

SCM get_xselection(XSelectionEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; /* */
  rrequestor; rselection; rtarget; rproperty; rtime; 
  return BOOL_F;
}

SCM get_xcolormap(XColormapEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rcolormap; rnew; rstate;
  return BOOL_F;
}

SCM get_xclient(XClientMessageEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rmessage_type; rformat;
  rdata;
  return BOOL_F;
}

SCM get_xmapping(XMappingEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rrequest; rfirst_keycode; rcount; 
  return BOOL_F;
}

SCM get_xerror(XErrorEvent xsev, int i)
{
  rtype; rserial; /* */ rdisplay; /* */
  rerror_code; rrequest_code; rminor_code; /* but unsigned char this time ! */
  rresourceid;
  return BOOL_F;
}

SCM get_xkeymap(XKeymapEvent xsev, int i)
{
  rtype; rserial; rsend_event; rdisplay; rwindow;
  rkey_vector;
  return BOOL_F;
}

static char s_fl_get_xev_member[]="fl_get_xev_member";
SCM nfl_get_xev_member(SCM sev, SCM i1)
{
  int i;
  XEvent *xev;
  ASSERT(XEVP(sev), sev, ARG1, s_fl_get_xev_member);
  ASSERT(INUMP(i1), i1, ARG2, s_fl_get_xev_member);
  SFDEBUGMSG(s_fl_get_xev_member);
  /* */
  i=INUM(i1);
  xev=XEV(sev);
  switch(xev->type) 
    {
    case KeyPress:
    case KeyRelease:
      return get_xkeypress((XKeyEvent)xev->xkey, i);
    case ButtonPress:
    case ButtonRelease:
      return get_xbutton((XButtonEvent)xev->xbutton, i);
    case MotionNotify:
      return get_xmotion((XMotionEvent)xev->xmotion, i);
    case EnterNotify:
    case LeaveNotify:
      return get_xcrossing((XCrossingEvent)xev->xcrossing, i);
    case FocusIn:
    case FocusOut:
      return get_xfocus(xev->xfocus, i);
    case Expose:
      return get_xexpose(xev->xexpose, i);
    case GraphicsExpose:
      return get_xgraphicsexpose(xev->xgraphicsexpose, i);
    case NoExpose:
      return get_xnoexpose(xev->xnoexpose, i);
    case VisibilityNotify:
      return get_xvisibility(xev->xvisibility, i);
    case CreateNotify:
      return get_xcreatewindow(xev->xcreatewindow, i);
    case DestroyNotify:
      return get_xdestroywindow(xev->xdestroywindow, i);
    case UnmapNotify:
      return get_xunmap(xev->xunmap, i);
    case MapNotify:
      return get_xmap(xev->xmap, i);
    case MapRequest:
      return get_xmaprequest(xev->xmaprequest, i);
    case ReparentNotify:
      return get_xreparent(xev->xreparent, i);
    case ConfigureNotify:
      return get_xconfigure(xev->xconfigure, i);
    case GravityNotify:
      return get_xgravity(xev->xgravity, i);
    case ResizeRequest:
      return get_xresizerequest(xev->xresizerequest, i);
    case ConfigureRequest:
      return get_xconfigurerequest(xev->xconfigurerequest, i);
    case CirculateNotify:
      return get_xcirculate(xev->xcirculate, i);
    case CirculateRequest:
      return get_xcirculaterequest(xev->xcirculaterequest, i);
    case PropertyNotify:
      return get_xproperty(xev->xproperty, i);
    case SelectionClear:
      return get_xselectionclear(xev->xselectionclear, i);
    case SelectionRequest:
      return get_xselectionrequest(xev->xselectionrequest, i);
    case SelectionNotify:
      return get_xselection(xev->xselection, i);
    case ColormapNotify:
      return get_xcolormap(xev->xcolormap, i);
    case ClientMessage:
      return get_xclient(xev->xclient, i);
    case MappingNotify:
      return get_xmapping(xev->xmapping, i);
    case KeymapNotify:
      return get_xkeymap(xev->xkeymap, i);
    default: /* error event */
      return get_xerror(xev->xerror, i);
    }
  return BOOL_F; /* impossible */
}

/* initialize functions */
void s_init_event_fct()
{
  make_subr(s_fl_get_xev_member, tc7_subr_2, nfl_get_xev_member);
  return;
}

/*
** EOF
*/
