/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_flps.c
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_flps_sym()
{
  /* */
  sysintern("flps_auto",      MAKINUM(FLPS_AUTO));
  sysintern("flps_landscape", MAKINUM(FLPS_LANDSCAPE));
  sysintern("flps_portrait",  MAKINUM(FLPS_PORTRAIT));
  /* */
  sysintern("flps_bw",        MAKINUM(FLPS_BW));
  sysintern("flps_grayscale", MAKINUM(FLPS_GRAYSCALE));
  sysintern("flps_color",     MAKINUM(FLPS_COLOR));
  return;
}

/* routines */
static char s_flps_init[]="flps_init";
SCM nflps_init()
{
  FLPS_CONTROL *nps;
  nps=flps_init();
  return 
    cons(MAKINUM(nps->ps_color), 
	 cons(MAKINUM(nps->orientation),
	      cons(MAKINUM(nps->auto_fit),
		   cons(MAKINUM(nps->drawbox),
			cons(MAKINUM(nps->eps),
			     cons(makdbl(nps->xdpi, 0.0),
				  cons(makdbl(nps->ydpi, 0.0),
				       cons(makdbl(nps->paper_w, 0.0),
					    cons(makdbl(nps->paper_h, 0.0),
						 cons(makdbl(nps->gamma, 0.0),
						      EOL)))))))))); 
}
SUBR_int__objectptr_charptr(fl_object_ps_dump);

/* initialize functions */
void s_init_flps_fct()
{
  MSUBR_0(flps_init);
  MSUBR_2(fl_object_ps_dump);
  return;
}

/*
** EOF
*/
