/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_folder.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_folder_sym()
{
  /* types */
  sysintern("fl_top_tabfolder",    MAKINUM(FL_TOP_TABFOLDER));	
  sysintern("fl_bottom_tabfolder", MAKINUM(FL_BOTTOM_TABFOLDER));	
  sysintern("fl_left_tabfolder",   MAKINUM(FL_LEFT_TABFOLDER));	
  sysintern("fl_right_tabfolder",  MAKINUM(FL_RIGHT_TABFOLDER));	
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_tabfolder);
SUBR_objectptr__5int_charptr(fl_add_tabfolder);
/* */
static char s_fl_addto_tabfolder[]="fl_addto_tabfolder";
SCM nfl_addto_tabfolder(SCM _o, SCM _s, SCM _f)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_addto_tabfolder);
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG2, s_fl_addto_tabfolder);
  ASSERT(FORMP(_f), _f, ARG3, s_fl_addto_tabfolder);
  SFDEBUGMSG(s_fl_addto_tabfolder);
  return mkobj(fl_addto_tabfolder(OBJ(_o), CHARS(_s), FORM(_f)));
} /* fl_addto_tabfolder */
SUBR_void__objectptr_formptr(fl_delete_folder);
SUBR_void__objectptr_int(fl_delete_folder_bynumber);
SUBR_void__objectptr_charptr(fl_delete_folder_byname);
/* */
SUBR_void__objectptr_formptr(fl_set_folder);
SUBR_void__objectptr_charptr(fl_set_folder_byname);
SUBR_void__objectptr_int(fl_set_folder_bynumber);
/* */
SUBR_formptr__objectptr(fl_get_folder);
SUBR_int__objectptr(fl_get_folder_number);
SUBR_charptr__objectptr(fl_get_folder_name);
/* */
SUBR_formptr__objectptr(fl_get_active_folder);
SUBR_int__objectptr(fl_get_active_folder_number);
SUBR_charptr__objectptr(fl_get_active_folder_name);
/* */
SUBR_4int__objectptr(fl_get_folder_area);
static char s_fl_replace_folder_bynumber[]="fl_replace_folder_bynumber";
SCM nfl_replace_folder_bynumber(SCM _o, SCM _i, SCM _f)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_replace_folder_bynumber);
  ASSERT(INUMP(_i), _i, ARG2, s_fl_replace_folder_bynumber);
  ASSERT(FORMP(_f), _f, ARG3, s_fl_replace_folder_bynumber);
  SFDEBUGMSG(s_fl_replace_folder_bynumber);
  fl_replace_folder_bynumber(OBJ(_o), INUM(_i), FORM(_f));
  return UNSPECIFIED;
} /* fl_replace_folder_bynumber */

/* initialize functions */
void s_init_folder_fct()
{
  MSUBR_L(fl_create_tabfolder);
  MSUBR_L(fl_add_tabfolder);
  MSUBR_3(fl_addto_tabfolder);
  MSUBR_2(fl_delete_folder);
  MSUBR_2(fl_delete_folder_bynumber);
  MSUBR_2(fl_delete_folder_byname);
  MSUBR_2(fl_set_folder);
  MSUBR_2(fl_set_folder_byname);
  MSUBR_2(fl_set_folder_bynumber);
  MSUBR_1(fl_get_folder);
  MSUBR_1(fl_get_folder_number);
  MSUBR_1(fl_get_folder_name);
  MSUBR_1(fl_get_active_folder);
  MSUBR_1(fl_get_active_folder_number);
  MSUBR_1(fl_get_active_folder_name);
  MSUBR_1(fl_get_folder_area);
  MSUBR_3(fl_replace_folder_bynumber);
  return;
}

/*
** EOF
*/
