/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_frame.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_frame_sym()
{
  /* types */
  sysintern("fl_no_frame",       MAKINUM(FL_NO_FRAME));
  sysintern("fl_up_frame",       MAKINUM(FL_UP_FRAME));
  sysintern("fl_down_frame",     MAKINUM(FL_DOWN_FRAME));
  sysintern("fl_border_frame",   MAKINUM(FL_BORDER_FRAME));
  sysintern("fl_shadow_frame",   MAKINUM(FL_SHADOW_FRAME));
  sysintern("fl_engraved_frame", MAKINUM(FL_ENGRAVED_FRAME));
  sysintern("fl_rounded_frame",  MAKINUM(FL_ROUNDED_FRAME));
  sysintern("fl_embossed_frame", MAKINUM(FL_EMBOSSED_FRAME));
  sysintern("fl_oval_frame",     MAKINUM(FL_OVAL_FRAME));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_frame);
SUBR_objectptr__5int_charptr(fl_add_frame);
/* labeld frame */
SUBR_objectptr__5int_charptr(fl_create_labelframe);
SUBR_objectptr__5int_charptr(fl_add_labelframe);

/* initialize functions */
void s_init_frame_fct()
{
  MSUBR_L(fl_create_frame);
  MSUBR_L(fl_add_frame);
  MSUBR_L(fl_create_labelframe);
  MSUBR_L(fl_add_labelframe);
  return;
}

/*
** EOF
*/
