/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_goodies.c
** oct 20 1998
** noc 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_goodies_sym()
{
  sysintern("fl_max_fselector",    MAKINUM(FL_MAX_FSELECTOR));  
  /* */
  return;
}

/* routines */
SUBR_void__2int(fl_set_goodies_font);
/* messages and questions */
SUBR_void__3charptr(fl_show_message);
SUBR_void__charptr(fl_show_messages);
SUBR_void__void(fl_hide_message);
SUBR_int__charptr_int(fl_show_question);
SUBR_void__void(fl_hide_question);
SUBR_void__3charptr_int(fl_show_alert);
SUBR_void__void(fl_hide_alert);
SUBR_charptr__2charptr(fl_show_input);
SUBR_void__void(fl_hide_input);
SUBR_charptr__2charptr(fl_show_simple_input);
SUBR_int__int(fl_show_colormap);
/* choices */
static char s_fl_show_choices[]="fl_show_choices";
SCM nfl_show_choices(SCM _s1, SCM _i1, SCM _args)
{
  SCM _s2, _s3, _s4, _i2;
  ASSERT(ilength(_args)==4, _args, UNDEFINED, s_fl_show_choices);
  _s2=CAR(_args); _args=CDR(_args);
  _s3=CAR(_args); _args=CDR(_args);
  _s4=CAR(_args); _args=CDR(_args);
  _i2=CAR(_args); 
  ASSERT(NIMP(_s1) && STRINGP(_s1), _s1, ARG1, s_fl_show_choices);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_show_choices);
  ASSERT(NIMP(_s2) && STRINGP(_s2), _s2, ARG3, s_fl_show_choices);
  ASSERT(NIMP(_s3) && STRINGP(_s3), _s3, ARG4, s_fl_show_choices);
  ASSERT(NIMP(_s4) && STRINGP(_s4), _s4, ARG5, s_fl_show_choices);
  ASSERT(INUMP(_i2), _i2, ARGn, s_fl_show_choices);
  SFDEBUGMSG(s_fl_show_choices);
  return MAKINUM(fl_show_choices(CHARS(_s1), INUM(_i1), 
				 CHARS(_s2), CHARS(_s3), 
				 CHARS(_s4), INUM(_i2)));
} /* fl_show_choices */
static char s_fl_show_choice[]="fl_show_choice";
SCM nfl_show_choice(SCM _s1, SCM _s2, SCM _args)
{
  SCM _s3, _i1, _s4, _s5, _s6, _i2;
  ASSERT(ilength(_args)==6, _args, ARG3, s_fl_show_choice);
  _s3=CAR(_args); _args=CDR(_args);
  _i1=CAR(_args); _args=CDR(_args);
  _s4=CAR(_args); _args=CDR(_args);
  _s5=CAR(_args); _args=CDR(_args);
  _s6=CAR(_args); _args=CDR(_args);
  _i2=CAR(_args); 
  ASSERT(NIMP(_s1) && STRINGP(_s1), _s1, ARG1, s_fl_show_choice);
  ASSERT(NIMP(_s2) && STRINGP(_s2), _s2, ARG2, s_fl_show_choice);
  ASSERT(NIMP(_s3) && STRINGP(_s3), _s3, ARG3, s_fl_show_choice);
  ASSERT(INUMP(_i1), _i1, ARG4, s_fl_show_choice);
  ASSERT(NIMP(_s4) && STRINGP(_s4), _s4, ARG5, s_fl_show_choice);
  ASSERT(NIMP(_s5) && STRINGP(_s5), _s5, ARGn, s_fl_show_choice);
  ASSERT(NIMP(_s6) && STRINGP(_s6), _s6, ARGn, s_fl_show_choice);
  ASSERT(INUMP(_i2), _i2, ARGn, s_fl_show_choice);
  SFDEBUGMSG(s_fl_show_choice);
  return MAKINUM(fl_show_choice(CHARS(_s1), CHARS(_s2), CHARS(_s3),
				 INUM(_i1), CHARS(_s4), CHARS(_s5), 
				 CHARS(_s6), INUM(_i2)));
} /* fl_show_choice */
SUBR_void__void(fl_hide_choice);
SUBR_void__3charptr(fl_set_choice_shortcut);
/* one liner */
SUBR_void__charptr_2int(fl_show_oneliner);
SUBR_void__void(fl_hide_oneliner);
SUBR_void__2int(fl_set_oneliner_font);
SUBR_void__2int(fl_set_oneliner_color);
/* command log */
SUBR_int__charptr_int(fl_exe_command); /* returns long */
/* (JL : this can create "zombie" processes) */
SUBR_int__int(fl_end_command);
/* (JL : to kill "zombies") */
SUBR_int__int(fl_check_command);
SUBR_int__void(fl_end_all_command);
SUBR_void__int(fl_show_command_log);
SUBR_void__void(fl_hide_command_log);
SUBR_void__void(fl_clear_command_log);
SUBR_void__charptr(fl_addto_command_log);
SUBR_void__2int(fl_set_command_log_position);
static char s_fl_get_command_log_fdstruct[]="fl_get_command_log_fdstruct";
SCM nfl_get_command_log_fdstruct()
{
  FD_CMDLOG *fdl;
  SFDEBUGMSG(s_fl_get_command_log_fdstruct);
  fdl=fl_get_command_log_fdstruct();
  return (cons(mkobj(fdl->browser), 
	       cons(mkobj(fdl->close_browser),
		    cons(mkobj(fdl->clear_browser), EOL))));
} /* fl_get_command_log_fdstruct */
/* file selector */
SUBR_int__int(fl_use_fselector);
SUBR_charptr__4charptr(fl_show_fselector);
SUBR_void__void(fl_hide_fselector);
SUBR_void__int(fl_set_fselector_fontsize);
SUBR_void__int(fl_set_fselector_fontstyle);
SUBR_void__int(fl_set_fselector_placement);
SUBR_void__int(fl_set_fselector_border);
static char s_fl_set_fselector_callback[]="fl_set_fselector_callback";
SCM nfl_set_fselector_callback(SCM _proc, SCM _data)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG1, s_fl_set_fselector_callback);
  /*ASSERT(INUMP(_data), _data, ARG2, s_fl_set_fselector_callback);*/
  SFDEBUGMSG(s_fl_set_fselector_callback);
  cb_add(loc_fselector_callback, MAKINUM(0), _proc);
  fl_set_fselector_callback(cb_fselector_callback, 
			    (void *)_data);
  return UNSPECIFIED;
} /* fl_set_fselector_callback */
SUBR_charptr__void(fl_get_filename);
SUBR_charptr__void(fl_get_directory);
SUBR_charptr__void(fl_get_pattern);
SUBR_int__charptr(fl_set_directory);
SUBR_void__charptr(fl_set_pattern);
SUBR_void__void(fl_refresh_fselector);
static char s_fl_add_fselector_appbutton[]="fl_add_fselector_appbutton";
SCM nfl_add_fselector_appbutton(SCM _s, SCM _proc, SCM _data)
{
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG1, s_fl_add_fselector_appbutton);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_add_fselector_appbutton);
  /*ASSERT(INUMP(_data), _data, ARG2, s_fl_add_fselector_appbutton);*/
  SFDEBUGMSG(s_fl_add_fselector_appbutton);
  cb_add(loc_fselector_appbutton, MAKINUM(0), _proc);
  fl_add_fselector_appbutton(CHARS(_s), cb_fselector_appbutton, 
			     (void *)_data);
  return UNSPECIFIED;
} /* fl_add_fselector_appbutton */
SUBR_void__charptr(fl_remove_fselector_appbutton);
SUBR_void__int(fl_disable_fselector_cache);
SUBR_void__void(fl_invalidate_fselector_cache);
SUBR_formptr__void(fl_get_fselector_form);
static char s_fl_get_fselector_fdstruct[]="fl_get_fselector_fdstruct";
SCM nfl_get_fselector_fdstruct()
{
  FD_FSELECTOR *fds;
  SFDEBUGMSG(s_fl_get_fselector_fdstruct);
  fds=fl_get_fselector_fdstruct();
  return 
    cons
    (mkform(fds->fselect), 
     cons
     (mkobj(fds->browser), 
      cons
      (mkobj(fds->input), 
       cons
       (mkobj(fds->prompt), 
	cons
	(mkobj(fds->resbutt), 
	 cons
	 (mkobj(fds->patbutt), 
	  cons
	  (mkobj(fds->dirbutt), 
	   cons
	   (mkobj(fds->cancel), 
	    cons
	    (mkobj(fds->ready), 
	     cons
	     (mkobj(fds->dirlabel), 
	      cons
	      (mkobj(fds->patlabel), 
	       cons
	       (mkobj(fds->appbutt[0]), 
		cons
		(mkobj(fds->appbutt[1]), 
		 cons
		 (mkobj(fds->appbutt[2]), EOL))))))))))))));
} /* fl_get_fselector_fdstruct */
/*SUBR_void__void(fl_hide_fselector); already defined */
SUBR_void__5int(fl_set_fselector_filetype_marker);

/* initialize functions */
void s_init_goodies_fct()
{
  MSUBR_2(fl_set_goodies_font);
  MSUBR_3(fl_show_message);
  MSUBR_1(fl_show_messages);
  MSUBR_0(fl_hide_message);
  MSUBR_2(fl_show_question);
  MSUBR_0(fl_hide_question);
  MSUBR_L(fl_show_alert);
  MSUBR_0(fl_hide_alert);
  MSUBR_2(fl_show_input);
  MSUBR_0(fl_hide_input);
  MSUBR_2(fl_show_simple_input);
  MSUBR_1(fl_show_colormap);
  MSUBR_L(fl_show_choices);
  MSUBR_L(fl_show_choice);
  MSUBR_0(fl_hide_choice);
  MSUBR_3(fl_set_choice_shortcut);
  MSUBR_3(fl_show_oneliner);
  MSUBR_0(fl_hide_oneliner);
  MSUBR_2(fl_set_oneliner_font);
  MSUBR_2(fl_set_oneliner_color);
  MSUBR_2(fl_exe_command);
  MSUBR_1(fl_end_command);
  MSUBR_1(fl_check_command);
  MSUBR_0(fl_end_all_command);
  MSUBR_1(fl_show_command_log);
  MSUBR_0(fl_hide_command_log);
  MSUBR_0(fl_clear_command_log);
  MSUBR_1(fl_addto_command_log);
  MSUBR_2(fl_set_command_log_position);
  MSUBR_0(fl_get_command_log_fdstruct);
  MSUBR_1(fl_use_fselector);
  MSUBR_L(fl_show_fselector);
  MSUBR_1(fl_set_fselector_fontsize);
  MSUBR_1(fl_set_fselector_fontstyle);
  MSUBR_1(fl_set_fselector_placement);
  MSUBR_1(fl_set_fselector_border);
  MSUBR_2(fl_set_fselector_callback);
  MSUBR_0(fl_get_filename);
  MSUBR_0(fl_get_directory);
  MSUBR_0(fl_get_pattern);
  MSUBR_1(fl_set_directory);
  MSUBR_1(fl_set_pattern);
  MSUBR_0(fl_refresh_fselector);
  MSUBR_3(fl_add_fselector_appbutton);
  MSUBR_1(fl_remove_fselector_appbutton);
  MSUBR_1(fl_disable_fselector_cache);
  MSUBR_0(fl_invalidate_fselector_cache);
  MSUBR_0(fl_get_fselector_form);
  MSUBR_0(fl_get_fselector_fdstruct);
  MSUBR_0(fl_hide_fselector);
  MSUBR_L(fl_set_fselector_filetype_marker);
  return;
}

/*
** EOF
*/
