/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_menubar.c
** oct 28 1998 (not supported by XForms yet ?)
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

#ifdef fl_create_menubar
/* initialize symbols */
void s_init_menubar_sym()
{
  /* types */
  sysintern("fl_normal_menubar",  MAKINUM(FL_NORMAL_MENUBAR));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_menubar);
SUBR_objectptr__5int_charptr(fl_add_menubar);
/* */
SUBR_void__objectptr(fl_clear_menubar);
SUBR_void__objectptr_charptr(fl_set_menubar);
static char s_fl_set_menubar_entries[]="fl_set_menubar_entries";
SCM nfl_set_menubar_entries(SCM _o, SCM _s1, SCM _pelst)
{
  int i, c;
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_menubar_entries);
  ASSERT(NIMP(_pelst) && CONSP(_pelst), _pelst, ARG2, 
	 s_fl_set_menubar_entries);
  SFDEBUGMSG(s_fl_set_menubar_entries);
  i=ilength(_pelst);
  {
    FL_PUP_ENTRY pe[i+1]; /* last entry with NULL text field */
    SCM _pe;
    for (c=0; c<i; c++, _pelst=CDR(_pelst))
      {
        _pe=CAR(_pelst);
        ASSERT(NIMP(_pe) && CONSP(_pe), _pe, ARG2, s_fl_set_menubar_entries);
        ASSERT(ilength(_pe)<=4, _pe, ARG2, s_fl_set_menubar_entries);
        pe[c].text=NULL;
        pe[c].callback=NULL;
        pe[c].shortcut=NULL;
       pe[c].mode=0;
        if (ilength(_pe)>=1)
          { SCM _t;
            _t=CAR(_pe); _pe=CDR(_pe);
            ASSERT((INUMP(_t) && INUM(_t)==0) || 
                    (NIMP(_t) && STRINGP(_t)), _t, ARG1, 
                   s_fl_set_menubar_entries);
            if (!INUMP(_t))
              pe[c].text    =CHARS(_t);
          }
        if (ilength(_pe)>=1)
          { SCM _c;
            _c=CAR(_pe); _pe=CDR(_pe);
            ASSERT(BOOL_T==procedurep(_c), _c, ARG2, s_fl_set_menubar_entries);
            cb_add(loc_menubar_item_callback, MAKINUM(c), _c);
            pe[c].callback=cb_menubar_item_callback;
          }
        if (ilength(_pe)>=1)
          { SCM _s;
            _s=CAR(_pe); _pe=CDR(_pe);
            ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG3, 
		   s_fl_set_menubar_entries);
            pe[c].shortcut=CHARS(_s);
          }
        if (ilength(_pe)==1)
          { SCM _m;
            _m=CAR(_pe); 
            ASSERT(INUMP(_m), _m, ARG4, s_fl_set_menubar_entries);
            pe[c].mode    =INUM(_m);
          }
      }
    pe[i+1].text=NULL;
    fl_set_menubar_entries(OBJ(_o), CHARS(_s1), &pe[0]);
  }
  return UNSPECIFIED;
} /* fl_set_menubar_entries */

/* initialize functions */
void s_init_menubar_fct()
{
  MSUBR_L(fl_create_menubar);
  MSUBR_L(fl_add_menubar);
  MSUBR_1(fl_clear_menubar);
  MSUBR_2(fl_set_menubar);
  MSUBR_3(fl_set_menubar_entries);
  return;
}
#endif

/*
** EOF
*/
