/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_omacro.h - function returning an (fl_)object object 
** nov 07 1998 
*/

#define SUBR_objectptr__formptr(_func)     \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(SCM _f){                    \
ASSERT(FORMP(_f), _f, ARG1, #_func);       \
SFDEBUGMSG(s_ ##_func);                    \
return mkobj(_func(FORM(_f)));}     /* ok */

#define SUBR_objectptr__void(_func)        \
static char s_ ## _func[]=#_func;          \
SCM n ## _func(){                          \
SFDEBUGMSG(s_ ##_func);                    \
return mkobj(_func());}             /* ok */

/* OK / check coords conversion */
#define SUBR_objectptr__5int_charptr(_func)\
static char s_ ## _func[]=# _func;         \
SCM n ## _func(SCM _i1, SCM _i2, SCM args) \
{SCM _i3, _i4, _i5, _s;                    \
SFDEBUGMSG(s_ ##_func);                    \
ASSERT(ilength(args)==4, args,             \
       WNA, #_func);                       \
_i3=CAR(args);args=CDR(args);              \
_i4=CAR(args);args=CDR(args);              \
_i5=CAR(args);args=CDR(args);              \
_s=CAR(args);args=CDR(args);               \
ASSERT(INUMP(_i1), _i1, ARG1, #_func);     \
ASSERT(INUMP(_i2), _i2, ARG2, #_func);     \
ASSERT(INUMP(_i3), _i3, ARG3, #_func);     \
ASSERT(INUMP(_i4), _i4, ARG4, #_func);     \
ASSERT(INUMP(_i5), _i5, ARG5, #_func);     \
ASSERT(NIMP(_s) && STRINGP(_s), _s,        \
       WNA, #_func);                       \
return mkobj(_func(INUM(_i1),              \
                   INUM(_i2), INUM(_i3),   \
                   INUM(_i4), INUM(_i5),   \
		     CHARS(_s)));}  /* ok */

/*
** EOF
*/
