/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_positioner.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_positioner_sym()
{
  /* types */
  sysintern("fl_normal_positioner",  MAKINUM(FL_NORMAL_POSITIONER));
  sysintern("fl_overlay_positioner", MAKINUM(FL_OVERLAY_POSITIONER));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_positioner);
SUBR_objectptr__5int_charptr(fl_add_positioner);
/* */
SUBR_void__objectptr_double(fl_set_positioner_xvalue);
SUBR_double__objectptr(fl_get_positioner_xvalue);
SUBR_void__objectptr_2double(fl_set_positioner_xbounds);
SUBR_2double__objectptr(fl_get_positioner_xbounds);
SUBR_void__objectptr_double(fl_set_positioner_yvalue);
SUBR_double__objectptr(fl_get_positioner_yvalue);
SUBR_void__objectptr_2double(fl_set_positioner_ybounds);
SUBR_2double__objectptr(fl_get_positioner_ybounds);
SUBR_void__objectptr_double(fl_set_positioner_xstep);
SUBR_void__objectptr_double(fl_set_positioner_ystep);
SUBR_void__objectptr_int(fl_set_positioner_return);

/* initialize functions */
void s_init_positioner_fct()
{
  MSUBR_L(fl_create_positioner);
  MSUBR_L(fl_add_positioner);
  MSUBR_2(fl_set_positioner_xvalue);
  MSUBR_1(fl_get_positioner_xvalue);
  MSUBR_3(fl_set_positioner_xbounds);
  MSUBR_1(fl_get_positioner_xbounds);
  MSUBR_2(fl_set_positioner_yvalue);
  MSUBR_1(fl_get_positioner_yvalue);
  MSUBR_3(fl_set_positioner_ybounds);
  MSUBR_1(fl_get_positioner_ybounds);
  MSUBR_2(fl_set_positioner_xstep);
  MSUBR_2(fl_set_positioner_ystep);
  MSUBR_2(fl_set_positioner_return);
  return;
}

/*
** EOF
*/
