/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_scrollbar.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_scrollbar_sym()
{
  /* types */
  sysintern("fl_hor_scrollbar",        MAKINUM(FL_HOR_SCROLLBAR));
  sysintern("fl_vert_scrollbar",       MAKINUM(FL_VERT_SCROLLBAR));
  sysintern("fl_hor_thin_scrollbar",   MAKINUM(FL_HOR_THIN_SCROLLBAR));
  sysintern("fl_vert_thin_scrollbar",  MAKINUM(FL_VERT_THIN_SCROLLBAR));
  sysintern("fl_hor_nice_scrollbar",   MAKINUM(FL_HOR_NICE_SCROLLBAR));
  sysintern("fl_vert_nice_scrollbar",  MAKINUM(FL_VERT_NICE_SCROLLBAR));
  sysintern("fl_hor_plain_scrollbar",  MAKINUM(FL_HOR_PLAIN_SCROLLBAR));
  sysintern("fl_vert_plain_scrollbar", MAKINUM(FL_VERT_PLAIN_SCROLLBAR));
  /* */
  sysintern("fl_thin_scrollbar",       MAKINUM(FL_THIN_SCROLLBAR));
  sysintern("fl_plain_scrollbar",      MAKINUM(FL_PLAIN_SCROLLBAR));
  sysintern("fl_normal_scrollbar",     MAKINUM(FL_NORMAL_SCROLLBAR));
  sysintern("fl_nice_scrollbar",       MAKINUM(FL_NICE_SCROLLBAR));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_scrollbar);
SUBR_objectptr__5int_charptr(fl_add_scrollbar);
/* */
SUBR_double__objectptr(fl_get_scrollbar_value);
SUBR_void__objectptr_double(fl_set_scrollbar_value);
SUBR_void__objectptr_double(fl_set_scrollbar_size);
SUBR_void__objectptr_2double(fl_set_scrollbar_increment);
SUBR_2float__objectptr(fl_get_scrollbar_increment);
SUBR_void__objectptr_2double(fl_set_scrollbar_bounds);
SUBR_2float__objectptr(fl_get_scrollbar_bounds);
SUBR_void__objectptr_int(fl_set_scrollbar_return);
SUBR_void__objectptr_double(fl_set_scrollbar_step);

/* initialize functions */
void s_init_scrollbar_fct()
{
  MSUBR_L(fl_create_scrollbar);
  MSUBR_L(fl_add_scrollbar);
  MSUBR_1(fl_get_scrollbar_value);
  MSUBR_2(fl_set_scrollbar_value);
  MSUBR_2(fl_set_scrollbar_size);
  MSUBR_3(fl_set_scrollbar_increment);
  MSUBR_1(fl_get_scrollbar_increment);
  MSUBR_3(fl_set_scrollbar_bounds);
  MSUBR_1(fl_get_scrollbar_bounds);
  MSUBR_2(fl_set_scrollbar_return);
  MSUBR_2(fl_set_scrollbar_step);
  return;
}

/*
** EOF
*/
