/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_slider.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_slider_sym()
{
  /* types */
  sysintern("fl_vert_slider",          MAKINUM(FL_VERT_SLIDER));
  sysintern("fl_hor_slider",           MAKINUM(FL_HOR_SLIDER));
  sysintern("fl_vert_fill_slider",     MAKINUM(FL_VERT_FILL_SLIDER));
  sysintern("fl_hor_fill_slider",      MAKINUM(FL_HOR_FILL_SLIDER));
  sysintern("fl_vert_nice_slider",     MAKINUM(FL_VERT_NICE_SLIDER));
  sysintern("fl_hor_nice_slider",      MAKINUM(FL_HOR_NICE_SLIDER));
  sysintern("fl_hor_browser_slider",   MAKINUM(FL_HOR_BROWSER_SLIDER));
  sysintern("fl_vert_browser_slider",  MAKINUM(FL_VERT_BROWSER_SLIDER));
  /* internal use */
  sysintern("fl_hor_browser_slider2",  MAKINUM(FL_HOR_BROWSER_SLIDER2));      
  sysintern("fl_vert_browser_slider2", MAKINUM(FL_VERT_BROWSER_SLIDER2));
  sysintern("fl_hor_thin_slider",      MAKINUM(FL_HOR_THIN_SLIDER));	       
  sysintern("fl_vert_thin_slider",     MAKINUM(FL_VERT_THIN_SLIDER));	
  sysintern("fl_hor_basic_slider",     MAKINUM(FL_HOR_BASIC_SLIDER));	
  sysintern("fl_vert_basic_slider",    MAKINUM(FL_VERT_BASIC_SLIDER));	
  /* others */
  sysintern("fl_slider_fine",          makdbl(FL_SLIDER_FINE, 0.0));	
  sysintern("fl_slider_width",         makdbl(FL_SLIDER_WIDTH, 0.0));
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_slider);
SUBR_objectptr__5int_charptr(fl_add_slider);
SUBR_objectptr__5int_charptr(fl_create_valslider);
SUBR_objectptr__5int_charptr(fl_add_valslider);
/* */
SUBR_void__objectptr_double(fl_set_slider_value);
SUBR_double__objectptr(fl_get_slider_value);
SUBR_void__objectptr_2double(fl_set_slider_bounds);
SUBR_2double__objectptr(fl_get_slider_bounds);
/* */
SUBR_void__objectptr_int(fl_set_slider_return);
SUBR_void__objectptr_double(fl_set_slider_step);
SUBR_void__objectptr_2double(fl_set_slider_increment);
SUBR_2float__objectptr(fl_get_slider_increment);
SUBR_void__objectptr_double(fl_set_slider_size);
SUBR_void__objectptr_int(fl_set_slider_precision);
static char s_fl_set_slider_filter[]="fl_set_slider_filter";
SCM nfl_set_slider_filter(SCM _o, SCM _proc)
{ 
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_slider_filter);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_slider_filter);
  SFDEBUGMSG(s_fl_set_slider_filter);
  cb_add(loc_slider_filter, _o, _proc);
  fl_set_slider_filter(OBJ(_o), cb_slider_filter);
  return UNSPECIFIED;
} /* fl_set_slider_filter */

/* initialize functions */
void s_init_slider_fct()
{
  MSUBR_L(fl_create_slider);
  MSUBR_L(fl_add_slider);
  MSUBR_L(fl_create_valslider);
  MSUBR_L(fl_add_valslider);
  MSUBR_2(fl_set_slider_value);
  MSUBR_1(fl_get_slider_value);
  MSUBR_3(fl_set_slider_bounds);
  MSUBR_1(fl_get_slider_bounds);
  MSUBR_2(fl_set_slider_return);
  MSUBR_2(fl_set_slider_step);
  MSUBR_3(fl_set_slider_increment);
  MSUBR_1(fl_get_slider_increment);
  MSUBR_2(fl_set_slider_size);
  MSUBR_2(fl_set_slider_precision);
  MSUBR_2(fl_set_slider_filter);
  return;
}

/*
** EOF
*/
