/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_timer.c
** oct 25 1998
** nov 09 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_timer_sym()
{
  /* types */
  sysintern("fl_normal_timer",    MAKINUM(FL_NORMAL_TIMER));
  sysintern("fl_value_timer",     MAKINUM(FL_VALUE_TIMER));
  sysintern("fl_hidden_timer",    MAKINUM(FL_HIDDEN_TIMER));
  /* others */
  sysintern("fl_timer_blinkrate", makdbl(FL_TIMER_BLINKRATE, 0.0));	
  return;
}

/* routines */
SUBR_objectptr__5int_charptr(fl_create_timer);
SUBR_objectptr__5int_charptr(fl_add_timer);
/* */
SUBR_void__objectptr_double(fl_set_timer);
SUBR_double__objectptr(fl_get_timer);
SUBR_void__objectptr_int(fl_set_timer_countup);
static char s_fl_set_timer_filter[]="fl_set_timer_filter";
SCM nfl_set_timer_filter(SCM _o, SCM _proc)
{
  ASSERT(OBJP(_o), _o, ARG1, s_fl_set_timer_filter);
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG2, s_fl_set_timer_filter);
  SFDEBUGMSG(s_fl_set_timer_filter);
  cb_add(loc_timer_filter, _o, _proc);
  fl_set_timer_filter(OBJ(_o), cb_timer_filter);
  return UNSPECIFIED;
} /* fl_set_timer_filter */
SUBR_void__objectptr(fl_suspend_timer);
SUBR_void__objectptr(fl_resume_timer);

/* initialize functions */
void s_init_timer_fct()
{
  MSUBR_L(fl_create_timer);
  MSUBR_L(fl_add_timer);
  MSUBR_2(fl_set_timer);
  MSUBR_1(fl_get_timer);
  MSUBR_2(fl_set_timer_countup);
  MSUBR_2(fl_set_timer_filter);
  MSUBR_1(fl_suspend_timer);
  MSUBR_1(fl_resume_timer);
  return;
}

/*
** EOF
*/
