/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_wmacro.h - functions that return a window object
** nov 06 1998
*/

#define SUBR_window__void(_func)            \
static char s_ ## _func[]=#_func;           \
SCM n ## _func(){                           \
SFDEBUGMSG(s_ ##_func);                     \
return mkwin(_func());}              /* ok */

#define SUBR_window__objectptr(_func)       \
static char s_ ## _func[]=#_func;           \
SCM n ## _func(SCM _o){                     \
ASSERT(OBJ(_o), _o, ARG1, #_func);          \
SFDEBUGMSG(s_ ##_func);                     \
return mkwin(_func(OBJ(_o)));}       /* ok */

#define SUBR_window__charptr(_func)         \
static char s_ ## _func[]=#_func;           \
SCM n ## _func(SCM _s){                     \
ASSERT(NIMP(_s) && STRINGP(_s), _s,         \
                             ARG1, #_func); \
SFDEBUGMSG(s_ ##_func);                     \
return mkwin(_func(CHARS(_s)));}     /* ok */

#define SUBR_window__window(_func)          \
static char s_ ## _func[]=#_func;           \
SCM n ## _func(SCM _w){                     \
ASSERT(WINP(_w), _w, ARG1, #_func);         \
SFDEBUGMSG(s_ ##_func);                     \
return mkwin(_func(WIN(_w)));}       /* ok */

/*
** EOF
*/
