/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** s_xbasic.c
** oct 27 1998
*/
#include "forms.h"
#include "s_macro.h"

/* initialize symbols */
void s_init_xbasic_sym()
{
  /* draw mode */
  sysintern("fl_xor",           MAKINUM(FL_XOR));
  sysintern("fl_copy",          MAKINUM(FL_COPY));
  sysintern("fl_and",           MAKINUM(FL_AND));
  /* */
  sysintern("fl_mindepth",      MAKINUM(FL_MINDEPTH));
  /* */
  sysintern("fl_illegalvisual", MAKINUM(FL_illegalVisual));
  sysintern("fl_staticgray",    MAKINUM(FL_StaticGray));
  sysintern("fl_grayscale",     MAKINUM(FL_GrayScale));
  sysintern("fl_staticcolor",   MAKINUM(FL_StaticColor));
  sysintern("fl_pseudocolor",   MAKINUM(FL_PseudoColor));
  sysintern("fl_truecolor",     MAKINUM(FL_TrueColor));
  sysintern("fl_directcolor",   MAKINUM(FL_DirectColor));
  sysintern("fl_defaultvisual", MAKINUM(FL_DefaultVisual));  
  /* */
  sysintern("fl_north",         MAKINUM(FL_North));
  sysintern("fl_northeast",     MAKINUM(FL_NorthEast));
  sysintern("fl_northwest",     MAKINUM(FL_NorthWest));
  sysintern("fl_south",         MAKINUM(FL_South));
  sysintern("fl_southeast",     MAKINUM(FL_SouthEast));
  sysintern("fl_southwest",     MAKINUM(FL_SouthWest));
  sysintern("fl_east",          MAKINUM(FL_East));
  sysintern("fl_west",          MAKINUM(FL_West));
  sysintern("fl_nogravity",     MAKINUM(FL_NoGravity));
  sysintern("fl_forgetgravity", MAKINUM(FL_ForgetGravity));
  /* internal colormap size */
  sysintern("fl_max_cols",      MAKINUM(FL_MAX_COLS));
  /* */
  sysintern("fl_max_fontsizes", MAKINUM(FL_MAX_FONTSIZES));
  /* */
  sysintern("fl_solid",         MAKINUM(FL_SOLID));
  sysintern("fl_userdash",      MAKINUM(FL_USERDASH));
  sysintern("fl_userdoubledash", MAKINUM(FL_USERDOUBLEDASH));
  sysintern("fl_dot",           MAKINUM(FL_DOT));
  sysintern("fl_dotdash",       MAKINUM(FL_DOTDASH));
  sysintern("fl_dash",          MAKINUM(FL_DASH));
  sysintern("fl_longdash",      MAKINUM(FL_LONGDASH));
  /* */
  sysintern("fl_all_event",     MAKINUM(FL_ALL_EVENT));
  sysintern("fl_timer_event",   MAKINUM(FL_TIMER_EVENT));
  /* */
  sysintern("fl_wm_shift",      MAKINUM(FL_WM_SHIFT));
  sysintern("fl_wm_normal",     MAKINUM(FL_WM_NORMAL));
  /* */
  sysintern("fl_none",          MAKINUM(FL_NONE));
  sysintern("fl_short",         MAKINUM(FL_SHORT));
  sysintern("fl_bool",          MAKINUM(FL_BOOL));
  sysintern("fl_int",           MAKINUM(FL_INT));
  sysintern("fl_long",          MAKINUM(FL_LONG));
  sysintern("fl_float",         MAKINUM(FL_FLOAT));
  sysintern("fl_string",        MAKINUM(FL_STRING));
  /* */
  /*sysintern("buttonLabelSize"   MAKINUM(buttonLabelSize));*/
  /*sysintern("sliderLabelSize"   MAKINUM(sliderLabelSize));*/
  /*sysintern("inputLabelSize"    MAKINUM(inputLabelSize));*/
  /* */
  sysintern("fl_pddepth",           MAKINUM(FL_PDDepth));
  sysintern("fl_pdclass",           MAKINUM(FL_PDClass));
  sysintern("fl_pddouble",          MAKINUM(FL_PDDouble));
  sysintern("fl_pdsync",            MAKINUM(FL_PDSync));
  sysintern("fl_pdprivatemap",      MAKINUM(FL_PDPrivateMap));
  sysintern("fl_pdscrollbartype",   MAKINUM(FL_PDScrollbarType));
  sysintern("fl_pdpupfontsize",     MAKINUM(FL_PDPupFontSize));
  sysintern("fl_pdbuttonfontsize",  MAKINUM(FL_PDButtonFontSize));
  sysintern("fl_pdinputfontsize",   MAKINUM(FL_PDInputFontSize));
  sysintern("fl_pdsliderfontsize",  MAKINUM(FL_PDSliderFontSize));
  sysintern("fl_pdvisual",          MAKINUM(FL_PDVisual));
  sysintern("fl_pdulthickness",     MAKINUM(FL_PDULThickness));
  sysintern("fl_pdulpropwidth",     MAKINUM(FL_PDULPropWidth));
  sysintern("fl_pdbs",              MAKINUM(FL_PDBS));
  sysintern("fl_pdcoordunit",       MAKINUM(FL_PDCoordUnit));
  sysintern("fl_pddebug",           MAKINUM(FL_PDDebug));
  sysintern("fl_pdsharedmap",       MAKINUM(FL_PDSharedMap));
  sysintern("fl_pdstandardmap",     MAKINUM(FL_PDStandardMap));
  sysintern("fl_pdborderwidth",     MAKINUM(FL_PDBorderWidth));
  sysintern("fl_pdsafe",            MAKINUM(FL_PDSafe));
  sysintern("fl_pdmenufontsize",    MAKINUM(FL_PDMenuFontSize));
  sysintern("fl_pdbrowserfontsize", MAKINUM(FL_PDBrowserFontSize));
  sysintern("fl_pdchoicefontsize",  MAKINUM(FL_PDChoiceFontSize));
  sysintern("fl_pdlabelfontsize",   MAKINUM(FL_PDLabelFontSize));
  return;
}

static char s_fl_get_gc[]="fl_get_gc";
SCM nfl_get_gc()
{
  SFDEBUGMSG(s_fl_get_gc);
  return mkxgc(fl_get_gc());
} /* fl_get_gc */
SUBR_int__2int(fl_mode_capable);
SUBR_window__void(fl_default_win);
SUBR_window__void(fl_default_window);
/* rectangles */
SUBR_void__6int(fl_rectangle);
SUBR_void__5int(fl_rectbound);
/* rectangle with rounded corners */
SUBR_void__6int(fl_roundrectangle);
/* general polygon and polylines */
static char s_fl_polygon[]="fl_polygon";
SCM nfl_polygon(SCM _i1, SCM _p, SCM _args)
{
  SCM _i2, _i3;
  int i, c;
  ASSERT(ilength(_args)==2, _args, ARG3, s_fl_polygon);
  _i2=CAR(_args); _args=CDR(_args);
  _i3=CAR(_args);
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_polygon);
  ASSERT(NIMP(_p) && CONSP(_p), _p, ARG2, s_fl_polygon);
  ASSERT(INUMP(_i2), _i2, ARG3, s_fl_polygon);
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_polygon);
  SFDEBUGMSG(s_fl_polygon);
  i=INUM(_i2);
  {
    SCM cp, px, py; FL_POINT p[i+1];
    ASSERT(ilength(_p)>=i, _p, ARG2, s_fl_polygon);
    for (c=0; c<i; c++, _p=CDR(_p))
      {
	ASSERT(NIMP(CAR(_p)) &&CONSP(CAR(_p)), _p, ARG2, s_fl_polygon);
	cp=CAR(_p);
	ASSERT(ilength(cp)==2, cp, ARG2, s_fl_polygon);
	px=CAR(cp); cp=CDR(cp);
	py=CAR(cp);
	ASSERT(INUMP(px), px, ARG2, s_fl_polygon);
	ASSERT(INUMP(py), py, ARG2, s_fl_polygon);
	p[c].x=INUM(px);
	p[c].y=INUM(py);
      }
    p[c+1].x=0; p[c+1].y=0;
    fl_polygon(INUM(_i1), &p[0], INUM(_i2), INUM(_i3));
  }
  return UNSPECIFIED;
} /* fl_polygon */
SUBR_void__points_2int(fl_polybound);
/* */
SUBR_void__points_2int(fl_lines);
SUBR_void__5int(fl_line);
SUBR_void__3int(fl_point);
SUBR_void__points_2int(fl_points);
SUBR_void__charptr_int(fl_dashedlinestyle);
/* line attributes */
SUBR_void__int(fl_linewidth);
SUBR_void__int(fl_linestyle);
SUBR_void__int(fl_drawmode);
SUBR_int__void(fl_get_linewidth);
SUBR_int__void(fl_get_linestyle);
SUBR_int__void(fl_get_drawmode);
/* ellipses */
SUBR_void__6int(fl_oval);
SUBR_void__5int(fl_ovalbound);
SUBR_void__8int(fl_ovalarc); 
/* arcs */
SUBR_void__8int(fl_pieslice); 
/* misc. stuff */
SUBR_void__2int(fl_add_vertex);
SUBR_void__2double(fl_add_float_vertex);
SUBR_void__void(fl_reset_vertex);
SUBR_void__void(fl_endline);
SUBR_void__void(fl_endpolygon);
SUBR_void__void(fl_endclosedline);
#undef fl_v2s
#define fl_v2s(v0, v1) fl_add_vertex(v0, v1)
SUBR_void__2int(fl_v2s);
#undef fl_v2i
#define fl_v2i(v0, v1) fl_add_vertex(v0, v1)
SUBR_void__2int(fl_v2i);
#undef fl_v2f
#define fl_v2f(v0, v1) fl_add_float_vertex(v0, v1)
SUBR_void__2double(fl_v2f);
#undef fl_v2d
#define fl_v2d(v0, v1) fl_add_float_vertex(v0, v1)
SUBR_void__2double(fl_v2d);
/* high level drawing routines */
SUBR_void__7int(fl_drw_frame);
SUBR_void__7int(fl_drw_checkbox);
/* interfaces */
static char s_fl_get_fontstruct[]="fl_get_fontstruct";
SCM nfl_get_fontstruct(SCM _i1, SCM _i2)
{
  ASSERT(INUMP(_i1), _i1, ARG1, s_fl_get_fontstruct);
  ASSERT(INUMP(_i2), _i2, ARG2, s_fl_get_fontstruct);
  SFDEBUGMSG(s_fl_get_fontstruct);
  return mkfnt(fl_get_fontstruct(INUM(_i1), INUM(_i2)));
} /* fl_get_fontstruct */
static char s_fl_get_mouse[]="fl_get_mouse";
SCM nfl_get_mouse()
{
  Window w;
  int i1, i2, i3;
  SFDEBUGMSG(s_fl_get_mouse);
  w=fl_get_mouse(&i1, &i2, &i3);
  return cons(mkwin(w),
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), 
			cons(MAKINUM(i3), EOL))));
} /* fl_get_mouse */
SUBR_void__2int(fl_set_mouse);
static char s_fl_get_win_mouse[]="fl_get_win_mouse";
SCM nfl_get_win_mouse(SCM _w)
{
  Window w;
  int i1, i2, i3;
  ASSERT(WINP(_w), _w, ARG1, s_fl_get_win_mouse);
  SFDEBUGMSG(s_fl_get_win_mouse);
  w=fl_get_win_mouse(WIN(_w), &i1, &i2, &i3);
  return cons(mkwin(w),
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), 
			cons(MAKINUM(i3), EOL))));
} /* fl_get_win_mouse */
static char s_fl_get_form_mouse[]="fl_get_form_mouse";
SCM nfl_get_form_mouse(SCM _f)
{
  Window w;
  int i1, i2, i3;
  ASSERT(FORMP(_f), _f, ARG1, s_fl_get_form_mouse);
  SFDEBUGMSG(s_fl_get_form_mouse);
  w=fl_get_form_mouse(FORM(_f), &i1, &i2, &i3);
  return cons(mkwin(w),
	      cons(MAKINUM(i1), 
		   cons(MAKINUM(i2), 
			cons(MAKINUM(i3), EOL))));
} /* fl_get_form_mouse */
static char s_fl_win_to_form[]="fl_win_to_form";
SCM nfl_win_to_form(SCM _w)
{
  ASSERT(WINP(_w), _w, ARG1, s_fl_win_to_form);
  SFDEBUGMSG(s_fl_win_to_form);
  return mkform(fl_win_to_form(WIN(_w)));
} /* fl_win_to_form */
static char s_fl_set_form_icon[]="fl_set_form_icon";
SCM nfl_set_form_icon(SCM _f, SCM _p1, SCM _p2)
{
  ASSERT(FORMP(_f), _f, ARG1, s_fl_set_form_icon);
  ASSERT(PIXP(_p1), _p1, ARG2, s_fl_set_form_icon);
  ASSERT(PIXP(_p2), _p2, ARG3, s_fl_set_form_icon);
  SFDEBUGMSG(s_fl_set_form_icon);
  fl_set_form_icon(FORM(_f), PIX(_p1), PIX(_p2));
  return UNSPECIFIED;
} /* fl_set_form_icon */
SUBR_void__formptr(fl_raise_form);
SUBR_void__formptr(fl_lower_form);
static char s_fl_set_foreground[]="fl_set_foreground";
SCM nfl_set_foreground(SCM _gc, SCM _i)
{
  ASSERT(SGCP(_gc), _gc, ARG1, s_fl_set_foreground);
  ASSERT(INUMP(_i) && INUM(_i)>=0, _i, ARG2, s_fl_set_foreground);
  SFDEBUGMSG(s_fl_set_foreground);
  fl_set_foreground(SGC(_gc), MAKINUM(_i));
  return UNSPECIFIED;
}
static char s_fl_set_background[]="fl_set_background";
SCM nfl_set_background(SCM _gc, SCM _i)
{
  ASSERT(SGCP(_gc), _gc, ARG1, s_fl_set_background);
  ASSERT(INUMP(_i) && INUM(_i)>=0, _i, ARG2, s_fl_set_background);
  SFDEBUGMSG(s_fl_set_background);
  fl_set_background(SGC(_gc), INUM(_i));
  return UNSPECIFIED;
}
/* general windowing support */
SUBR_window__charptr(fl_wincreate);
SUBR_window__window(fl_winshow);
SUBR_window__charptr(fl_winopen);
SUBR_void__window(fl_winhide);
SUBR_void__window(fl_winclose);
SUBR_void__window(fl_winset);
static char s_fl_winreparent[]="fl_winreparent";
SCM nfl_winreparent(SCM _w1, SCM _w2)
{
  ASSERT(WINP(_w1), _w1, ARG1, s_fl_winreparent);
  ASSERT(WINP(_w2), _w2, ARG2, s_fl_winreparent);
  SFDEBUGMSG(s_fl_winreparent);
  return MAKINUM(fl_winreparent(WIN(_w1), WIN(_w2)));
} /* fl_winreparent */
SUBR_void__window(fl_winfocus);
SUBR_window__void(fl_winget);
/* */
SUBR_void__window_2int(fl_winresize);
SUBR_void__window_2int(fl_winmove);
SUBR_void__window_4int(fl_winreshape);
static char s_fl_winicon[]="fl_winicon";
SCM nfl_winicon(SCM _w, SCM _p1, SCM _p2)
{
  ASSERT(WINP(_w), _w, ARG1, s_fl_winicon);
  ASSERT(PIXP(_p1), _p1, ARG2, s_fl_winicon);
  ASSERT(PIXP(_p2), _p2, ARG3, s_fl_winicon);
  SFDEBUGMSG(s_fl_winicon);
  fl_winicon(WIN(_w), PIX(_p1), PIX(_p2));
  return UNSPECIFIED;
} /* fl_winicon */
SUBR_void__window_int(fl_winbackground);
SUBR_void__window_2int(fl_winstepunit);
SUBR_int__window(fl_winisvalid);
SUBR_void__window_charptr(fl_wintitle);
SUBR_void__window_charptr(fl_winicontitle);
SUBR_void__2int(fl_winposition);
/* */
SUBR_void__window_2int(fl_winminsize);
SUBR_void__window_2int(fl_winmaxsize);
SUBR_void__window_2int(fl_winaspect);
SUBR_void__window(fl_reset_winconstraints);
SUBR_void__2int(fl_winsize);
SUBR_void__2int(fl_initial_winsize);
SUBR_void__int(fl_initial_winstate);
SUBR_dummy2(fl_create_colormap);
/* */
SUBR_void__4int(fl_wingeometry);
SUBR_void__4int(fl_initial_wingeometry);
#define fl_pnoborder fl_noborder 
SUBR_void__void(fl_pnoborder);
#define fl_ptransient fl_transient
SUBR_void__void(fl_ptransient);
SUBR_2int__window(fl_get_winsize);
SUBR_2int__window(fl_get_winorigin);
SUBR_4int__window(fl_get_wingeometry);
#define fl_is_canvas FL_IS_CANVAS
SUBR_int__objectptr(fl_is_canvas);
/* the window an object belongs to */
#define fl_objwin FL_ObjWin
SUBR_window__objectptr(fl_objwin);
SUBR_window__objectptr(fl_get_real_object_window);
static char s_fl_xnextevent[]="fl_xnextevent";
SCM nfl_xnextevent()
{ /* BUGGY */
  XEvent xev;
  int i;
  SFDEBUGMSG(s_fl_xnextevent);
  i=fl_XNextEvent(&xev);
  return cons(MAKINUM(i), 
	      cons(mkxev(&xev), EOL));
}
static char s_fl_xpeekevent[]="fl_xpeekevent";
SCM nfl_xpeekevent()
{ /* BUGGY */
  XEvent xev;
  int i;
  SFDEBUGMSG(s_fl_xpeekevent);
  i=fl_XPeekEvent(&xev);
  return cons(MAKINUM(i), 
	      cons(mkxev(&xev), EOL));
} /* fl_xpeekevent */
#define fl_xeventsqueued fl_XEventsQueued
SUBR_int__int(fl_xeventsqueued);
static char s_fl_xputbackevent[]="fl_xputbackevent";
SCM nfl_xputbackevent(SCM sev)
{ /* BUGGY */
  ASSERT(XEVP(sev), sev, ARG1, s_fl_xputbackevent);
  SFDEBUGMSG(s_fl_xputbackevent);
  fl_XPutBackEvent(XEV(sev));
  return UNSPECIFIED;
} /* fl_xputbackevent */
static char s_fl_last_event[]="fl_last_event";
SCM nfl_last_event()
{ 
  SFDEBUGMSG(s_fl_last_event);
  return mkxev((XEvent *)fl_last_event());
} /* fl_last_event */
static char s_fl_set_event_callback[]="fl_set_event_callback";
SCM nfl_set_event_callback(SCM _proc, SCM _data)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG1, s_fl_set_event_callback);
  ASSERT(INUMP(_data), _data, ARG2, s_fl_set_event_callback); 
  SFDEBUGMSG(s_fl_set_event_callback);
  cb_add(loc_event_callback, MAKINUM(0), _proc);
  fl_set_event_callback(cb_event_callback, 
			(void *)_data);
  return UNSPECIFIED;
} /* fl_set_event_callback */
static char s_fl_set_idle_callback[]="fl_set_idle_callback";
SCM nfl_set_idle_callback(SCM _proc, SCM _data)
{
  ASSERT(BOOL_T==procedurep(_proc), _proc, ARG1, s_fl_set_idle_callback);
  ASSERT(INUMP(_data), _data, ARG2, s_fl_set_idle_callback); 
  SFDEBUGMSG(s_fl_set_idle_callback);
  cb_add(loc_idle_callback, MAKINUM(0), _proc);
  fl_set_idle_callback(cb_idle_callback, 
		       (void *)_data);
  return UNSPECIFIED;
} /* fl_set_idle_callback */

SUBR_int__window_int(fl_addto_selected_xevent);
SUBR_int__window_int(fl_remove_selected_xevent);
SUBR_void__int(fl_set_idle_delta);
static char s_fl_add_event_callback[]="fl_add_event_callback";
SCM nfl_add_event_callback(SCM _w, SCM _i, SCM _args)
{
  SCM _proc, _data;
  ASSERT(ilength(_args)==2, _args, UNDEFINED, s_fl_add_event_callback);
  _proc=CAR(_args); _args=CDR(_args);
  _data=CAR(_args);
  SFDEBUGMSG(s_fl_add_event_callback);
  cb_add(loc_sevent_callback, _i, _proc);
  fl_add_event_callback(WIN(_w), INUM(_i), cb_sevent_callback, (void *)_data);
  return UNSPECIFIED;
} /* fl_add_event_callback */
SUBR_void__window_int(fl_remove_event_callback);
SUBR_void__window(fl_activate_event_callbacks);
static char s_fl_print_xevent_name[]="fl_print_xevent_name";
SCM nfl_print_xevent_name(SCM _s, SCM _sev)
{
  XEvent *xev;
  ASSERT(NIMP(_s) && STRINGP(_s), _s, ARG1, s_fl_print_xevent_name);
  ASSERT(XEVP(_sev), _sev, ARG2, s_fl_print_xevent_name);
  SFDEBUGMSG(s_fl_print_xevent_name);
  xev=fl_print_xevent_name(CHARS(_s), XEV(_sev));
  return mkxev(xev);
} /* fl_print_xevent_name */
SUBR_int__int(metakey_down);
SUBR_int__int(shiftkey_down);
SUBR_int__int(controlkey_down);
SUBR_int__int(button_down);
static char s_fl_initialize[]="fl_initialize";
SCM nfl_initialize(SCM args)
{ /* args ignored for now */
  Display *d;
  int argc;
  char *argv;
  const char *appclass;
  XrmOptionDescList app_opt;
  int n_app_opt;
  /* */
  SFDEBUGMSG(s_fl_initialize);
  argc=1;
  argv="scm";
  appclass="SCM X forms";
  app_opt=0;
  n_app_opt=0;
  d=fl_initialize(&argc, &argv, appclass, app_opt, n_app_opt);
  return mkdis(d); 
}
SUBR_void__void(fl_finish);
SUBR_dummyL(fl_get_resource);
SUBR_void__2charptr(fl_set_resource);
SUBR_dummy2(fl_get_app_resources);
SUBR_void__2int(fl_set_graphics_mode);
SUBR_void__int(fl_set_visualID);
SUBR_int__int(fl_keysym_pressed);
#define fl_sbit FL_SBIT
SUBR_int__int(fl_sbit);
SUBR_dummy2(fl_set_defaults);
SUBR_void__charptr(fl_set_tabstop);
SUBR_dummy0(fl_get_defaults);
SUBR_int__void(fl_get_visual_depth);
SUBR_charptr__int(fl_vclass_name);
SUBR_int__charptr(fl_vclass_val);
SUBR_void__2int(fl_set_ul_property);
SUBR_void__4int(fl_set_clipping);
static char s_fl_set_gc_clipping[]="fl_set_gc_clipping";
SCM nfl_set_gc_clipping(SCM _gc, SCM _i1, SCM _args)
{
  SCM _i2, _i3, _i4;
  ASSERT(ilength(_args)==3, _args, UNDEFINED, s_fl_set_gc_clipping);
  _i2=CAR(_args); _args=CDR(_args);
  _i3=CAR(_args); _args=CDR(_args);
  _i4=CAR(_args); _args=CDR(_args);
  ASSERT(SGCP(_gc), _gc, ARG1, s_fl_set_gc_clipping);
  ASSERT(INUMP(_i1), _i1, ARG2, s_fl_set_gc_clipping);
  ASSERT(INUMP(_i2), _i2, ARG3, s_fl_set_gc_clipping);
  ASSERT(INUMP(_i3), _i3, ARG4, s_fl_set_gc_clipping);
  ASSERT(INUMP(_i4), _i4, ARG5, s_fl_set_gc_clipping);
  SFDEBUGMSG(s_fl_set_gc_clipping);
  fl_set_gc_clipping(SGC(_gc), INUM(_i1), INUM(_i2), INUM(_i3), INUM(_i4));
  return UNSPECIFIED;
} /* fl_set_gc_clipping */
static char s_fl_unset_gc_clipping[]="fl_unset_gc_clipping";
SCM nfl_unset_gc_clipping(SCM _gc)
{
  ASSERT(SGCP(_gc), _gc, ARG1, s_fl_unset_gc_clipping);
  SFDEBUGMSG(s_fl_unset_gc_clipping);
  fl_unset_gc_clipping(SGC(_gc));
  return UNSPECIFIED;
} /* fl_unset_gc_clipping */


static char s_fl_set_clippings[]="fl_set_clippings";
SCM nfl_set_clippings(SCM _sl, SCM _i)
{
  int i;
  SCM _r, _i1, _i2, _i3, _i4;
  ASSERT(NIMP(_sl) && CONSP(_sl), _sl, ARG1, s_fl_set_clippings);
  ASSERT(INUMP(_i), _i, ARG2, s_fl_set_clippings);
  SFDEBUGMSG(s_fl_set_clippings);
  for (i=0; i<INUM(_i); i++)
    {
      ASSERT(ilength(CAR(_sl))==4, _sl, ARG1, s_fl_set_clippings);
      _r=CAR(_sl);
      _i1=CAR(_r); _r=CDR(_r);
      _i2=CAR(_r); _r=CDR(_r);
      _i3=CAR(_r); _r=CDR(_r);
      _i4=CAR(_r); 
      nfl_set_clipping(_i1, _i2, 
		       cons(_i3, 
			    cons(_i4, EOL)));
      _sl=CDR(_sl);
    }
  return UNSPECIFIED;
} /* fl_set_clippings */
SUBR_void__void(fl_unset_clipping);

/* initialize functions */
void s_init_xbasic_fct()
{
  MSUBR_0(fl_get_gc);
  MSUBR_2(fl_mode_capable);
  MSUBR_0(fl_default_win);
  MSUBR_0(fl_default_window);
  MSUBR_L(fl_rectangle);
  MSUBR_L(fl_rectbound);
  MSUBR_L(fl_roundrectangle);
  MSUBR_L(fl_polygon);
  MSUBR_3(fl_polybound);
  MSUBR_3(fl_lines);
  MSUBR_L(fl_line);
  MSUBR_3(fl_point);
  MSUBR_3(fl_points);
  MSUBR_2(fl_dashedlinestyle);
  MSUBR_1(fl_linewidth);
  MSUBR_1(fl_linestyle);
  MSUBR_1(fl_drawmode);
  MSUBR_0(fl_get_linewidth);
  MSUBR_0(fl_get_linestyle);
  MSUBR_0(fl_get_drawmode);
  MSUBR_L(fl_oval);
  MSUBR_L(fl_ovalbound);
  MSUBR_L(fl_ovalarc);
  MSUBR_L(fl_pieslice);
  MSUBR_2(fl_add_vertex);
  MSUBR_2(fl_add_float_vertex);
  MSUBR_0(fl_reset_vertex);
  MSUBR_0(fl_endline);
  MSUBR_0(fl_endpolygon);
  MSUBR_0(fl_endclosedline);
  MSUBR_2(fl_v2s);
  MSUBR_2(fl_v2i);
  MSUBR_2(fl_v2f);
  MSUBR_2(fl_v2d);
  MSUBR_L(fl_drw_frame);
  MSUBR_L(fl_drw_checkbox);
  MSUBR_2(fl_get_fontstruct);
  MSUBR_0(fl_get_mouse);
  MSUBR_2(fl_set_mouse);
  MSUBR_1(fl_get_win_mouse);
  MSUBR_1(fl_get_form_mouse);
  MSUBR_1(fl_win_to_form);
  MSUBR_3(fl_set_form_icon);
  MSUBR_1(fl_raise_form);
  MSUBR_1(fl_lower_form);
  MSUBR_2(fl_set_foreground);
  MSUBR_2(fl_set_background);
  MSUBR_1(fl_wincreate);
  MSUBR_1(fl_winshow);
  MSUBR_1(fl_winopen);
  MSUBR_1(fl_winhide);
  MSUBR_1(fl_winclose);
  MSUBR_1(fl_winset);
  MSUBR_2(fl_winreparent);
  MSUBR_1(fl_winfocus);
  MSUBR_0(fl_winget);
  MSUBR_3(fl_winresize);
  MSUBR_3(fl_winmove);
  MSUBR_L(fl_winreshape);
  MSUBR_3(fl_winicon);
  MSUBR_2(fl_winbackground);
  MSUBR_3(fl_winstepunit);
  MSUBR_1(fl_winisvalid);
  MSUBR_2(fl_wintitle);
  MSUBR_2(fl_winicontitle);
  MSUBR_2(fl_winposition);
  MSUBR_3(fl_winminsize);
  MSUBR_3(fl_winmaxsize);
  MSUBR_3(fl_winaspect);
  MSUBR_1(fl_reset_winconstraints);
  MSUBR_2(fl_winsize);
  MSUBR_2(fl_initial_winsize);
  MSUBR_1(fl_initial_winstate);
  MSUBR_d2(fl_create_colormap);
  MSUBR_L(fl_wingeometry);
  MSUBR_L(fl_initial_wingeometry);
  MSUBR_0(fl_pnoborder);
  MSUBR_0(fl_ptransient);
  MSUBR_1(fl_get_winsize);
  MSUBR_1(fl_get_winorigin);
  MSUBR_1(fl_get_wingeometry);
  MSUBR_1(fl_is_canvas);
  MSUBR_1(fl_objwin);
  MSUBR_1(fl_get_real_object_window);
  MSUBR_0(fl_xnextevent);
  MSUBR_0(fl_xpeekevent);
  MSUBR_1(fl_xeventsqueued);
  MSUBR_1(fl_xputbackevent);
  MSUBR_0(fl_last_event);
  MSUBR_2(fl_set_event_callback);
  MSUBR_2(fl_set_idle_callback);
  MSUBR_2(fl_addto_selected_xevent);
  MSUBR_2(fl_remove_selected_xevent);
  MSUBR_1(fl_set_idle_delta);
  MSUBR_L(fl_add_event_callback);
  MSUBR_2(fl_remove_event_callback);
  MSUBR_1(fl_activate_event_callbacks);
  MSUBR_dL(fl_print_xevent_name);
  MSUBR_1(metakey_down);
  MSUBR_1(shiftkey_down);
  MSUBR_1(controlkey_down);
  MSUBR_1(button_down);
  MSUBR_1(fl_initialize);
  MSUBR_0(fl_finish);
  MSUBR_dL(fl_get_resource);
  MSUBR_2(fl_set_resource);
  MSUBR_d2(fl_get_app_resources);
  MSUBR_2(fl_set_graphics_mode);
  MSUBR_1(fl_set_visualID);
  MSUBR_1(fl_keysym_pressed);
  MSUBR_1(fl_sbit);
  MSUBR_d2(fl_set_defaults);
  MSUBR_1(fl_set_tabstop);
  MSUBR_d0(fl_get_defaults);
  MSUBR_0(fl_get_visual_depth);
  MSUBR_1(fl_vclass_name);
  MSUBR_1(fl_vclass_val);
  MSUBR_2(fl_set_ul_property);
  MSUBR_L(fl_set_clipping);
  MSUBR_L(fl_set_gc_clipping);
  MSUBR_1(fl_unset_gc_clipping);
  MSUBR_2(fl_set_clippings);
  MSUBR_0(fl_unset_clipping);
  return;
}

/*
** EOF
*/
